<?php
/**
 * @version 1.1.0 $Id: photomapgallery.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

define('PHOTOMAP_VERSION', '1.4.0');
define('PHOTOMAP_RELEASE', 'rev.1');

if ( JFile::exists( $path = dirname(__FILE__) . DS . 'defines.php' ) ) {
	require_once($path);
} else {
	JError::raiseError( 404, 'PhotoMap Gallery Framework cannot find the defines file, located at : ' . $path );
}

if ( JFile::exists( $path = GALLERY_CONTROLLER ) ) {
	require_once($path);
} else {
	JError::raiseError( 404, 'Photomap Gallery Framework cannot find the generic controller file, located at : ' . $path );
}

require_once (JPATH_COMPONENT_SITE.DS.'classes'.DS.'photomapgallery.helper.php');
require_once (JPATH_COMPONENT_SITE.DS.'classes'.DS.'photomapgallery.categories.php');

// Set the table directory
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

//Set filepath
$params =& JComponentHelper::getParams('com_photomapgallery');
define('COM_PHOTOMAPGALLERY_FILEPATH',    JPATH_ROOT.DS.$params->get($path, 'components/com_photomapgallery/upload'));


if ( $controller = JRequest::getCmd('controller') ) {
	if ( JFile::exists( $path = GALLERY_CONTROLLERS . DS . $controller . '.php' ) ) {
		require_once($path);
	} else {
		JError::raiseError( 404, JText::_("PhotoMap Gallery Framework cannot find the specified controller '" . $controller . "' : unknown controller.") );
	}
}


if ( JFile::exists( $path = GALLERY_CLASSES . DS . 'util.php' ) ) {
	require_once($path);
} else {
	JError::raiseError( 404, JText::_("PhotoMap Gallery Framework cannot find the utility class file.") );
}

if ( JFile::exists( $path = GALLERY_CLASSES . DS . 'upload.php' ) ) {
	require_once($path);
} else {
	JError::raiseError( 404, JText::_("PhotoMap Gallery Framework cannot find the upload file.") );
}

global $gconf;
$gconf		= GUtil::config();

//Create the controller
$classname  = 'photomapgalleryController'.$controller;
$controller = new $classname( );

// Perform the Request task
$controller->execute( JRequest::getWord('task'));
$controller->redirect();
?>