<?php
/**
 * @version 1.1.0 $Id: upload.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );


function change_chmod($dir, $mode = 0777) {
	//check if chmod is necessary, otherwise return true  
	$fileperms= substr(decoct( fileperms($dir)),3);
	if ($fileperms >= decoct($mode)){
		return true;
	}
  
	static $ftpOptions;
	
	if(!isset($ftpOptions)) {
		// Initialize variables
		jimport('joomla.client.helper');
		$ftpOptions = JClientHelper::getCredentials('ftp');
	}

	if ($ftpOptions['enabled'] == 1) {
		// Connect the FTP client
		jimport('joomla.client.ftp');
		$ftp = &JFTP::getInstance(
			$ftpOptions['host'], $ftpOptions['port'], null,
			$ftpOptions['user'], $ftpOptions['pass']
		);
		// Translate path to FTP path
		$dir = JPath::clean(str_replace(JPATH_ROOT, $ftpOptions['root'], $dir), '/');
		$ftp->chmod($dir, $mode);
	} 
	return true;
}

function find_libraries() {
	$libraries = array();

	// Initialization - To allow Windows machine to do proper detection
	$shell_cmd = '';
	if ( substr( PHP_OS, 0, 3 ) == 'WIN' )
		$shell_cmd = getenv( "COMSPEC" ) . " /C ";
	unset($output);

	// Detect Imagemagick
	@exec( $shell_cmd . 'convert -version', $output, $status );
	if( !$status ) {
		if ( preg_match( "/imagemagick[ \t]+([0-9\.]+)/i", $output[0], $matches ) )
			$libraries['imagemagick'] = $matches[0];
	}

	// Detect Netpbm
	unset($output);
	@exec( $shell_cmd . 'jpegtopnm -version 2>&1', $output, $status );
	if ( !$status ) {
		if( preg_match( "/netpbm[ \t]+([0-9\.]+)/i", $output[0], $matches ) )
			$libraries['netpbm'] = $matches[0];
	}

	// Detect GD1/GD2
	$GDfuncList = get_extension_funcs('gd');

	ob_start();
	@phpinfo(INFO_MODULES);
	$output = ob_get_contents();
	ob_end_clean();
	$matches[1] = '';
	if ( preg_match( "/GD Version[ \t]*(<[^>]+>[ \t]*)+([^<>]+)/s", $output, $matches ) ) {
		$gdversion = $matches[2];
	}

	if ( $GDfuncList ) {
		if( trim($gdversion) == '1.6.2 or higher' ) {
			$libraries['gd1'] = $gdversion;
		} else {
			$libraries['gd2'] = $gdversion;
		}
	}
	/*if ( $GDfuncList ) {
		if( in_array('imagegd2',$GDfuncList) )
			$libraries['gd2'] = $gdversion;
		else
			$libraries['gd1'] = $gdversion;
	}*/

	return $libraries;
}


?>