<?php
/**
 * @version 1.1.0 $Id: util.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );
  

class GUtil {
	function introtext($text, $number) {
		$text = htmlspecialchars($text);
		if (strlen($text) > $number) {
			$pos = strpos($text, ' ', $number);
			if ((!$pos) || ($pos > $number)) {
				$pos = $number;
			}
	    	$text = substr($text, 0, $pos + 1) . "....";
	    	return $text;
		}else{
			return $text;
		}
	}

	function footer( )
	{
		echo '<div style="font-size: 11px; text-align:center">';
		echo JText::_('Powered by').' <a href="http://www.photoindochina.com/" target="_blank"><img style="vertical-align:middle;" src="'.$this->baseurl.'/components/com_photomapgallery/assets/images/photomap.png" alt="PhotoMap Gallery"/></a>';
		echo '</div>';
		echo '<div style="clear:both;padding-bottom:20px;"></div>' . "\n";
	}

	function autoreadmore( $item, $max_chars )
	{
  		if (strlen(strip_tags($item->description)) > $max_chars) {
			// First, remove all new lines
			$item->description = preg_replace("/\r\n|\r|\n/", "", $item->description);
			// Next, replace <br /> tags with \n
			$item->description = preg_replace("/<BR[^>]*>/i", "\n", $item->description);
			// Replace <p> tags with \n\n
			$item->description = preg_replace("/<P[^>]*>/i", "\n\n", $item->description);
			// Strip all tags
			$item->description = strip_tags($item->description);
			// Truncate
			$item->description = substr($item->description, 0, $max_chars);
			// Pop off the last word in case it got cut in the middle
			$item->description = preg_replace("/[.,!?:;]? [^ ]*$/", "", $item->description);
			// Add a few new lines to the end of the article, and ...
			$item->description = trim($item->description) . "...\n\n";
			// Replace \n with <br />
//			$item->description = str_replace("\n", "<br />", $item->description);

			echo $item->description;
		}
		else {
			echo $item->description;
		}
	}
	
	function config()
	{
		$db =& JFactory::getDBO();

		$sql = 'SELECT * FROM #__g_settings WHERE id = 1';
		$db->setQuery($sql);
		$config = $db->loadObject();

		return $config;
	}

	
	function showEXIF($itemid, $path) {
		require_once (JPATH_SITE.DS.'components'.DS.'com_photomapgallery'.DS.'lib'.DS.'exif.php');

		$exifvars = array(
		'EXIFMake'					=> array('IFD0',	'Make',					JText::_('Camera Maker'),			true,	52),
		'EXIFModel'					=> array('IFD0',	'Model',				JText::_('Camera Model'),			true,	52),
		'EXIFDescription'			=> array('IFD0',	'ImageDescription',		JText::_('Image Title'),			false,	52),
		'IPTCObjectName'			=> array('IPTC',	'ObjectName',			JText::_('Object name'),			false,	256),
		'IPTCImageHeadline'			=> array('IPTC',	'ImageHeadline',		JText::_('Image headline'),			false,	256),
		'IPTCImageCaption'			=> array('IPTC',	'ImageCaption',			JText::_('Image caption'),			false,	2000),
		'IPTCImageCaptionWriter'	=> array('IPTC',	'ImageCaptionWriter',	JText::_('Image caption writer'),	false,	32),
		'EXIFDateTime'				=> array('SubIFD',	'DateTime',				JText::_('Time Taken'),				true,	52),
		'EXIFDateTimeOriginal'		=> array('SubIFD',	'DateTimeOriginal',		JText::_('Original Time Taken'),	true,	52),
		'EXIFDateTimeDigitized'		=> array('SubIFD',	'DateTimeDigitized',	JText::_('Time Digitized'),			true,	52),
		'IPTCDateCreated'			=> array('IPTC',	'DateCreated',			JText::_('Date created'),			false,	8),
		'IPTCTimeCreated'			=> array('IPTC',	'TimeCreated',			JText::_('Time created'),			false,	11),
	'IPTCDigitizeDate' 					=> array('IPTC',	 'DigitizeDate',					JText::_('Digital Creation Date'),											false,			8),
	'IPTCDigitizeTime' 					=> array('IPTC',	 'DigitizeTime',					JText::_('Digital Creation Time'),											false,			11),
	'EXIFArtist'			      		=> array('IFD0',   'Artist', 								JText::_('Artist'), 	     					 										false,			52),
	'IPTCImageCredit'						=> array('IPTC',	 'ImageCredit',						JText::_('Image Credit'),															false,			32),
	'IPTCByLine' 								=> array('IPTC',	 'ByLine',								JText::_('ByLine'),																		false,			32),
	'IPTCByLineTitle' 					=> array('IPTC',	 'ByLineTitle',						JText::_('ByLine Title'),															false,			32),
	'IPTCSource'								=> array('IPTC',	 'Source',								JText::_('Image source'),															false,			32),
	'IPTCContact' 							=> array('IPTC',	 'Contact',								JText::_('Contact'),																		false,			128),
	'EXIFCopyright'			    		=> array('IFD0',   'Copyright', 						JText::_('Copyright Holder'), 			 										false,			128),
	'IPTCCopyright'							=> array('IPTC',	 'Copyright',							JText::_('Copyright Notice'),													false,			128),
	'EXIFExposureTime'      		=> array('SubIFD', 'ExposureTime',      		JText::_('Shutter Speed'),          										true,				52),
	'EXIFFNumber'           		=> array('SubIFD', 'FNumber',           		JText::_('Aperture'),               										true,				52),
	'EXIFISOSpeedRatings'   		=> array('SubIFD', 'ISOSpeedRatings',   		JText::_('ISO Sensitivity'),        										true,				52),
	'EXIFExposureBiasValue' 		=> array('SubIFD', 'ExposureBiasValue', 		JText::_('Exposure Compensation'), 										true,				52),
	'EXIFMeteringMode'      		=> array('SubIFD', 'MeteringMode',      		JText::_('Metering Mode'),         										true,				52),
	'EXIFFlash'             		=> array('SubIFD', 'Flash',             		JText::_('Flash Fired'),         											true,				52),
	'EXIFImageWidth'        		=> array('SubIFD', 'ExifImageWidth',    		JText::_('Original Width'),														false,			52),
	'EXIFImageHeight'       		=> array('SubIFD', 'ExifImageHeight',   		JText::_('Original Height'),      											false,			52),
	'EXIFOrientation'       		=> array('IFD0',   'Orientation',       		JText::_('Orientation'),            										false,			52),
	'EXIFContrast'          		=> array('SubIFD', 'Contrast',          		JText::_('Contrast Setting'),      										false,			52),
	'EXIFSharpness'         		=> array('SubIFD', 'Sharpness',         		JText::_('Sharpness Setting'),     										false,			52),
	'EXIFSaturation'        		=> array('SubIFD', 'Saturation',        		JText::_('Saturation Setting'),    										false,			52),
	'EXIFWhiteBalance'					=> array('SubIFD', 'WhiteBalance',					JText::_('White Balance'),															false,			52),
	'EXIFSubjectDistance'				=> array('SubIFD', 'SubjectDistance',				JText::_('Subject Distance'),													false,			52),
	'EXIFFocalLength'       		=> array('SubIFD', 'FocalLength',       		JText::_('Focal Length'),           										true,				52),
	'EXIFLensType'       				=> array('SubIFD', 'LensType',       				JText::_('Lens Type'),   	        										false,			52),
	'EXIFLensInfo'       				=> array('SubIFD', 'LensInfo',      		 		JText::_('Lens Info'),           											false,			52),
	'EXIFFocalLengthIn35mmFilm'	=> array('SubIFD', 'FocalLengthIn35mmFilm',	JText::_('Focal Length Equivalent in 35mm Film'),			false,			52),
	'IPTCCity' 									=> array('IPTC',	 'City',									JText::_('City'),																			false,			32),
	'IPTCSubLocation' 					=> array('IPTC',	 'SubLocation',						JText::_('Sublocation'),																false,			32),
	'IPTCState' 								=> array('IPTC',	 'State',									JText::_('Province/State'),														false,			32),
	'IPTCLocationCode' 					=> array('IPTC',	 'LocationCode',					JText::_('Country/Primary Location Code'),							false,			3),
	'IPTCLocationName' 					=> array('IPTC',	 'LocationName',					JText::_('Country/Primary Location Name'),							false,			64),
	'EXIFGPSLatitude'       		=> array('GPS',    'Latitude',          		JText::_('Latitude'),              										false,			52),
	'EXIFGPSLatitudeRef'    		=> array('GPS',    'Latitude Reference',		JText::_('Latitude Reference'),    										false,			52),
	'EXIFGPSLongitude'      		=> array('GPS',    'Longitude',         		JText::_('Longitude'),             										false,			52),
	'EXIFGPSLongitudeRef'   		=> array('GPS',    'Longitude Reference',		JText::_('Longitude Reference'),  											false,			52),
	'EXIFGPSAltitude'       		=> array('GPS',    'Altitude',          		JText::_('Altitude'),              										false,			52),
	'EXIFGPSAltitudeRef'    		=> array('GPS',    'Altitude Reference',		JText::_('Altitude Reference'),  											false,			52),
	'IPTCOriginatingProgram'		=> array('IPTC',	 'OriginatingProgram',		JText::_('Originating Program '),											false,			32),
	'IPTCProgramVersion'			 	=> array('IPTC',	 'ProgramVersion',				JText::_('Program version'),														false,			10)
	);
		
		$exif_raw = read_exif_data_raw($path, false);

		$exif_data = array();
		if (isset($exif_raw['ValidEXIFData'])) {

			foreach($exifvars as $field => $exifvar) {
				if (isset($exif_raw[$exifvar[0]][$exifvar[1]])) {
					$exif = trim($exif_raw[$exifvar[0]][$exifvar[1]],1);
					$exif_data[$field] = $exif;
				} else if (isset($exif_raw[$exifvar[0]]['MakerNote'][$exifvar[1]])) {
					$exif = trim($exif_raw[$exifvar[0]]['MakerNote'][$exifvar[1]],1);
					$exif_data[$field] = $exif;
				}
			}
		}
/*		
		$db =& JFactory::getDBO();

		$query = 'UPDATE #__galleryitems SET exif = ' . $exif_data. ' WHERE id = '.$itemid;
		$db->setQuery($query);
		$db->query();
*/
		return $exif_data;
 	}
	
	function getXML($xmlfile, $element_name) {
		jimport('domit.xml_domit_lite_include');
		$xmlDoc = & new DOMIT_Lite_Document();
		$xmlDoc->resolveErrors(true);
		if (!@$xmlDoc->loadXML($xmlfile)) {
			return "Could not connect";
		}
		$element = & $xmlDoc->documentElement;
		$element = & $xmlDoc->getElementsByPath($element_name, 1);
		$result = $element ? $element->getText() : '';
		return $result;
	}
}
?>