<?php
/**
 * @version 1.1.0 $Id: controller.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * PhotoMapGallery Component Controller
 *
 * @package Joomla
 * @subpackage PhotoMapGallery
 * @since 1.0
 */
class photomapgalleryController extends JController
{
	function __construct( $config = array() )
	{
		// Require the generic photomapgalleryView
		if ( JFile::exists( $path = GALLERY_VIEW ) ) {
			require_once($path);
		} else {
			JError::raiseError( 404, get_class($this) . '::_construct() : cannot find PhotoMap Gallery generic view, located at: ' . $path );
		}
		
		parent::__construct($config);

		// Register Extra task
		$this->registerTask( 'apply', 	'save' );
		$this->registerTask( 'applycss', 	'savecss' );
	}

	/**
	 * Display the view
	 */
	function display( $cachable = false )
	{
		// Set a default view if none exists
		if ( !JRequest::getCmd('view') ) {
			JRequest::setVar( 'view', 'photomapgallery' );
		}
	
		parent::display($cachable);
	}

	function getName()
	{
		$name = $this->_name;

		if ( empty( $name ) )
		{
			$r = null;
			if (!preg_match('/Controller((controller)*(.*(controller)?.*))$/i', get_class($this), $r)) {
				JError::raiseError( 500, get_class($this) . "::getName() : Cannot get or parse class name." );
			}
			if (strpos($r[3], "controller"))
			{
				JError::raiseWarning('SOME_ERROR_CODE', get_class($this) . "::getName() : Your classname contains the substring 'controller'. " . "This causes problems when extracting the classname from the name of your objects photomapgallery controller. " . "Avoid Object names with the substring 'controller'." );
			}
			$name = strtolower( $r[3] );
		}

		return $name;
	}
	
	function &getView( $name = '', $type = '', $prefix = 'photomapgalleryView', $config = array() )
	{
		if ( empty($type) ) {
			$document	=& JFactory::getDocument();
			$type		= $document->getType();
		}
		
		if ( empty($prefix) ) {
			$prefix = 'photomapgalleryView';
		}
		
		$view =& parent::getView( $name, $type, $prefix, $config );
		
		return $view;
	}
	
	function &getModel( $name = '', $prefix = 'photomapgalleryModel', $config = array() )
	{
		$model =& parent::getModel( $name, $prefix, $config );
		
		return $model;
	}
}
?>