<?php
/**
 * @version 1.1.0 $Id: categories.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * PhotoMap Gallery Component Categories Controller
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class photomapgalleryControllerCategories extends photomapgalleryController
{
	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra task
		$this->registerTask( 'add',		 		'edit' );
		$this->registerTask( 'apply', 			'save' );
		$this->registerTask( 'accesspublic', 	'access' );
		$this->registerTask( 'accessregistered','access' );
		$this->registerTask( 'accessspecial', 	'access' );
	}

	/**
	 * Logic to save a category
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function save()
	{
		jimport('joomla.filesystem.folder');
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$task			= JRequest::getVar('task');
		$post 			= JRequest::get('post');


		$model = $this->getModel('category');
		
		$cid = JRequest::getVar( 'id', array(0), 'post', 'array' );

		$db 	=& JFactory::getDBO();
		$query = 'SELECT c.id, c.directory'
					. ' FROM #__g_categories AS c'
					. ' WHERE c.id IN ('. $cid[0] .')';
					
		$db->setQuery($query);
		$result = $db->loadObject();
		
		$old_dir = $result->directory;

		if ( $model->store($post) ) {

			switch ($task)
			{
				case 'apply' :
					$link = 'index.php?option=com_photomapgallery&view=category&cid[]='.(int) $model->get('id');
					break;

				default :
					$link = 'index.php?option=com_photomapgallery&view=categories';
					break;
			}
			
			if ($result->id)
				$directory = 'gallery-'.$post['userid'].'-'.$result->id;
			else
				$directory = 'gallery-'.$post['userid'].'-'.$model->get('id');

			$query = 'UPDATE #__g_categories SET `directory` = ' . $db->quote($directory). ' WHERE `id` = '.$model->get('id');
			$db->setQuery($query);
			if(!$db->query()) {
				JError::raiseWarning(500, JText::_( $db->getErrorMsg() ) );
				return false;
			}
		
			if ($cid[0] != $model->get('id')) {
				$dir = GALLERY_IMAGES_ORIGINAL.DS.$directory.DS;
	
				if (!file_exists($dir)) {
					mkdir($dir, 0777);
				}
				
				$album_dir = GALLERY_IMAGES_ALBUM.DS.$directory.DS;
			
				if (!file_exists($album_dir)) {
					mkdir($album_dir, 0777);
				}
				
				$resized_dir = GALLERY_IMAGES_RESIZED.DS.$directory.DS;
			
				if (!file_exists($resized_dir)) {
					mkdir($resized_dir, 0777);
				}
				
				$thumb_dir = GALLERY_IMAGES_THUMBNAIL.DS.$directory.DS;
			
				if (!file_exists($thumb_dir)) {
					mkdir($thumb_dir, 0777);
				}
			}
			else {
				rename(GALLERY_IMAGES_ORIGINAL.DS.$old_dir, GALLERY_IMAGES_ORIGINAL.DS.$directory);
				rename(GALLERY_IMAGES_ALBUM.DS.$old_dir, GALLERY_IMAGES_ALBUM.DS.$directory);
				rename(GALLERY_IMAGES_RESIZED.DS.$old_dir, GALLERY_IMAGES_RESIZED.DS.$directory);
				rename(GALLERY_IMAGES_THUMBNAIL.DS.$old_dir, GALLERY_IMAGES_THUMBNAIL.DS.$directory);
//				$msg .= JText::_( 'CATEGORY NAME CHANGED' );
			}
		
			$msg .= JText::_( 'CATEGORY SAVED' );
			
			//Take care of access levels and state
			$categoriesmodel = & $this->getModel('categories');
			$categoriesmodel->access($model->get('id'), $model->get('access'));
			
			$pubid = array();
			$pubid[] = $model->get('id');
			if($model->get('published') == 1) {
				$categoriesmodel->publish($pubid, 1);
			} else {
				$categoriesmodel->publish($pubid, 0);
			}
			
			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();

		} else {

			$msg 	= JText::_( 'ERROR SAVING CATEGORY' );
			$link 	= 'index.php?option=com_photomapgallery&view=category';
		}

		$model->checkin();

		$this->setRedirect($link, $msg);
	}

	/**
	 * Logic to publish categories
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function publish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$cid 	= JRequest::getVar( 'cid', array(0), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			$msg = '';
			JError::raiseWarning(500, JText::_( 'SELECT ITEM PUBLISH' ) );
		} else {

			$model = $this->getModel('categories');

			if(!$model->publish($cid, 1)) {
				JError::raiseError(500, $model->getError());
			}

			$msg 	= JText::_( 'CATEGORY PUBLISHED');
		
			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=categories', $msg );
	}

	/**
	 * Logic to unpublish categories
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function unpublish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$cid 	= JRequest::getVar( 'cid', array(0), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			$msg = '';
			JError::raiseWarning(500, JText::_( 'SELECT ITEM UNPUBLISH' ) );
		} else {

			$model = $this->getModel('categories');

			if(!$model->publish($cid, 0)) {
				JError::raiseError(500, $model->getError());
			}

			$msg 	= JText::_( 'CATEGORY UNPUBLISHED');
		
			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}
		
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=categories', $msg );
	}

	/**
	 * Logic to orderup a category
	 *
	 * @access public
	 * @return void;
	 * @since 1.0
	 */
	function orderup()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$model = $this->getModel('categories');
		$model->move(-1);
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();
		
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=categories');
	}

	/**
	 * Logic to orderdown a category
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function orderdown()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$model = $this->getModel('categories');
		$model->move(1);
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=categories');
	}

	/**
	 * Logic to mass ordering categories
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function saveorder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$cid 	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(0), 'post', 'array' );

		$model = $this->getModel('categories');
		if(!$model->saveorder($cid, $order)) {
			$msg = '';
			JError::raiseWarning(500, $model->getError());
		}
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();

		$msg = JText::_('NEW ORDERING SAVED');
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=categories', $msg );
	}

	/**
	 * Logic to delete categories
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );

		if (!is_array( $cid ) || count( $cid ) < 1) {
			$msg = '';
			JError::raiseWarning(500, JText::_( 'SELECT ITEM DELETE' ) );
		} else {

			$model = $this->getModel('categories');

			$msg = $model->delete($cid);

			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}
		
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=categories', $msg );
	}

	/**
	 * logic for cancel an action
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function cancel()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$category = & JTable::getInstance('g_categories', '');
		$category->bind(JRequest::get('post'));
		$category->checkin();

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=categories' );
	}

	/**
	 * Logic to set the category access level
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function access( )
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$id			= (int)$cid[0];
		$task		= JRequest::getVar( 'task' );

		if ($task == 'accesspublic') {
			$access = 0;
		} elseif ($task == 'accessregistered') {
			$access = 1;
		} else {
			$access = 2;
		}

		$model = $this->getModel('categories');
		
		if(!$model->access( $id, $access )) {
			JError::raiseError(500, $model->getError());
		} else {
			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}
		
		$this->setRedirect('index.php?option=com_photomapgallery&view=categories' );
	}

	/**
	 * Logic to create the view for the edit categoryscreen
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function edit( )
	{	
		// Check for request forgeries
		//JRequest::checkToken() or jexit( 'Invalid Token' );
		
		JRequest::setVar( 'view', 'category' );
		JRequest::setVar( 'hidemainmenu', 1 );

		$model 	= $this->getModel('category');
		$user	=& JFactory::getUser();

		// Error if checkedout by another administrator
		if ($model->isCheckedOut( $user->get('id') )) {
			$this->setRedirect( 'index.php?option=com_photomapgallery&view=categories', JText::_( 'EDITED BY ANOTHER ADMIN' ) );
		}

		$model->checkout( $user->get('id') );
		
		parent::display();
	}
}