<?php
/**
 * @version 1.1.0 $Id: filemanager.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');


class photomapgalleryControllerFilemanager extends photomapgalleryController
{
	function __construct()
	{
		parent::__construct();
		
		$this->registerTask( 'batchupload', 'batchupload' );
	}

	function getmicrotime() {
		list($usec, $sec) = explode( " ", microtime());
		return ((float) $usec + (float) $sec);
	}
	
	function batchupload()
	{
		global $mainframe;
		$config = GUtil::config();

		$db 	= & JFactory::getDBO();
		$user 	= & JFactory::getUser();
		$debugoutput='';

		if (JFolder::exists(GALLERY_TEMP)) 
		{
			$temp_dir = GALLERY_TEMP;
			
			//make temp path writeable if it is not, workaround for servers with wwwrun-problem
			if(!is_writeable($temp_dir))
			{
				change_chmod($temp_dir, 0777);
				$permissions_changed = true;
			}
		} 
		else 
		{
			$mainframe->redirect('index.php?option=com_photomapgallery&view=filemanager', JText::_('GALLERY_ERROR_TEMP_MISSING'), 'error');
		}
		
		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );
		
		$post = JRequest::get( 'post' );
		$cid  = JRequest::getVar('cid', 0);
		$title = JRequest::getVar( 'title' );
		$startno = JRequest::getVar( 'startnumber' );
		$description = JRequest::getVar( 'description' );
	
		$this->addModelPath( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_photomapgallery' . DS . 'models' );
		$model = $this->getModel('galleryitem', 'photomapgalleryModel');
		
		$query = 'SELECT c.id, c.directory'
					. ' FROM #__g_categories AS c'
					. ' WHERE c.id IN ('. $cid[0] .')';
					
		$db->setQuery($query);
		$result = $db->loadObject();
		
		$old_dir = $result->directory;
		
		if ($result->id)
			$directory = 'gallery-'.$user->id.'-'.$result->id;
		else
			$directory = 'gallery-'.$$user->id.'-'.$model->get('id');
				

		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.archive');
		require_once (GALLERY_ADMINISTRATOR.DS.'lib'.DS.'class.upload.php');
		require_once (JPATH_ADMINISTRATOR . DS . 'includes' . DS . 'pcl' . DS . 'pclzip.lib.php');

		if (isset($_FILES['zippack'])){
			$zipfile = $_FILES['zippack'];
		}
		else {
			$mainframe->redirect('index.php?option=com_photomapgallery&view=filemanager', JText::_('GALLERY_CANNOT_FIND_FILE'), 'error');
		}
		
		//check existence of uploaded zip
		if (!JFile::exists($_FILES['zippack']['tmp_name'])) 
		{
			$mainframe->redirect('index.php?option=com_photomapgallery&view=filemanager', JText::_('GALLERY_ERROR_FILE_NOT_UPLOADED'), 'error');
		}

		$zipfile = new PclZip($_FILES['zippack']['tmp_name']);
	  
		$ziplist = $zipfile->extract(PCLZIP_OPT_PATH, $temp_dir,
								PCLZIP_OPT_REMOVE_ALL_PATH,
								PCLZIP_OPT_BY_PREG, "/^(.*).((jpg)|(JPG)|(jpeg)|(JPEG)|(jpe)|(JPE)|(png)|(PNG)|(gif)|(GIF))$/");

		//check error code of extraction
		if ($zipfile->error_code != 1) 
		{
			$ziperror = str_replace("'","",$zipfile->errorInfo());
			$msg = JText::_( 'ZIPFILE ERROR' );
			$this->setRedirect('index.php?option=com_photomapgallery&view=filemanager', $msg);
		}
	
	  	$sizeofzip = sizeof($ziplist);

		$ziplist = array_reverse($ziplist);

		for ($i = 0; $i < $sizeofzip; $i++) {
			$filepathinfos = pathinfo($ziplist[$i]['filename']);
			$origfilename = $filepathinfos["basename"];

			$handle = new Upload($temp_dir.DS.$origfilename);

			if ($handle->uploaded) {

				$original_dir =  GALLERY_IMAGES_ORIGINAL.DS.$directory.DS;
				$album_dir =  GALLERY_IMAGES_ALBUM.DS.$directory.DS;
				$resize_dir =  GALLERY_IMAGES_RESIZED.DS.$directory.DS;
				$thumb_dir =  GALLERY_IMAGES_THUMBNAIL.DS.$directory.DS;
				
				if (!file_exists($original_dir)) {
					mkdir($original_dir, 0777);
				}
				if (!file_exists($album_dir)) {
					mkdir($album_dir, 0777);
				}
				if (!file_exists($resize_dir)) {
					mkdir($resize_dir, 0777);
				}
				if (!file_exists($thumb_dir)) {
					mkdir($thumb_dir, 0777);
				}

				$handle->jpeg_quality = 100;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;
				$handle->Process($original_dir);

				$post['filename'] = $handle->file_dst_name;	
				$imagewidth = $handle->image_dst_x;
				$imageheight = $handle->image_dst_y;
				$post['imagewidth'] = $imagewidth;
				$post['imageheight'] = $imageheight;
				
				$handle->image_resize = true;
				if ($imageheight < $imagewidth) {
					$handle->image_ratio_y = true;
					$handle->image_x = $config->width;
				} else {
					$handle->image_ratio_x = true;
					$handle->image_y = $config->width;
				}
				$handle->jpeg_quality = 85;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;

				$handle->Process($album_dir);
				
				$handle->image_resize = true;
				if ($imageheight < $imagewidth) {
					$handle->image_ratio_y = true;
					$handle->image_x = $config->resizewidth;
				} else {
					$handle->image_ratio_x = true;
					$handle->image_y = $config->resizewidth;
				}
				$handle->jpeg_quality = 85;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;
				
				$handle->Process($resize_dir);
				
				$handle->image_resize = true;
				
//				if (JRequest::getVar( 'thumbuploadmethod' ) == 1) {
					$handle->image_ratio_crop = true;
					$handle->image_y = 50;
					$handle->image_x = 50;
/*				} else {
					if ($imageheight < $imagewidth) {
						$handle->image_ratio_y = true;
						$handle->image_x = $config->thumbwidth;
					} else {
						$handle->image_ratio_x = true;
						$handle->image_y = $config->thumbwidth;
					}
				} */
				$handle->jpeg_quality = 85;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;
				
				$handle->Process($thumb_dir);
				
				$handle->Clean();
			
				if (!$startno)
					$startno = 0;
				$no = $startno + $i; 
				$post['cid'] = $cid[0];
	
				$post['title'] = $title . '-' . $no;
				$post['created'] = mktime( );
				$post['created_by'] = $user->username;
				$post['state'] = 1;
			}
		
			if ( $model->store($post) ) {
				$cache = &JFactory::getCache('com_photomapgallery');
				$cache->clean();
				$msg = JText::_( 'ZIP FILE SAVED' );
				$link 	= 'index.php?option=com_photomapgallery&view=filemanager';
			} else {
				$msg = JText::_( 'ERROR SAVING ZIP FILE' );
				JError::raiseError( 500, $model->getError() );
				$link 	= 'index.php?option=com_photomapgallery&view=galleryitems';
			}
			
			$model->checkin();
		
			$this->setRedirect($link, $msg);
		}
	}

	/**
	 * logic for cancel an action
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function cancel()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$file = & JTable::getInstance('g_files', '');
		$file->bind(JRequest::get('post'));
		$file->checkin();

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=filemanager' );
	}
}