<?php
/**
 * @version 1.1.0 $Id: galleryitems.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');


class photomapgalleryControllerGalleryItems extends photomapgalleryController
{
	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra task
		$this->registerTask( 'add', 'edit' );
		$this->registerTask( 'apply', 'save' );
	}

	/**
	 * Logic to save an item
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function save()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$config = & GUtil::config();
		
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.archive');
		require_once (GALLERY_ADMINISTRATOR.DS.'lib'.DS.'class.upload.php');
		
		$task = JRequest::getVar('task');
		$user = & JFactory::getUser();
		$post = JRequest::get( 'post' );
		
		$model = $this->getModel('galleryitem');

		if (isset($_FILES['file_upload'])){
			$handle = new Upload($_FILES['file_upload']);

			if ($handle->uploaded) {
				$cid = JRequest::getVar('cid', 0);
		
				$db =& JFactory::getDBO();
		
				$query = 'SELECT c.directory, c.userid'
							. ' FROM #__g_categories AS c'
							. ' WHERE c.id = '. $cid[0];
							
				$db->setQuery($query);
				$cat = $db->loadObject();
			
				$directory = $cat->directory;

				$dir =  GALLERY_IMAGES_ORIGINAL.DS.$directory.DS;
		
				if (!file_exists($dir)) {
					mkdir($dir, 0777);
				}

				$handle->jpeg_quality = 100;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;
				$width = $handle->image_src_x;
				$height = $handle->image_src_y;
				$handle->Process($dir);

				$post['filename'] = $handle->file_dst_name;	

				// resized image
				$album_dir =  GALLERY_IMAGES_ALBUM.DS.$directory.DS;
	
				if (!file_exists($album_dir)) {
					mkdir($album_dir, 0777);
				}
		
				$handle->image_resize = true;
				if ($height < $width) {
					$handle->image_ratio_y = true;
					$handle->image_x = $config->width;
				} else {
					$handle->image_ratio_x = true;
					$handle->image_y = $config->width;
				}
				$handle->jpeg_quality = 85;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;

				$handle->Process($album_dir);

				$imagewidth = $handle->image_dst_x;
				$imageheight = $handle->image_dst_y;
				$post['imagewidth'] = $imagewidth;
				$post['imageheight'] = $imageheight;
				
				// resized image
				$resize_dir =  GALLERY_IMAGES_RESIZED.DS.$directory.DS;
	
				if (!file_exists($resize_dir)) {
					mkdir($resize_dir, 0777);
				}
		
				$handle->image_resize = true;
				if ($height < $width) {
					$handle->image_ratio_y = true;
					$handle->image_x = $config->resizewidth;
				} else {
					$handle->image_ratio_x = true;
					$handle->image_y = $config->resizewidth;
				}
				$handle->jpeg_quality = 85;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;
				
				$handle->Process($resize_dir);
				
				// thumb image
				$thumb_dir =  GALLERY_IMAGES_THUMBNAIL.DS.$directory.DS;
	
				if (!file_exists($thumb_dir)) {
					mkdir($thumb_dir, 0777);
				}
		
				$handle->image_resize = true;
				
				if ($config->uploadmethod == 1) {
					$handle->image_ratio_crop = true;
					$handle->image_y = 50;
					$handle->image_x = 50;
				} else {
					if ($height < $width) {
						$handle->image_ratio_y = true;
						$handle->image_x = $config->thumbwidth;
					} else {
						$handle->image_ratio_x = true;
						$handle->image_y = $config->thumbwidth;
					}
				}
				$handle->jpeg_quality = 85;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;
				
				$handle->Process($thumb_dir);
				
				$handle->Clean();
			/*	
				if (JFile::exists($dir.$data->filename)) {
					JFile::delete($dir.$data->filename);
				}
				
				if (JFile::exists($album_dir.$data->filename)) {
					JFile::delete($album_dir.$data->filename);
				}
				
				if (JFile::exists($resize_dir.$data->filename)) {
					JFile::delete($resize_dir.$data->filename);
				}
				
				if (JFile::exists($thumb_dir.$data->filename)) {
					JFile::delete($thumb_dir.$data->filename);
				} */
			}
		}

		if ( $model->store($post) ) {

			switch ($task)
			{
				case 'apply' :
					$link = 'index.php?option=com_photomapgallery&view=galleryitem&cid[]='.(int) $model->get('id');
					break;

				default :
					$link = 'index.php?option=com_photomapgallery&view=galleryitems';
					break;
			}
			$msg = JText::_( 'ITEM SAVED' );

			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();

		} else {
			$msg = JText::_( 'ERROR SAVING ITEM' );
			JError::raiseError( 500, $model->getError() );
			$link 	= 'index.php?option=com_photomapgallery&view=galleryitem';
		}
		
		$model->checkin();
		
		$this->setRedirect($link, $msg);
	}

	/**
	 * Logic to orderup an item
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function orderup()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$model = $this->getModel('galleryitems');
		$model->move(-1);

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=galleryitems');
	}

	/**
	 * Logic to orderdown an item
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function orderdown()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$model = $this->getModel('galleryitems');
		$model->move(1);

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=galleryitems');
	}

	/**
	 * Logic to mass ordering items
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function saveorder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$cid 	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(0), 'post', 'array' );

		$model = $this->getModel('galleryitems');
		if(!$model->saveorder($cid, $order)) {
			$msg = '';
			JError::raiseError(500, $model->getError());
		} else {
			$msg = JText::_( 'NEW ORDERING SAVED' );
		}

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=galleryitems', $msg );
	}

	function publish() {

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'SELECT ITEM PUBLISH' ) );
		}

		$model = $this->getModel('galleryitems');
		if(!$model->publish($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=galleryitems' );
	}

	function unpublish() {

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'SELECT ITEM UNPUBLISH' ) );
		}

		$model = $this->getModel('galleryitems');
		if(!$model->unpublish($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=galleryitems' );
	}
	
	/**
	 * Logic to delete items
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		
		if (!is_array( $cid ) || count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'SELECT ITEM DELETE' ) );
		}

		$model = $this->getModel('galleryitems');

		if(!$model->delete($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
			$msg = JText::_( 'Error Deleting PhotoMap gallery' );
		} else {
			$total 	= count( $cid );
			$db 	=& JFactory::getDBO();

			$msg 	= $total.' '.JText::_($directory);

			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=galleryitems', $msg );
	}

	/**
	 * logic for cancel an action
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function cancel()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$item = & JTable::getInstance('g_galleryitems', '');
		$item->bind(JRequest::get('post'));
		$item->checkin();

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=galleryitems' );
	}

	/**
	 * Logic to create the view for the edit gallery item
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function edit( )
	{		
		JRequest::setVar( 'view', 'galleryitem' );
		JRequest::setVar( 'hidemainmenu', 1 );

		$model 	= $this->getModel('galleryitem');
		$user	=& JFactory::getUser();

		// Error if checkedout by another administrator
		if ($model->isCheckedOut( $user->get('id') )) {
			$this->setRedirect( 'index.php?option=com_photomapgallery&view=galleryitems', JText::_( 'EDITED BY ANOTHER ADMIN' ) );
		}

		$model->checkout( $user->get('id') );

		parent::display();
	}

	/**
	 * Method to reset hits
	 * 
	 * @since 1.0
	 */
	function resethits()
	{
		$id		= JRequest::getInt( 'id', 0 );
		$model = $this->getModel('galleryitem');

		$model->resetHits($id);
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();

		echo 0;
	}

	/**
	 * Method to reset votes
	 * 
	 * @since 1.0
	 */
	function resetvotes()
	{
		$id		= JRequest::getInt( 'id', 0 );
		$model = $this->getModel('galleryitem');

		$model->resetVotes($id);
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();
		
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=galleryitem' );
	}

	/**
	 * Method to fetch the votes
	 * 
	 * @since 1.0
	 */
	function getvotes()
	{
		$id 	= JRequest::getInt('id', 0);
		$model 	= $this->getModel('galleryitem');
		$votes 	= $model->getvotes($id);

		if ($votes) {
			echo '+ '.(int)$votes[0]->rate.' | - '.(int)$votes[0]->rate_sum;
		} else {
			echo '+ 0 | - 0';
		}
	}

	/**
	 * Method to get hits
	 * 
	 * @since 1.0
	 */
	function gethits()
	{
		$id 	= JRequest::getInt('id', 0);
		$model 	= $this->getModel('galleryitem');
		$hits 	= $model->gethits($id);

		if ($hits) {
			echo $hits;
		} else {
			echo 0;
		}
	}
	
	function gettags()
	{
		$id 	= JRequest::getInt('id', 0);
		$model 	= $this->getModel('galleryitem');
		$tags 	= $model->gettags();

		$used = null;

		if ($id) {
			$used 	= $model->getusedtags($id);
		}
		if(!is_array($used)){
			$used = array();
		}

		$rsp = '<div class="tagbox">';
		$n = count($tags);
		for( $i = 0, $n; $i < $n; $i++ ){
			$tag = $tags[$i];

			if( ( $i % 5 ) == 0 ){
				if( $i != 0 ){
					$rsp .= '</div>';
				}
				$rsp .=  '<div class="tagline">';
			}
			$rsp .=  '<span class="tag"><span class="tagidbox"><input type="checkbox" name="tag[]" value="'.$tag->id.'"' . (in_array($tag->id, $used) ? 'checked="checked"' : '') . ' /></span>'.$tag->name.'</span>';
		}
		$rsp .= '</div>';
		$rsp .= '</div>';
		$rsp .= '<div class="clear"></div>';
		$rsp .= '<div class="addtag">';
		$rsp .= '<label for="addtags">'.JText::_('ADD TAG').'</label>';
		$rsp .= '<input type="text" id="tagname" class="inputbox" size="30" />';
		$rsp .=	'<input type="button" class="button" value="'.JText::_('ADD').'" onclick="addtag()" />';
		$rsp .= '</div>';

		echo $rsp;
	}
}