<?php
/**
 * @version 1.1.0 $Id: settings.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');


class photomapgalleryControllerSettings extends photomapgalleryController
{
	/**
	 * Constructor
	 *
	 * @access public
	 * @return void
	 * @since 0.9
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra task
		$this->registerTask( 'apply', 		'save' );
	}

	/**
	 * logic for cancel an action
	 *
	 * @access public
	 * @return void
	 * @since 0.9
	 */
	function cancel()
	{
		global $option;

		$model = $this->getModel('settings');

		$model->checkin();

		$this->setRedirect( 'index.php?option='.$option.'&view=photomapgallery' );
	}

	/**
	 * logic to create the edit venue view
	 *
	 * @access public
	 * @return void
	 * @since 0.9
	 */
	function edit( )
	{
		JRequest::setVar( 'view', 'settings' );

		parent::display();

		$model = $this->getModel('settings');

		$model->checkout();
	}

	/**
	 * saves the venue in the database
	 *
	 * @access public
	 * @return void
	 * @since 0.9
	 */
	function save()
	{
		// Check for request forgeries
		JRequest::checkToken() or die( 'Invalid Token' );

		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.archive');
		require_once (GALLERY_ADMINISTRATOR.DS.'lib'.DS.'class.upload.php');
		
		// Sanitize
		$task	= JRequest::getVar('task');
		$post 	= JRequest::get( 'post' );
		$post['introdescription'] = JRequest::getVar('introdescription', '', 'POST', 'string', JREQUEST_ALLOWRAW);

		//get model
		$model 	= $this->getModel('settings');

		if (isset($_FILES['file_upload'])){
			$typeimg = $_FILES['file_upload']['type'];
			if (!empty($typeimg)) {	
				if($typeimg == 'image/jpeg'){$ext='.jpg';}else{$ext= '.'.substr($typeimg, strlen($typeimg) - 3); }
				$filename = 'logoimage'.$ext;
				$post['logoimage'] = $filename;		
			}
			
			$handle = new Upload($_FILES['file_upload']);
			
			if ($handle->uploaded) {

				$dir =  GALLERY_ASSETS_IMAGES.DS;
		
				if (!file_exists($dir)) {
					mkdir($dir, 0777);
				}

				$handle->jpeg_quality = 100;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = 'logoimage';
				$width = $handle->image_src_x;
				$height = $handle->image_src_y;
				$handle->Process($dir);
				
				$imagewidth = $handle->image_dst_x;
				$imageheight = $handle->image_dst_y;
				$post['logowidth'] = $imagewidth;
				$post['logoheight'] = $imageheight;

				$handle->Clean();
			}
		}
		
		if ($model->store($post)) {
			$msg	= JText::_( 'SETTINGS SAVE');
		} else {
			$msg	= JText::_( 'SAVE SETTINGS FAILED');
		}

		switch ($task)
		{
			case 'apply':
				$link = 'index.php?option=com_photomapgallery&controller=settings&task=edit';
				break;

			default:
				$link = 'index.php?option=com_photomapgallery&view=photomapgallery';
				break;
		}
		$model->checkin();

		$this->setRedirect( $link, $msg );
	}
}
?>