<?php
/**
 * @version 1.1.0 $Id: select.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


require_once ( JPATH_LIBRARIES . DS . 'joomla' . DS . 'html' . DS . 'html' . DS . 'select.php' );

class photomapgallerySelect extends JHTMLSelect
{
	/**
	* Generates an HTML radio list
	* 
	* Overloads Joomla's one to unsure id attribute only contains valid characters
	*
	* @param array An array of objects
	* @param string The value of the HTML name attribute
	* @param string Additional HTML attributes for the <select> tag
	* @param mixed The key that is selected
	* @param string The name of the object variable for the option value
	* @param string The name of the object variable for the option text
	* @returns string HTML for the select list
	*/
	function radiolist( $arr, $name, $attribs = null, $key = 'value', $text = 'text', $selected = null, $idtag = false, $translate = false )
	{
		reset( $arr );
		$html = '';

		if (is_array($attribs)) {
			$attribs = JArrayHelper::toString($attribs);
		 }

		$id_text = $name;
		if ( $idtag ) {
			$id_text = $idtag;
		}
		
		$id_text	= str_replace('[','',$id_text);
		$id_text	= str_replace(']','',$id_text);

		for ($i=0, $n=count( $arr ); $i < $n; $i++ )
		{
			$k	= $arr[$i]->$key;
			$t	= $translate ? JText::_( $arr[$i]->$text ) : $arr[$i]->$text;
			$id	= ( isset($arr[$i]->id) ? @$arr[$i]->id : null);

			$extra	= '';
			$extra	.= $id ? " id=\"" . $arr[$i]->id . "\"" : '';
			if (is_array( $selected ))
			{
				foreach ($selected as $val)
				{
					$k2 = is_object( $val ) ? $val->$key : $val;
					if ($k == $k2)
					{
						$extra .= " selected=\"selected\"";
						break;
					}
				}
			} else {
				$extra .= ($k == $selected ? " checked=\"checked\"" : '');
			}
			$html .= "\n\t<input type=\"radio\" name=\"$name\" id=\"$id_text$k\" value=\"".$k."\"$extra $attribs />";
			$html .= "\n\t<label for=\"$id_text$k\">$t</label>";
		}
		$html .= "\n";
		return $html;
	}
	
	/**
	 * Generates a yes/no radio list
	 *
	 * @param string The value of the HTML name attribute
	 * @param string Additional HTML attributes for the <select> tag
	 * @param mixed The key that is selected
	 * @returns string HTML for the radio list
	 */
	function booleanlist( $name, $attribs = null, $selected = null, $yes='yes', $no='no', $id=false )
	{	
		$arr = array(
			JHTML::_('select.option',  '0', JText::_( $no ) ),
			JHTML::_('select.option',  '1', JText::_( $yes ) )
		);
		return JHTML::_('photomapgallery.select.radiolist',  $arr, $name, $attribs, 'value', 'text', (int) $selected, $id );
	}
	
	function image_libraries( $name, $attribs = null, $selected = null, $idtag = false, $translate = false )
	{
		if (is_array($attribs)) {
			$attribs['class'] = ( isset( $attribs['class'] ) ? $attribs['class'] : '' ) . ' inputbox';
			$attribs = JArrayHelper::toString($attribs);
		}
		
		$GDfuncList = find_libraries();
					
		$image_libraries = array( JHTML::_( 'select.option', '', sprintf( JText::_('SELECT IMAGE LIB') )) );
		if( !empty($GDfuncList['gd1']) ) {
			$image_libraries[] = JHTML::_('select.option',  'gd1', JText::_( 'GD LIB' ) . ' ' . $GDfuncList['gd1'] );
		}
		$image_libraries[] = JHTML::_( 'select.option', 'gd2', JText::_( 'GD2 Library' ) . ' ' . $GDfuncList['gd2'] );
		$image_libraries[] = JHTML::_( 'select.option', 'netpbm', ( isset( $GDfuncList['netpbm'] ) ) ? $GDfuncList['netpbm'] : JText::_( 'Netpbm' ) );
		$image_libraries[] = JHTML::_( 'select.option', 'imagemagick', ( isset( $GDfuncList['imagemagick'] ) ) ? $GDfuncList['imagemagick'] : JText::_( 'Imagemagick' ) );

		$image_libraries = JHTML::_( 'select.genericlist', $image_libraries, $name, $attribs, 'value', 'text', $selected, $idtag, $translate );
	
		return $image_libraries;
	}
}