<?php
/**
 * @version 1.1.0 $Id: sidemenu.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


class photomapgallerySidemenu
{
	/**
	 * A method to play the __construct() role since JHTML::_() doesn't instantiate the class
	 * 
	 * @access	public
	 * @return	void
	 */
	function general()
	{
		global $mainframe;
		
		// Load the photomapgallery's general css file
		$css = GALLERY_ASSETS_CSS_URL . 'sidemenu.css';
		
		$document =& JFactory::getDocument();
		$document->addStyleSheet($css);
		
		if ( $mainframe->isAdmin() ) {
			JHTML::_('photomapgallery.sidemenu.sidemenu');
		}
	}
	

	/**
	 * The Side Menu
	 * 
	 * @access	public
	 * @return	void
	 */
	function sidemenu()
	{
		$view = JRequest::getCmd('view');
		$task = JRequest::getCmd('task');
		?>
		<div id="sidemenu">
			<div class="t">
				<div class="t">
					<div class="t"></div>
				</div>
			</div>
			<div class="m">
				<center><?php echo JHTML::_( 'image', GALLERY_ASSETS_IMAGES_URL . 'logo.png', JText::_('GALLERY') ); ?></center>
				<dl>
					<dt><?php echo JText::_('GENERAL'); ?></dt>
                    <dd class="zebra<?php echo ( $view == 'photomapgallery' && empty($task) ) ? ' active' : ''; ?>">
						<a href="<?php echo JRoute::_('index.php?option=com_photomapgallery&view=photomapgallery'); ?>">
							<?php echo JText::_('DASHBOARD'); ?>
						</a>
					</dd>
					<dd class="zebra<?php echo ( $view == 'categories' && empty($task) ) ? ' active' : ''; ?>">
						<a href="<?php echo JRoute::_('index.php?option=com_photomapgallery&view=categories'); ?>">
							<?php echo JText::_('CATEGORY'); ?>
						</a>
					</dd>
                    <dd class="zebra<?php echo ( $view == 'batchupload' && empty($task) ) ? ' active' : ''; ?>">
						<a href="<?php echo JRoute::_('index.php?option=com_photomapgallery&view=filemanager'); ?>">
							<?php echo JText::_('BATCH UPLOAD'); ?>
						</a>
					</dd>
                    <dd>
						<a href="<?php echo JRoute::_('index.php?option=com_photomapgallery&view=galleryitems'); ?>">
							<?php echo JText::_('GALLERY ITEMS'); ?>
						</a>
					</dd>
                    <dd>
						<a href="<?php echo JRoute::_('index.php?option=com_photomapgallery&view=users'); ?>">
							<?php echo JText::_('GALLERYUSER'); ?>
						</a>
					</dd>
                    <dd>
						<a href="<?php echo JRoute::_('index.php?option=com_photomapgallery&view=usergroups'); ?>">
							<?php echo JText::_('GALLERYUSERGROUP'); ?>
						</a>
					</dd>  
 					<dd>
						<a href="<?php echo JRoute::_('index.php?option=com_photomapgallery&view=tags'); ?>">
							<?php echo JText::_('TAGS'); ?>
						</a>
					</dd>
                    <dd>
						<a href="<?php echo JRoute::_('index.php?option=com_photomapgallery&view=comments'); ?>">
							<?php echo JText::_('COMMENTS'); ?>
						</a>
					</dd>
					<dd <?php echo ( $view == 'configurations' ) ? 'class="active"' : ''; ?>>
						<a href="<?php echo JRoute::_('index.php?option=com_photomapgallery&view=settings'); ?>">
							<?php echo JText::_('CONFIGURATIONS'); ?>
						</a>
					</dd>
				</dl>
				<a class="credits" href="http://www.photoindochina.com" target="_blank"><center><?php echo JHTML::_( 'image', GALLERY_ASSETS_IMAGES_URL . 'credit.png', JText::_('POWERED BY PHOTOMAP GALLERY') ); ?></center></a>
				<div class="clr"></div>
			</div>
			<div class="b">
				<div class="b">
					<div class="b"></div>
				</div>
			</div>
		</div>
		<?php
	}
}
?>
