


CREATE TABLE IF NOT EXISTS `#__g_categories` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `parent_id` int(11) unsigned NOT NULL default '0',
  `userid` int(11) unsigned NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `directory` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `meta_keywords` text NOT NULL,
  `meta_description` text NOT NULL,
  `image` varchar(255) NOT NULL,
  `maptype` varchar(20) NOT NULL,
  `mapwidth` varchar(20) NOT NULL,
  `mapheight` varchar(20) NOT NULL,
  `ajaxmap` tinyint(1) NOT NULL,
  `published` tinyint(1) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `access` int(11) unsigned NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
PRIMARY KEY (`id`)
) TYPE=MyISAM CHARACTER SET `utf8` COLLATE `utf8_general_ci`;

CREATE TABLE IF NOT EXISTS `#__g_cats_item_relations` (
  `catid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `ordering` tinyint(11) NOT NULL,
  PRIMARY KEY  (`catid`,`itemid`),
  KEY `catid` (`catid`),
  KEY `itemid` (`itemid`)
) TYPE=MyISAM CHARACTER SET `utf8` COLLATE `utf8_general_ci`;


CREATE TABLE IF NOT EXISTS `#__g_comments` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `post_id` int(11) NOT NULL COMMENT 'galleryitem_post_id',
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `date` datetime NOT NULL,
  `update` datetime NOT NULL,
  `ip` varchar(15) NOT NULL,
  `hit` int(11) default NULL,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM CHARACTER SET `utf8` COLLATE `utf8_general_ci`;

CREATE TABLE IF NOT EXISTS `#__g_favourites` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM CHARACTER SET `utf8` COLLATE `utf8_general_ci`;

CREATE TABLE IF NOT EXISTS `#__g_galleryitems` (
  `id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL,
  `title` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `filename` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `imagewidth` int(11) NOT NULL,
  `imageheight` int(11) NOT NULL,
  `rate` int(11) default '0',
  `rate_sum` int(11) default '0',
  `hits` int(11) unsigned NOT NULL default '0',
  `post_hits` int(11) unsigned NOT NULL,
  `version` int(11) unsigned NOT NULL,
  `meta_keywords` text NOT NULL,
  `meta_description` text NOT NULL,
  `metadata` text NOT NULL,
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `created_by` int(11) unsigned NOT NULL default '0',
  `created_by_alias` text NOT NULL,
  `modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `modified_by` int(11) unsigned NOT NULL default '0',
  `attribs` text NOT NULL,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL default '0',
  `ordering` int(11) default '0',
  `featured` tinyint(1) NOT NULL default '0',
  `slideshow` tinyint(1) unsigned NOT NULL,
  `mapdisplay` tinyint(1) NOT NULL,
  `lat` varchar(50) NOT NULL,
  `lon` varchar(50) NOT NULL,
  `zoom` int(11) NOT NULL,
  `maptype` varchar(20) NOT NULL,
  `exif` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM CHARACTER SET `utf8` COLLATE `utf8_general_ci`;

CREATE TABLE IF NOT EXISTS `#__g_tags` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL,
  `name` varchar(255) character set utf8 NOT NULL,
  `alias` varchar(255) character set utf8 NOT NULL,
  `published` tinyint(1) NOT NULL,
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM CHARACTER SET `utf8` COLLATE `utf8_general_ci`;

CREATE TABLE IF NOT EXISTS `#__g_tags_item_relations` (
  `tid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`tid`,`itemid`),
  KEY `tid` (`tid`),
  KEY `itemid` (`itemid`)
) TYPE=MyISAM CHARACTER SET `utf8` COLLATE `utf8_general_ci`;

CREATE TABLE IF NOT EXISTS `#__g_user` (
  `id` int(11) NOT NULL auto_increment,
  `userID` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL,
  `username` varchar(255) NOT NULL default '',
  `gender` enum('m','f') NOT NULL default 'm',
  `description` text NOT NULL,
  `avatar` varchar(255) NOT NULL default '',
  `gallerytitle` varchar(255) NOT NULL default '',
  `catid` int(11) NOT NULL,
  `url` varchar(255) NOT NULL,
  `group` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `userid` (`userid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__g_user_groups` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(255) character set utf8 NOT NULL,
  `permissions` text character set utf8 NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__g_votes` (
  `vpic` int(11) NOT NULL auto_increment,
  `vip` varchar(15) default NULL,
  PRIMARY KEY (`vpic`)
) TYPE=MyISAM CHARACTER SET `utf8` COLLATE `utf8_general_ci`;


CREATE TABLE IF NOT EXISTS `#__g_settings` (
  `id` int(11) NOT NULL,
  `introdescription` text NOT NULL,
  `imagelimit` int(11) unsigned NOT NULL,
  `collimit` int(11) unsigned NOT NULL,
  `cellheight` int(11) unsigned NOT NULL,
  `showrating` tinyint(1) unsigned NOT NULL,
  `showowner` tinyint(1) NOT NULL,
  `showview` tinyint(1) NOT NULL,
  `showsocial` tinyint(1) unsigned NOT NULL,
  `width` int(11) unsigned NOT NULL,
  `resizewidth` int(11) unsigned NOT NULL,
  `thumbwidth` int(11) unsigned NOT NULL,
  `resizequality` int(11) unsigned NOT NULL,
  `thumbquality` int(11) unsigned NOT NULL,
  `uploadmethod` tinyint(1) unsigned NOT NULL default '1',
  `api_key` varchar(255) NOT NULL,
  `lat` varchar(100) NOT NULL,
  `lon` varchar(100) NOT NULL,
  `zoom` int(11) NOT NULL,
  `maptype` varchar(20) NOT NULL,
  `iconsize` int(11) unsigned NOT NULL default '28',
  `featured` tinyint(1) NOT NULL default '0',
  `featured_limit` int(11) NOT NULL default '5',
  `mootools` tinyint(1) NOT NULL default '0',
  `show_pdf_icon` tinyint(1) NOT NULL default '0',
  `show_favourite_icon` tinyint(1) NOT NULL,
  `show_print_icon` tinyint(1) NOT NULL default '0',
  `show_mail_icon` tinyint(1) NOT NULL,
  `show_menu` tinyint(1) NOT NULL,
  `show_menuicon` tinyint(1) NOT NULL,
  `show_sidebar` tinyint(1) NOT NULL,
  `category_cluster` tinyint(1) NOT NULL default '1',
  `cat_cluster_no` int(11) NOT NULL default '20',
  `max_icon_cat` int(11) NOT NULL default '29',
  `item_cluster` tinyint(1) NOT NULL default '0',
  `item_cluster_no` int(11) NOT NULL default '20',
  `max_icon_item` int(11) NOT NULL default '29',
  `special_cluster` tinyint(1) NOT NULL default '0',
  `special_cluster_no` int(11) NOT NULL default '20',
  `max_icon_special` int(11) NOT NULL default '29',
  `mostviewmaptype` varchar(20) NOT NULL,
  `newviewmaptype` varchar(20) NOT NULL,
  `logoimage` varchar(255) NOT NULL,
  `logowidth` int(11) NOT NULL,
  `logoheight` int(11) NOT NULL,
  `image_lib` varchar(50) NOT NULL,
  `max_upload_size` int(11) NOT NULL default '2',
  `show_footer` tinyint(1) NOT NULL default '1',
  `favorite_col` int(11) NOT NULL,
  `favorite_row` int(11) NOT NULL,
  `framesidemargin` int(11) NOT NULL,
  `navwidth` int(11) NOT NULL,
  `mostviewed` int(11) NOT NULL,
  `newphotos` int(11) NOT NULL,
  `group` varchar(30) NOT NULL,
  `tagwidth` int(11) NOT NULL,
  `tagcellwidth` int(11) NOT NULL,
  `tagcellheight` int(11) NOT NULL,
  `tagmaximage` int(11) NOT NULL,
  `exifTags` text NOT NULL,
  `favwidth` int(11) NOT NULL,
  `favcellwidth` int(11) NOT NULL,
  `favcellheight` int(11) NOT NULL,
  `favmaximage` int(11) NOT NULL,
  `default_language` varchar(10) NOT NULL,
  `box` varchar(10) NOT NULL,
  `frame` varchar(30) NOT NULL,
  `framecolor` varchar(10) NOT NULL,
  `backcolor` varchar(10) NOT NULL,
  `toptitlecolor` varchar(10) NOT NULL,
  `titlecolor` varchar(10) NOT NULL,
  `desccolor` varchar(10) NOT NULL,
  `copyrightcolor` varchar(10) NOT NULL,
  `topmargin` int(11) NOT NULL,
  `bottommargin` int(11) NOT NULL,
  `sidemargin` int(11) NOT NULL,
  `navicolumm` int(11) NOT NULL,
  `navirow` int(11) NOT NULL,
  `vermargin` int(11) NOT NULL,
  `topheight` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM CHARACTER SET `utf8` COLLATE `utf8_general_ci`;

INSERT IGNORE INTO `#__g_settings` VALUES (1, '', 20, 4, 260, 1, 1, 1, 1, 650, 150, 60, 0, 0, 0, '', '12.131708944582929', '106.10595703125', 7, 'Hybrid', 28, 0, 4, 0, 1, 1, 1, 1, 1, 0, 1, 1, 20, 29, 0, 20, 29, 0, 20, 29, 'Terrain', 'Map', 'logoimage.gif', 160, 29, 'imagemagick', 5, 1, 8, 10, '10', '670', 100, 200, 'Registered', 670, 70, 70, 108, 'FileName|FileSize|FileDateTime|make|model', 670, 70, 70, 108, 'en-GB', 'White', 'Polaroid Shadow', '#e3dfcb', '#f4f4ea', '#1b1b1b', '#3b3b3b', '#5862c8', '#848484', 3, 15, 3, 9, 2, 10, 30);

INSERT IGNORE INTO `#__g_user_groups` VALUES (2, 'Registered', 'frontEdit=1\nadd=1\neditOwn=1\neditAll=0\npublish=1\ncomment=1\ninheritance=1\n\n'),
(1, 'Site Owner', 'frontEdit=1\nadd=1\neditOwn=1\neditAll=1\npublish=1\ncomment=1\ninheritance=1\ncategories=all\n\n');


