<?php
/**
 * @version 1.1.0 $Id: photomapgallery.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

/**
 * PhotoMap Gallery Component Model
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since		1.0
 */
class photomapgalleryModelPhotoMapGallery extends JModel
{
	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct()
	{
		parent::__construct();
	}

	function getExistcat()
	{
		$query 	= 'SELECT COUNT( id )'
				. ' FROM #__g_categories'
				;
		$this->_db->setQuery( $query );
		$count = $this->_db->loadResult();
			
		if ($count > 0) {
			return true;
		}
		
		return false;
	}
	
	function getExistmenu()
	{
		$component =& JComponentHelper::getComponent('com_photomapgallery');

		$menus	= &JApplication::getMenu('site', array());
		$items	= $menus->getItems('componentid', $component->id);
			
		if (count($items) > 0) {
			return true;
		}
		
		return false;
	}
	
	function getGroupName($userid)
	{
		$query 	= 'SELECT g.name AS groupname'
				. ' FROM #__g_user AS u'
				. ' LEFT JOIN #__g_user_groups AS g ON g.id = u.group'
				. ' WHERE u.userID = '.$userid
				;
		$this->_db->setQuery( $query );
		$name = $this->_db->loadObject();

		return $name;
	}
	
	function getLatestItems(){

		$query = 'SELECT i.id, i.title, i.user_id, i.created, i.created_by, i.filename, g.name AS groupname, c.title AS category, c.directory AS directory'
				. ' FROM #__g_galleryitems AS i'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__g_categories AS c ON c.id = rel.catid'
				. ' LEFT JOIN #__g_user AS u ON u.userID = c.userid'
				. ' LEFT JOIN #__g_user_groups AS g ON g.id = u.group'
				. ' WHERE i.published = 1'
				. ' ORDER BY created DESC'
				. ' LIMIT 10'
				;
		
		$this->_db->SetQuery($query);
  		$row = $this->_db->loadObjectList();

		return $row;
	}
	
	function getMostViewedItems(){

		$query = 'SELECT i.id, i.title, i.hits, i.user_id, i.created, i.created_by, i.filename, g.name AS groupname, c.title AS category, c.directory AS directory'
				. ' FROM #__g_galleryitems AS i'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__g_categories AS c ON c.id = rel.catid'
				. ' LEFT JOIN #__g_user AS u ON u.userID = c.userid'
				. ' LEFT JOIN #__g_user_groups AS g ON g.id = u.group'
				. ' WHERE i.published = 1'
				. ' ORDER BY hits DESC'
				. ' LIMIT 10'
				;
		
		$this->_db->SetQuery($query);
  		$row = $this->_db->loadObjectList();
		
		return $row;
	}
	
	function getMostRatedItems(){

		$query = 'SELECT (i.rate_sum / i.rate ) * 20 AS votes, i.title, i.id, i.user_id, i.created, i.created_by, i.filename, i.rate, g.name AS groupname, c.title AS category, c.directory AS directory'
				. ' FROM #__g_galleryitems AS i'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__g_categories AS c ON c.id = rel.catid'
				. ' LEFT JOIN #__g_user AS u ON u.userID = c.userid'
				. ' LEFT JOIN #__g_user_groups AS g ON g.id = u.group'
				. ' WHERE i.published = 1'
				. ' ORDER BY votes DESC'
				. ' LIMIT 10'
				;
		
		$this->_db->SetQuery($query);
  		$row = $this->_db->loadObjectList();
			
		return $row;
	}
	
	function getCategories($id)
	{
		$query = 'SELECT DISTINCT c.title'
				. ' FROM #__g_categories AS c'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.catid = c.id'
				. ' WHERE rel.itemid = '.(int)$id
				;
	
		$this->_db->setQuery( $query );

		$cats = $this->_db->loadObjectList();

		return $cats;
	}
	
	function getLatestComments() {
	
		$query = 'SELECT c.*, i.filename, i.user_id, i.id  AS itemid, g.name AS groupname, ct.title AS category, ct.directory AS directory'
				. ' FROM #__g_comments AS c'
				. ' LEFT JOIN #__g_galleryitems AS i ON i.id = c.post_id'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__g_categories AS ct ON ct.id = rel.catid'
				. ' LEFT JOIN #__g_user AS u ON u.userID = ct.userid'
				. ' LEFT JOIN #__g_user_groups AS g ON g.id = u.group'
				. ' WHERE i.published = 1'
				. ' ORDER BY c.date DESC';
				
		$this->_db->setQuery($query, 0, 10);
		$rows = $this->_db->loadObjectList();

		return $rows;
	}
	
	function countItems(){
		
		$query = "SELECT COUNT(*) FROM #__g_galleryitems";
		$this->_db->setQuery($query);
		$result = $this->_db->loadResult();
		return $result;
	}
	
	function countFeaturedItems(){

		$query = "SELECT COUNT(*) FROM #__g_galleryitems WHERE featured=1";
		$this->_db->setQuery($query);
		$result = $this->_db->loadResult();
		return $result;
	}
	
	function countCategories(){

		$query = "SELECT COUNT(*) FROM #__g_categories";
		$this->_db->setQuery($query);
		$result = $this->_db->loadResult();
		return $result;
	}
	
	function countUnpublishedCategories(){

		$query = "SELECT COUNT(*) FROM #__g_categories WHERE published=0";
		$this->_db->setQuery($query);
		$result = $this->_db->loadResult();
		return $result;
	}
	
	function countComments(){

		$query = "SELECT COUNT(*) FROM #__g_comments";
		$this->_db->setQuery($query);
		$result = $this->_db->loadResult();
		return $result;
	}
	
	function countUsers(){

		$query = "SELECT COUNT(*) FROM #__g_user";
		$this->_db->setQuery($query);
		$result = $this->_db->loadResult();
		return $result;
	}

	
	/**
	 * Fetch the version from the schlu.net server
	 * TODO: Cleanup
	 */
	 function getUpdate()
	 {
	 	$url = 'http://update.photoindochina.com/photomapgallery_update.xml';
		$data = '';
		$check = array();
		$check['connect'] = 0;
		$check['version_current'] = '1.0.3';
		$check['versionread_current'] = '1.0.3';

		//try to connect via cURL
		if(function_exists('curl_init') && function_exists('curl_exec')) {
			$ch = @curl_init();
			
			@curl_setopt($ch, CURLOPT_URL, $url);
			@curl_setopt($ch, CURLOPT_HEADER, 0);
			//http code is greater than or equal to 300 ->fail
			@curl_setopt($ch, CURLOPT_FAILONERROR, 1);
			@curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			//timeout of 5s just in case
			@curl_setopt($ch, CURLOPT_TIMEOUT, 5);
						
			$data = @curl_exec($ch);
						
			@curl_close($ch);
		}

		//try to connect via fsockopen
		if(function_exists('fsockopen') && $data == '') {

			$errno = 0;
			$errstr = '';

			//timeout handling: 5s for the socket and 5s for the stream = 10s
			$fsock = @fsockopen("update.photoindochina.com", 80, $errno, $errstr, 5);
		
			if ($fsock) {
				@fputs($fsock, "GET /photomapgallery_update.xml HTTP/1.1\r\n");
				@fputs($fsock, "HOST: update.photoindochina.com\r\n");
				@fputs($fsock, "Connection: close\r\n\r\n");
        
				//force stream timeout...bah so dirty
				@stream_set_blocking($fsock, 1);
				@stream_set_timeout($fsock, 5);
				 
				$get_info = false;
				while (!@feof($fsock))
				{
					if ($get_info)
					{
						$data .= @fread($fsock, 1024);
					}
					else
					{
						if (@fgets($fsock, 1024) == "\r\n")
						{
							$get_info = true;
						}
					}
				}        	
				@fclose($fsock);
				
				//need to chack data cause http error codes aren't supported here
				if(!strstr($data, '<?xml version="1.0" encoding="utf-8"?>
<update>')) {
					$data = '';
				}
			}
		}

	 	//try to connect via fopen
		if (function_exists('fopen') && ini_get('allow_url_fopen') && $data == '') {
		
			//set socket timeout
			ini_set('default_socket_timeout', 5);
			
			$handle = @fopen ($url, 'r');
			
			//set stream timeout
			@stream_set_blocking($handle, 1);
			@stream_set_timeout($handle, 5);
			
			$data	= @fread($handle, 1000);
			
			@fclose($handle);
		}
						
		/* try to connect via file_get_contents..k..a bit stupid
		if(function_exists('file_get_contents') && ini_get('allow_url_fopen') && $data == '') {
			$data = @file_get_contents($url);
		}
		*/
		
		if( $data && strstr($data, '<?xml version="1.0" encoding="utf-8"?><update>') ) {
			$xml = & JFactory::getXMLparser('Simple');
			$xml->loadString($data);
			
			$version 				= & $xml->document->version[0];
			$check['version'] 		= & $version->data();
			$versionread 			= & $xml->document->versionread[0];
			$check['versionread'] 	= & $versionread->data();
			$released 				= & $xml->document->released[0];
			$check['released'] 		= & $released->data();
			$check['connect'] 		= 1;
			$check['enabled'] 		= 1;
			
			$check['current'] 		= version_compare( $check['version_current'], $check['version'] );
		}
		
		return $check;
	 }
}
?>