<?php
/**
 * @version 1.1.0 $Id: users.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 

defined('_JEXEC') or die();

jimport('joomla.application.component.model');
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');


class photomapgalleryModelUsers extends JModel
{
	var $_pagination = null;
	var $_total = null;
	
	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		$limit		= $mainframe->getUserStateFromRequest( $option.'.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}
	
	function getData() {
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.users.filter_order', 'filter_order', '', 'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.users.filter_order_Dir', 'filter_order_Dir', '', 'word' );
		$filter_status = $mainframe->getUserStateFromRequest($option.'.users.filter_status', 'filter_status', -1, 'int');
		$filter_group = $mainframe->getUserStateFromRequest($option.'.users.filter_group', 'filter_group', '', 'string');
		$filter_group_pm = $mainframe->getUserStateFromRequest($option.'.users.filter_group_pm', 'filter_group_pm', '', 'string');
		$search = $mainframe->getUserStateFromRequest( $option.'.users.search', 'search', '', 'string' );
		$search = $this->_db->getEscaped( trim(JString::strtolower( $search ) ) );
	
		$query = "SELECT juser.*, pmuser.group, pmgroup.name AS groupname FROM #__users AS juser ".
				"LEFT JOIN #__g_user AS pmuser ON juser.id=pmuser.userid ".
				"LEFT JOIN #__g_user_groups AS pmgroup ON pmuser.group=pmgroup.id ".
				" WHERE juser.id > 0";
		
//		$query = "SELECT juser.* FROM #__users as juser ".
//		" WHERE juser.id>0";
/*		$query = "SELECT juser.*, pmuser.group FROM #__users as juser ".
		"LEFT JOIN #__g_user as pmuser ON juser.id=pmuser.userid ".
		" WHERE juser.id>0";
*/		
		if ($filter_status > -1) {
			$query .= " AND juser.block = {$filter_status}";
		}
	
		if ($filter_group) {
			switch($filter_group)
			{
				case 'Public Frontend':
				$query .= " AND juser.usertype IN ('Registered', 'Author', 'Editor', 'Publisher')";
				break;
			
				case 'Public Backend':
				$query .= " AND juser.usertype IN ('Manager', 'Administrator', 'Super Administrator')";
				break;
			
				default:
				$filter_group=strtolower(trim($filter_group));
				$query .= " AND juser.usertype = '{$filter_group}'";
			}
		}
		
		if ($filter_group_pm) {
			$query .= " AND pmuser.group = '{$filter_group_pm}'";
		}
		
		if ($search) {
			$query .= " AND LOWER( juser.name ) LIKE ".$db->Quote('%'.$search.'%');
		}
	
		if (!$filter_order) {
			$filter_order = "juser.name";
		}
	
		$query .= " ORDER BY {$filter_order} {$filter_order_Dir}";
	
		$this->_db->setQuery($query, $this->getState('limitstart'), $this->getState('limit'));
		$rows = $this->_db->loadObjectList();
		return $rows;
	}

	function getTotal() {
	
		global $mainframe, $option;

		$filter_status = $mainframe->getUserStateFromRequest($option.'.users.filter_status', 'filter_status', -1, 'int');
		$filter_group = $mainframe->getUserStateFromRequest($option.'.users.filter_group', 'filter_group', '', 'string');
		$filter_group_pm = $mainframe->getUserStateFromRequest($option.'.users.filter_group_pm', 'filter_group_pm', '', 'string');
		$search = $mainframe->getUserStateFromRequest($option.'.users.search', 'search', '', 'string');
		$search = JString::strtolower($search);
	
		$query = "SELECT COUNT(juser.id) FROM #__users as juser ".
				"LEFT JOIN #__g_user as pmuser ON juser.id=pmuser.userID ".
				"LEFT JOIN #__g_user_groups as pmgroup ON pmuser.group=pmgroup.id ".
				" WHERE juser.id>0";
	
		if ($filter_status > -1) {
			$query .= " AND juser.block = {$filter_status}";
		}
	
		if ($filter_group) {
			switch($filter_group)
			{
				case 'Public Frontend':
				$query .= " AND juser.usertype IN ('Registered', 'Author', 'Editor', 'Publisher')";
				break;
			
				case 'Public Backend':
				$query .= " AND juser.usertype IN ('Manager', 'Administrator', 'Super Administrator')";
				break;
			
				default:
				$filter_group=strtolower(trim($filter_group));
				$query .= " AND juser.usertype = '{$filter_group}'";
			}
		}
		
		if ($filter_group_pm) {
			$query .= " AND pmuser.group = '{$filter_group_pm}'";
		}
		
		if ($search) {
			$query .= " AND LOWER( juser.name ) LIKE ".$db->Quote('%'.$search.'%');
		}
		
		$query.= " GROUP BY juser.id";
		
		$this->_db->setQuery($query);
		$this->_total = $this->_getListCount($query);
		
		return $this->_total;
	}

	function getPagination()
	{
		// Lets load the Items if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}
	
	function remove() {
		global $mainframe;
		$cid = JRequest::getVar('cid');
		$row = & JTable::getInstance('g_user', '');
		foreach ($cid as $id) {
			$row->load($id);
			$row->delete($id);
		}
		$cache = & JFactory::getCache('com_photomapgallery');
		$cache->clean();
		$mainframe->redirect('index.php?option=com_photomapgallery&view=users', JText::_('User profile deleted'));
	}
	
	function getUserGroups($type='joomla'){
		
		$db = & JFactory::getDBO();
		
		if ($type=='joomla'){
			
			$query = 'SELECT (lft - 3) AS lft, name AS value, name AS text'
				. ' FROM #__core_acl_aro_groups'
				. ' WHERE name != "ROOT"'
				. ' AND name != "USERS"'
				. ' ORDER BY `lft` ASC'
			;
			$db->setQuery( $query );
			$groups = $db->loadObjectList();
			$userGroups = array();
	
			foreach ($groups as $group) {
				if ($group->lft >= 10) $group->lft = (int)$group->lft - 10;
				$group->text = $this->indent($group->lft).$group->text;
				array_push($userGroups,$group);
			}
			
		}
		else {
			$query = "SELECT * FROM #__g_user_groups";
			$db->setQuery($query);
			$userGroups = $db->loadObjectList();
			
		}

		return $userGroups;
	}
	
	function indent($times, $char = '&nbsp;&nbsp;&nbsp;&nbsp;', $start_char = '', $end_char = '') {
		$return = $start_char;
		for ($i = 0; $i < $times; $i++) $return .= $char;
		$return .= $end_char;
		return $return;
	}
	
	function checkLogin($id){
		
		$db = & JFactory::getDBO();
		$query = "SELECT COUNT(s.userid) FROM #__session AS s WHERE s.userid = {$id}";
		$db->setQuery( $query );
		$result = $db->loadResult();
		return $result;
	}
	
	function hasProfile($id){
		
		$db = & JFactory::getDBO();
		$query = "SELECT id FROM #__g_user WHERE userID = {$id}";
		$db->setQuery( $query );
		$result = $db->loadResult();
		return $result;
	}
}
?>