<?php
/**
 * @version 1.1.0 $Id: g_categories.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die('Restricted access');

/**
 * PhotoMap Gallery table class
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class g_categories extends JTable
{
	/**
	 * Primary Key
	 * @var int
	 */
	var $id 				= null;
	var $parent_id			= null;
	var $userid				= null;
	var $title 				= null;
	var $alias	 			= null;
	var $directory			= null;
	var $description	 	= null;
	var $meta_keywords		= null;
	var $meta_description 	= null;
	var $image 				= null;
	var $maptype 			= null;
	var $mapwidth 			= null;
	var $mapheight 			= null;
	var $ajaxmap 			= null;
	var $published			= null;
	var $checked_out 		= 0;
	var $checked_out_time	= 0;
	var $access 			= null;
	var $ordering 			= null;

	function g_categories(& $db) {
		parent::__construct('#__g_categories', 'id', $db);
	}
	
	// overloaded check function
	function check()
	{
		// Not typed in a category name?
		if (trim( $this->title ) == '') {
			$this->_error = JText::_( 'ADD NAME CATEGORY' );
			JError::raiseWarning('SOME_ERROR_CODE', $this->_error );
			return false;
		}

		$alias = JFilterOutput::stringURLSafe($this->title);

		if(empty($this->alias) || $this->alias != $alias ) {
			$this->alias = $alias;
		}

		/** check for existing name with same parent category*/
		$query = 'SELECT id'
				.' FROM #__g_categories'
				.' WHERE title = '.$this->_db->Quote($this->title)
				.' AND parent_id = '.$this->parent_id
				;
		$this->_db->setQuery($query);

		$xid = intval($this->_db->loadResult());
		if ($xid && $xid != intval($this->id)) {
			JError::raiseWarning('SOME_ERROR_CODE', JText::sprintf('CATEGORY NAME ALREADY EXIST', $this->title));
			return false;
		}

		return true;
	}
}
?>