<?php
/**
 * @version 1.1.0 $Id: g_galleryitems.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die('Restricted access');

/**
 * PhotoMap Gallery table class
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class g_galleryitems extends JTable
{
	/**
	 * Primary Key
	 * @var int
	 */
	var $id 				= null;
	var $user_id			= null;
	/** @var string */
	var $title 				= '';
	/** @var string */
	var $alias	 			= '';
	var $filename	 		= '';
	/** @var string */
	var $description	 	= '';
	var $imagewidth			= 0;
	var $imageheight		= 0;
	/** @var int */
	var $rate_sum			= 0;
	/** @var int */
	var $rate				= 0;
	/** @var int */
	var $hits				= 0;
	var $post_hits			= 0;
	var $version			= 0;
	/** @var string */
	var $meta_keywords		= null;
	/** @var string */
	var $meta_description 	= null;
	/** @var string */
	var $metadata			= null;
	/** @var date */
	var $created			= '';
	/** @var int */
	var $created_by			= '';
	var $created_by_alias	= '';
	/** @var date */
	var $modified			= '';
	/** @var int */
	var $modified_by		= '';
	/** @var int */
	var $published			= 0;
	/** @var string */
	var $attribs	 		= null;
	/** @var int */
	var $checked_out 		= 0;
	/** @var date */
	var $checked_out_time	= '';
	/** @var int */
	var $ordering 			= null;
	var $featured			= 0;
	var $slideshow			= 0;
	/** @var string */
	var $mapdisplay 		= 0;
	var $lat 				= '';
	var $lon 				= '';
	var $zoom 				= '';
	var $maptype 			= '';
	var $exif	 			= null;

	function g_galleryitems(& $db) {
		parent::__construct('#__g_galleryitems', 'id', $db);
	}
	
	// overloaded check function
	function check()
	{
		// Not typed in a title?
		if (trim( $this->title ) == '') {
			$this->_error = JText::_( 'ADD TITLE' );
			JError::raiseWarning('SOME_ERROR_CODE', $this->_error );
			return false;
		}

		$alias = JFilterOutput::stringURLSafe($this->title);

		if(empty($this->alias) || $this->alias === $alias ) {
			$this->alias = $alias;
		}
	
		return true;
	}
}
?>