<?php
/**
 * @version 1.2.0 $Id: g_language.php 2010-03-06 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die('Restricted access');


class g_language extends JTable
{
	/**
	 * Primary Key
	 * @var int
	 */
	var $itemid 			= null;
	/** @var int */
	var $language			= null;
	/** @var string */
	var $title				= '';
	/** @var string */
	var $alias				= '';
	/** @var int */
	var $description		= '';
	/** @var int */
	var $meta_key 			= '';
	/** @var date */
	var $meta_des			= '';

	function g_language(& $db) {
		parent::__construct('#__g_language', 'itemid', $db);
	}
	
	// overloaded check function
	function check()
	{
		// Not typed in a name?
		if (trim( $this->title ) == '') {
			$this->_error = JText::_( 'ADD_NAME' );
			JError::raiseWarning('SOME_ERROR_CODE', $this->_error );
			return false;
		}
		
		$alias = JFilterOutput::stringURLSafe($this->title);

		if(empty($this->alias) || $this->alias === $alias ) {
			$this->alias = $alias;
		}
		
		/** check for existing name */
		$query = 'SELECT itemid'
				.' FROM #__g_language'
				.' WHERE title = '.$this->_db->Quote($this->title)
				;
		$this->_db->setQuery($query);
		

		$xid = intval($this->_db->loadResult());
		if ($xid && $xid == intval($this->itemid)) {
			JError::raiseWarning('SOME_ERROR_CODE', JText::sprintf('TITLE ALREADY EXIST', $this->title));

			return false;
		}

		return true;
	}
}
?>