<?php
/**
 * @version 1.1.0 $Id: category.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * View class for the PhotoMap Gallery category screen
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class photomapgalleryViewCategory extends photomapgalleryView {

	function __construct( $config = array() )
	{
		parent::__construct($config);

	}
	
	function displayDefault()
	{
		global $mainframe;

		//Load pane behavior
		jimport('joomla.html.pane');

		//initialise variables
		$editor 	= & JFactory::getEditor();
		$document	= & JFactory::getDocument();
		$user 		= & JFactory::getUser();
		$lang 		= & JFactory::getLanguage();

		//get vars
		$cid 		= JRequest::getVar( 'cid' );

		//create the toolbar
		if ( $cid ) {
			JToolBarHelper::title( JText::_( 'EDIT CATEGORY' ), 'categories' );

		} else {
			JToolBarHelper::title( JText::_( 'NEW CATEGORY' ), 'categories' );
		}
		JToolBarHelper::apply();
		JToolBarHelper::spacer();
		JToolBarHelper::save();
		JToolBarHelper::spacer();
		JToolBarHelper::cancel();

		//Get data from the model
		$model		= & $this->getModel();
		$row     	= & $this->get( 'Category' );
		$sub     	= & $this->get( 'SubCategory' );
		$categories = photomapgallery_cats::getCategoriesTree(1, 0);

		//remove the current category to prevent selection as parent for itself
		foreach($categories as $category) {			
			if ($category->id == $row->id) {
				unset($categories[$category->id]);
			}
		}

		//fail if checked out not by 'me'
		if ($row->id) {
			if ($model->isCheckedOut( $user->get('id') )) {
				JError::raiseWarning( 'SOME_ERROR_CODE', $row->title.' '.JText::_( 'EDITED BY ANOTHER ADMIN' ));
				$mainframe->redirect( 'index.php?option=com_photomapgallery&view=categories' );
			}
		}

		$row->userid = $user->get('id');
		
		//clean data
		JFilterOutput::objectHTMLSafe( $row, ENT_QUOTES, 'text' );
	    	
		//build selectlists
		$Lists = array();

		$Lists['access'] 	= JHTML::_('list.accesslevel', $row );
		$Lists['parent_id'] = photomapgallery_cats::buildcatselect($categories, 'parent_id', $row->parent_id, true);
		
		if (count($sub)) {
			$folder = $sub[0]->id;
			$directory = $sub[0]->directory;
		} else {
			$folder = $row->id;
			$directory = $row->directory;
		}
		//build image select js and load the view
		$js = "
		function gSelectImage(image, folder) {
			document.getElementById('a_image').value = image;
			document.getElementById('a_folder').value = folder;
			document.getElementById('imagelib').src = '../images/photomap/thumb/' + image;
			document.getElementById('sbox-window').close();
		}";

		$link = 'index.php?option=com_photomapgallery&amp;view=imagehandler&amp;task=selectimage&amp;tmpl=component&amp;folder='.$folder;
		$document->addScriptDeclaration($js);
		
		JHTML::_('behavior.modal', 'a.modal');
		
		$imageselect = "\n<input style=\"background: #ffffff;\" size=\"65\" type=\"text\" id=\"a_folder\" value=\"$row->image\" disabled=\"disabled\" onchange=\"javascript:if (document.forms[0].a_image.value!='') {document.imagelib.src='../images/photomap/thumb/$directory/' + document.forms[0].a_folder.value + '/' + document.forms[0].a_image.value} else {document.imagelib.src='../media/com_photomapgallery/gallery/no_thumb.gif'}\"; /><br />";

		$imageselect .= "<div class=\"button2-left\"><div class=\"blank\"><a class=\"modal\" title=\"".JText::_('SELECTIMAGE')."\" href=\"$link\" rel=\"{handler: 'iframe', size: {x: 650, y: 425}}\">".JText::_('SELECTIMAGE')."</a></div></div>\n";

		$imageselect .= "\n<input type=\"hidden\" id=\"a_image\" name=\"image\" value=\"$row->image\" />";
		
		$maptype[] = JHTML::_('select.option',  'Map', JText::_( 'Map' ) );
		$maptype[] = JHTML::_('select.option',  'Satellite', JText::_( 'Satellite' ) );
		$maptype[] = JHTML::_('select.option',  'Hybrid', JText::_( 'Hybrid' ) );
		$maptype[] = JHTML::_('select.option',  'Terrain', JText::_( 'Terrain' ) );

		$Lists['maptype'] = JHTML::_('select.genericlist',   $maptype, 'maptype', '', 'value', 'text', $row->maptype );

		$meta     	= & $model->getCategoryMeta($row->parent_id);
		$row->prevmetakey = $meta->meta_keywords;
		$row->prevmetadesc = $meta->meta_description;
		
		$author=JFactory::getUser($row->userid);
		
		//assign vars to view
		$this->assignRef('Lists', 			$Lists);
		$this->assignRef('row', 			$row);
		$this->assignRef('meta', 			$meta);
		$this->assignRef('cid', 			$cid);
		$this->assignRef('editor', 			$editor);
		$this->assignRef('imageselect', 	$imageselect);
		$this->assignRef('folder', 			$folder);
		$this->assignRef('user', 			$user);
		$this->assignRef('author', 			$author);
/*		
		echo "<pre>";
		echo "view=";
		print_r($author);
		echo "</pre>";
*/
	}
}
?>