<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * View class for the PhotoMap Gallery comments screen
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class photomapgalleryViewComments extends photomapgalleryView {

	function __construct( $config = array() )
	{
		parent::__construct($config);

	}
	
	function displayDefault()
	{
		global $mainframe;

		$filter_order		= $mainframe->getUserStateFromRequest( "$option.filter_order", 'filter_order', 'duration','cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( "$option.filter_order_Dir", 'filter_order_Dir', '', 'word' );
		if ($filter_order != 'name')
			$filter_order = 'name';

		$search = $mainframe->getUserStateFromRequest( "$option.search", 'search', '', 'string' );
		$search = JString::strtolower( $search );
		$this->assignRef( 'search', $search );

		$model =& $this->getModel();

		JToolBarHelper::title( JText::_( 'Comments Manager' ), 'comments' );
		JToolBarHelper::publishList();
		JToolBarHelper::spacer();
		JToolBarHelper::unpublishList();
		JToolBarHelper::spacer();
		JToolBarHelper::editList();
		JToolBarHelper::spacer();
		JToolBarHelper::deleteList('Are you sure you want to delete the record(s)?');

//		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limit		= 20;
		$limitstart = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		$total = $model->GetRowNumbers($search);

		jimport('joomla.html.pagination');

		$pagination = new JPagination( $total, $limitstart, $limit );
		$this->assignRef( 'pagination', $pagination );

		$rows = $model->GetComments($pagination->limitstart, $pagination->limit, $search, $filter_order, $filter_order_Dir);
		$this->assignRef( 'rows', $rows );

		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;

		// search filter
		$lists['search']= $search;
		$this->assignRef( 'lists', $lists );
		
/*		
		echo "<pre>";
		echo "view=";
		print_r($rows);
		echo "</pre>";*/
	}
}
?>