<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Filemanager View
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class photomapgalleryViewFilemanager extends photomapgalleryView {
	function __construct( $config = array() )
	{
		parent::__construct($config);

	}
	
	function displayDefault()
	{
		global $mainframe, $option;
		
		//initialise variables
		$document	= & JFactory::getDocument();
		$params 	= & JComponentHelper::getParams('com_photomapgallery');
		$lang 		= & JFactory::getLanguage();

		//add css and submenu to document
		$document->addStyleSheet('components/com_photomapgallery/assets/css/photomapgallerybackend.css');
		if ($lang->isRTL()) {
			$document->addStyleSheet('components/com_photomapgallery/assets/css/photomapgallerybackend_rtl.css');
    	}		
		
		//create the toolbar
		JToolBarHelper::title( JText::_( 'BATCH UPLOAD' ), 'batchupload' );
		JToolBarHelper::cancel();

		$categories = photomapgallery_cats::getCategoriesTree(1, 0);
		$selectedcats = & $this->get( 'Catsselected' );

		$lists['cid'] = photomapgallery_cats::buildcatselect($categories, 'cid[]', $selectedcats, false, 'multiple="multiple" size="10"');
		
		$uploadmethod[] = JHTML::_('select.option',  '0', JText::_( 'Scale' ) );
		$uploadmethod[] = JHTML::_('select.option',  '1', JText::_( 'Crop' ) );

		$lists['resizeuploadmethod'] = JHTML::_('select.genericlist', $uploadmethod, 'resizeuploadmethod', '', 'value', 'text', 0 );
		$lists['thumbuploadmethod'] = JHTML::_('select.genericlist', $uploadmethod, 'thumbuploadmethod', '', 'value', 'text', 0 );
		
		//assign data to template		
		$this->assignRef('session'		, JFactory::getSession());
		$this->assignRef('params'		, $params);
		$this->assignRef('lists'      	, $lists);
	}
}
?>