<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');


class photomapgalleryViewGalleryItem extends photomapgalleryView {

	function __construct( $config = array() )
	{
		parent::__construct($config);

	}
	
	function displayDefault()
	{
		global $mainframe, $gconf;

		//Load pane behavior
		jimport('joomla.html.pane');

		//initialise variables
		$document	= & JFactory::getDocument();
		$user 		= & JFactory::getUser();
		$db  		= & JFactory::getDBO();
		$lang 		= & JFactory::getLanguage();
		$tabs 		= & JPane::getInstance('tabs');
		$pane 		= & JPane::getInstance('sliders');

		JHTML::_('behavior.tooltip');

		$nullDate 		= $db->getNullDate();

		//get vars
		$cid 		= JRequest::getVar( 'cid' );

		$document->addStyleSheet('components/com_photomapgallery/assets/css/photomapgallery.css');
		if ($lang->isRTL()) {
			$document->addStyleSheet('components/com_photomapgallery/assets/css/photomapgallery_rtl.css');
    	}
		
		$document->addScript( JURI::base().'components/com_photomapgallery/assets/js/itemscreen.js' );
		
		//create the toolbar
		if ( $cid ) {
			JToolBarHelper::title( JText::_( 'EDIT GALLERY ITEM' ), 'itemedit' );

		} else {
			JToolBarHelper::title( JText::_( 'NEW GALLERY ITEM' ), 'newitem' );
		}
		JToolBarHelper::apply();
		JToolBarHelper::spacer();
		JToolBarHelper::save();
		JToolBarHelper::spacer();
		JToolBarHelper::cancel();

		//Get data from the model
		$model		= & $this->getModel();
		$row 		= & $this->get('Item');

		$categories = photomapgallery_cats::getCategoriesTree(1, 0);
		$selectedcats = & $this->get( 'Catsselected' );

		// fail if checked out not by 'me'
		if ($row->id) {
			if ($model->isCheckedOut( $user->get('id') )) {
				JError::raiseWarning( 'SOME_ERROR_CODE', $row->title.' '.JText::_( 'EDITED BY ANOTHER ADMIN' ));
				$mainframe->redirect( 'index.php?option=com_photomapgallery&view=categories' );
			}
		}

		//clean data
		JFilterOutput::objectHTMLSafe( $row, ENT_QUOTES );

		//build selectlists
		$lists = array();
		$lists['cid'] = photomapgallery_cats::buildcatselect($categories, 'cid[]', $selectedcats, false, 'multiple="multiple" size="10"');

		$query = 'SELECT *'
				. ' FROM #__g_categories'
				. ' WHERE id = '.$selectedcats[0];
					
		$db->setQuery($query);
		$parent_cat = $db->loadObject();
			
		// Create the form
		$form = new JParameter('', GALLERY_MODELS.DS.'galleryitem.xml');

		// Details Group
		$active = (intval($row->created_by) ? intval($row->created_by) : $user->get('id'));
		$form->set('created_by', $active);
		$form->set('created_by_alias', $row->created_by_alias);
		$form->set('created', JHTML::_('date', $row->created, '%Y-%m-%d %H:%M:%S'));
		$form->set('modified', JHTML::_('date', $row->modified, '%Y-%m-%d %H:%M:%S'));

		// Advanced Group
		$form->loadINI($row->attribs);

		// Metadata Group
		if (!$row->meta_description)
			$form->set('description', $parent_cat->meta_description . ', ' . $row->title);
		else
			$form->set('description', $row->meta_description);
			
		if (!$row->meta_keywords)
			$form->set('keywords', $row->title . ', ' . $parent_cat->meta_keywords);
		else
			$form->set('keywords', $row->meta_keywords);
			
		$form->loadINI($row->metadata); 

		// get list of active languages
		$langOptions[] = JHTML::_('select.option',  '-1', JText::_('SELECT DEFAULT LANGUAGE') );
		$systemLanguages = JLanguage::getKnownLanguages(JPATH_SITE);
		
		if ( count($systemLanguages)>0 ) {
			foreach( $systemLanguages as $language )
			{
				$langOptions[] = JHTML::_('select.option',  $language['tag'], $language['name'] );
			}
		}
		
//		$lists['select_language'] = JHTML::_('select.genericlist',  $langOptions, 'select_language', '', 'value', 'text', $config->default_language );
		
		$lists['select_language'] = JHTML::_('select.genericlist', $langOptions, 'select_language', 'class="inputbox" size="1" onchange="if(document.getElementById(\'select_language\').value.length>0) document.adminForm.submit();"', 'value', 'text', $gconf->default_language );

		//assign data to template
		$this->assignRef('gconf'		, $gconf);
		$this->assignRef('lists'      	, $lists);
		$this->assignRef('row'      	, $row);
		$this->assignRef('tabs'			, $tabs);
		$this->assignRef('pane'			, $pane);
		$this->assignRef('nullDate'		, $nullDate);
		$this->assignRef('form'			, $form);
		$this->assignRef('photos'		, $gallery);
		$this->assignRef('parent_cat'	, $parent_cat);
/*
		echo "<pre>";
		echo "view=";
		print_r($row);
		echo "</pre>";
*/
	}
}
?>