<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent EventList component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * View class for the Category imageselect screen
 * Based on the Joomla! media component
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 0.9
 */
class photomapgalleryViewImagehandler extends photomapgalleryView {

	function __construct( $config = array() )
	{
		parent::__construct($config);

	}
	
	function displayDefault()
	{
		global $mainframe, $option, $conf;
		$document =& JFactory::getDocument();
		$user 		= & JFactory::getUser();

		//get vars
		$task 		= JRequest::getVar( 'task' );
		$folder 	= JRequest::getVar( 'folder' );
		$search 	= $mainframe->getUserStateFromRequest( $option.'.search', 'search', '', 'string' );
		$search 	= trim(JString::strtolower( $search ) );

		// Do not allow cache
		JResponse::allowCache(false);

		//add css
		$document->addStyleSheet('components/com_photomapgallery/assets/css/photomapgallery.css');

		//get images
		$images = $this->get('images');
		$pageNav = & $this->get( 'Pagination' );

		$categories_option[]=JHTML::_('select.option', 0, JText::_('- SELECT CATEGORY -'));
		$categories = photomapgallery_cats::getCategoriesTree(1, $user->id);
		$categories_options=@array_merge($categories_option, $categories);
		$lists['categories'] = JHTML::_('select.genericlist', $categories_options, 'folder', 'onchange="this.form.submit();"', 'text', 'text', $folder);
		
		$this->assignRef('conf',  	$conf);
		$this->assignRef('images', 	$images);
		$this->assignRef('folder', 	$folder);
		$this->assignRef('search', 	$search);
		$this->assignRef('pageNav', $pageNav);
		$this->assignRef('lists', 	$lists);
/*		
		echo "<pre>";
		echo "view=";
		print_r( $images);
		echo "</pre>";
*/		
	}

	function setImage($index = 0)
	{
		if (isset($this->images[$index])) {
			$this->_tmp_img = &$this->images[$index];
		} else {
			$this->_tmp_img = new JObject;
		}
	}
}
?>