<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class photomapgalleryViewPhotoMapGallery extends photomapgalleryView
{
	function __construct( $config = array() )
	{
		parent::__construct($config);
		
	}

	function displayDefault()
	{
		global $mainframe;
		
		jimport('joomla.html.pane');
		
		$user 		= & JFactory::getUser();
		$pane   	= & JPane::getInstance('sliders');
		$template	= $mainframe->getTemplate();
		$params 	= & JComponentHelper::getParams('com_photomapgallery');
	
		$model = &$this->getModel();
		
		// required setup check
		$existcat 	= & $this->get( 'Existcat' );
		$existmenu 	= & $this->get( 'Existmenu' );
		$group 	= $model->getGroupName($user->id);
		
		$latestItems = $model->getLatestItems();
		$mostviewedItems = $model->getMostViewedItems();
		$mostratedItems = $model->getMostRatedItems();
		$latestComments = $model->getLatestComments();
		$totalItems = $model->countItems();
		$countFeaturedItems = $model->countFeaturedItems();
		$countCategories = $model->countCategories();
		$countUnCategories = $model->countUnpublishedCategories();
		$countComments = $model->countComments();
		$countUsers = $model->countUsers();
		
		$this->assignRef('existcat',		$existcat);
		$this->assignRef('existmenu',		$existmenu);
		$this->assignRef('latestItems',		$latestItems);
		$this->assignRef('mostviewedItems',		$mostviewedItems);
		$this->assignRef('mostratedItems',		$mostratedItems);
		$this->assignRef('latestComments',		$latestComments);
		$this->assignRef('totalItems',		$totalItems);
		$this->assignRef('countFeaturedItems',		$countFeaturedItems);
		$this->assignRef('countCategories',		$countCategories);
		$this->assignRef('countUnCategories',		$countUnCategories);
		$this->assignRef('countComments',		$countComments);
		$this->assignRef('countUsers',		$countUsers);
		$this->assignRef('group',		$group);
		
		$this->assignRef('pane'			, $pane);
		$this->assignRef('template'		, $template);

	}
}
?>