<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


class photomapgalleryViewSettings extends photomapgalleryView
{
	function __construct( $config = array() )
	{
		parent::__construct($config);

	}
	
	function displayDefault()
	{		
		global $mainframe;
		
		//initialise variables
		jimport('joomla.html.pane');
		
		$document 	= & JFactory::getDocument();
		$acl		= & JFactory::getACL();
		$uri 		= & JFactory::getURI();
		$user 		= & JFactory::getUser();
		$db			= & JFactory::getDBO();
		
		$pane 		= & JPane::getInstance('tabs');
		
		$editor =& JFactory::getEditor();
				
		$document->addStyleSheet('components/com_photomapgallery/assets/css/photomapgallery.css');

		$document->addScript( JURI::base().'components/com_photomapgallery/assets/js/jscolor.js' );
		
		//get data from model
		$model		= & $this->getModel();
		$conf = & $this->get( 'Data');

		$key = $conf->api_key;
		
		//only admins have access to this view
		if ($user->get('gid') < 24) {
			JError::raiseWarning( 'SOME_ERROR_CODE', JText::_( 'ALERTNOTAUTH'));
			$mainframe->redirect( 'index.php?option=com_photomapgallery&view=photomapgallery' );
		}

		// fail if checked out not by 'me'
		if ($model->isCheckedOut( $user->get('id') )) {
			JError::raiseWarning( 'SOME_ERROR_CODE', JText::_( 'EDITED BY ANOTHER ADMIN' ));
			$mainframe->redirect( 'index.php?option=com_photomapgallery&view=photomapgallery' );
		}

		$Lists = array();
		$uploadmethod[] = JHTML::_('select.option',  '0', JText::_( 'Scale' ) );
		$uploadmethod[] = JHTML::_('select.option',  '1', JText::_( 'Crop' ) );

		$Lists['uploadmethod'] = JHTML::_('select.genericlist',   $uploadmethod, 'uploadmethod', '', 'value', 'text', $conf->uploadmethod );
		
		$query = "SELECT * FROM #__g_user_groups";
		$db->setQuery($query);
		$groups = $db->loadObjectList();
		
		foreach($groups as $group) {			
			$grouplist[] = JHTML::_('select.option', $group->name, $group->name );
		}
		$Lists['group'] = JHTML::_('select.genericlist',   $grouplist, 'group', '', 'value', 'text', $conf->group );
			
		if (!$conf->lat)
			$conf->lat = 0;
		if (!$conf->lon)
			$conf->lon = 0;
		if (!$conf->zoom)
			$conf->zoom = 5;
		if (!$conf->maptype)
			$conf->maptype = 'Map';
		
		//Exif tags
		$exifTagsArray = array(
				"resolutionUnit" 		=> "Resolution unit",
			    "FileName" 				=> "Filename",
			    "FileSize" 				=> "Filesize",
			    "FileDateTime" 			=> "File Date",
			    "FlashUsed" 			=> "Flash used",
			    "imageDesc" 			=> "Image description",                              
			    "make" 					=> "Camera make",
			    "model" 				=> "Camera model",
			    "xResolution" 			=> "X Resolution",
			    "yResolution" 			=> "Y Resolution",
			    "software" 				=> "Software used",
			    "fileModifiedDate" 		=> "File modified date",
			    "YCbCrPositioning" 		=> "YCbCrPositioning",
			    "exposureTime" 			=> "Exposure time",
			    "fnumber" 				=> "f-Number",
			    "exposure" 				=> "Exposure",
			    "isoEquiv" 				=> "ISO equivalent",
			    "exifVersion" 			=> "EXIF version",
			    "DateTime" 				=> "Date & time",
			    "dateTimeDigitized" 	=> "Original date",
			    "componentConfig" 		=> "Component config",
			    "jpegQuality" 			=> "Jpeg quality",
			    "exposureBias" 			=> "Exposure bias",
			    "aperture" 				=> "Aperture",
			    "meteringMode" 			=> "Metering Mode",
			    "whiteBalance" 			=> "White balance",
			    "flashUsed" 			=> "Flash used",
			    "focalLength" 			=> "Focal lenght",
			    "makerNote" 			=> "Maker note",
			    "subSectionTime" 		=> "Subsection time",
			    "flashpixVersion" 		=> "Flashpix version",
			    "colorSpace" 			=> "Color Space",
			    "Width" 				=> "Width",
			    "Height" 				=> "Height",
			    "GPSLatitudeRef" 		=> "GPS Latitude reference",
			    "Thumbnail" 			=> "Thumbnail",
			    "ThumbnailSize" 		=> "Thumbnail size",
			    "sourceType" 			=> "Source type",
			    "sceneType" 			=> "Scene type",
			    "compressScheme" 		=> "Compress scheme",
			    "IsColor" 				=> "Color or B&W",
			    "Process" 				=> "Process",
			    "resolution" 			=> "Resolution",
			    "color" 				=> "Color",
			    "jpegProcess" 			=> "Jpeg process"
		);
		//Format selected items
		$exifSelected = explode("|", $conf->exifTags);
		foreach ($exifSelected as $select) {
			$exifSelect[] = JHTML::_("select.option",$select,$select);
		}
		//Format values for dropdownbox
		foreach ($exifTagsArray as $key=>$value) {
			$exif[] = JHTML::_("select.option",$key,$key);
		}
		
		// get list of active languages
		$langOptions[] = JHTML::_('select.option',  '-1', JText::_('SELECT DEFAULT LANGUAGE') );
		$systemLanguages = JLanguage::getKnownLanguages(JPATH_SITE);
		
		if ( count($systemLanguages)>0 ) {
			foreach( $systemLanguages as $language )
			{
				$langOptions[] = JHTML::_('select.option',  $language['tag'], $language['name'] );
			}
		}
		
		$Lists['default_language'] = JHTML::_('select.genericlist',  $langOptions, 'default_language', '', 'value', 'text', $conf->default_language );
		
		$box[] = JHTML::_('select.option',  'White', JText::_( 'WHITE' ) );
		$box[] = JHTML::_('select.option',  'Black', JText::_( 'BLACK' ) );

		$Lists['box'] = JHTML::_('select.genericlist',   $box, 'box', '', 'value', 'text', $conf->box );
		
		$frame[] = JHTML::_('select.option',  'None', JText::_( 'NONE' ) );
		$frame[] = JHTML::_('select.option',  'Solid', JText::_( 'SOLID' ) );
		$frame[] = JHTML::_('select.option',  'Polaroid', JText::_( 'POLAROID' ) );
		$frame[] = JHTML::_('select.option',  'Shadow', JText::_( 'SHADOW' ) );
		$frame[] = JHTML::_('select.option',  'Polaroid Shadow', JText::_( 'POLAROID SHADOW' ) );

		$Lists['frame'] = JHTML::_('select.genericlist',   $frame, 'frame', '', 'value', 'text', $conf->frame );
		
		$this->assignRef( 'conf', $conf );
		$this->assignRef( 'imageselect', $imageselect);
		$this->assignRef( 'pane', $pane );
		$this->assignRef( 'editor', $editor );
		$this->assignRef( 'Lists', $Lists );
		$this->assignRef( 'exifSelect', $exifSelect );
		$this->assignRef( 'exif', $exif );
/*		
		echo "<pre>";
		echo "view=";
		print_r($langOptions);
		echo "</pre>";
*/
	}
}
?>
