<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * View class for the PhotoMap Gallery Tag screen
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class photomapgalleryViewTag extends photomapgalleryView {

	function __construct( $config = array() )
	{
		parent::__construct($config);

	}
	
	function displayDefault()
	{
		global $mainframe;

		//initialise variables
		$document	= & JFactory::getDocument();
		$user 		= & JFactory::getUser();

		//get vars
		$cid 		= JRequest::getVar( 'cid' );

		//add css to document
		$document->addStyleSheet('components/com_photomapgallery/assets/css/photomapgallery.css');

		//create the toolbar
		if ( $cid ) {
			JToolBarHelper::title( JText::_( 'EDIT_TAG' ), 'tagedit' );

		} else {
			JToolBarHelper::title( JText::_( 'NEW_TAG' ), 'tagedit' );	
		}
		JToolBarHelper::apply();
		JToolBarHelper::save();
		JToolBarHelper::cancel();


		//Get data from the model
		$model		= & $this->getModel();
		$row     	= & $this->get( 'Tag' );

		// fail if checked out not by 'me'
		if ($row->id) {
			if ($model->isCheckedOut( $user->get('id') )) {
				JError::raiseWarning( 'SOME_ERROR_CODE', $row->name.' '.JText::_( 'EDITED_BY_ANOTHER_ADMIN' ));
				$mainframe->redirect( 'index.php?option=com_photomapgallery&view=tags' );
			}
		}

//		$row->userid = $user->get('id');
		$author=JFactory::getUser($row->userid);
		
		//clean data
		JFilterOutput::objectHTMLSafe( $row, ENT_QUOTES );

		//assign data to template
		$this->assignRef('row'      	, $row);
		$this->assignRef('author'      	, $author);
/*		
		echo "<pre>";
		echo "view=";
		print_r($row);
		echo "</pre>";
*/
	}
}
?>