<?php
/**
 * @version 1.1.0 $Id: user.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class photomapgalleryViewUser extends photomapgalleryView
{

	function __construct( $config = array() )
	{
		parent::__construct($config);

	}
	
	function displayDefault() {
	
		JRequest::setVar('hidemainmenu', 1);
		$model = & $this->getModel();
		$user = $model->getData();
	
		if (JRequest::getInt('userID')) {
			$joomlaUser = & JUser::getInstance(JRequest::getInt('userID'));
		}
		else {
			$joomlaUser = & JUser::getInstance($user->userID);
		}
	
		$user->name = $joomlaUser->name;
		$user->userID = $joomlaUser->id;
		
		$basecat = $model->getBaseCategory($user->userID);
		
		$user->gallerytitle = $basecat[0]->title;
		
		$this->assignRef('row', $user);
		$this->assignRef('basecat', $basecat);
		
		
		$wysiwyg = & JFactory::getEditor();
		$editor = $wysiwyg->display('description', $user->description, '100%', '250', '40', '5', false);
		$this->assignRef('editor', $editor);
	
		$lists = array ();
		$genderOptions[] = JHTML::_('select.option', 'm', JText::_('MALE'));
		$genderOptions[] = JHTML::_('select.option', 'f', JText::_('FAMALE'));
		$lists['gender'] = JHTML::_('select.radiolist', $genderOptions, 'gender','','value','text',$user->gender);
		
		$userGroupOptions=$model->getUserGroups();
		$lists['userGroup']=JHTML::_('select.genericlist', $userGroupOptions, 'group', 'class="inputbox"', 'id', 'name', $user->group);
		
		$this->assignRef('lists', $lists);
	
		$params = & JComponentHelper::getParams('com_photomapgallery');
		$this->assignRef('params', $params);

		//create the toolbar
		if ( $cid ) {
			JToolBarHelper::title( JText::_( 'EDIT USER' ), 'user' );
		} else {
			JToolBarHelper::title( JText::_( 'NEW USER' ), 'user' );
		}
		JToolBarHelper::save();
		JToolBarHelper::apply();
		JToolBarHelper::cancel();
		$toolbar=JToolBar::getInstance('toolbar');
		$toolbar->prependButton('Link', 'edit', JText::_('EDIT JOOMLA USER'), JURI::base().'index.php?option=com_users&view=user&task=edit&cid[]='.$user->userID);
/*
		echo "<pre>";
		echo "view=";
		print_r($basecat[0]->id);
		echo "</pre>";*/
	}

}
