<?php
/**
 * @version 1.1.0 $Id: users.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
defined('_JEXEC') or die();
jimport( 'joomla.application.component.view' );
jimport( 'joomla.filesystem.file' ); 

class photomapgalleryViewUsers extends photomapgalleryView
{
	function __construct( $config = array() )
	{
		parent::__construct($config);

	}
	
	function displayDefault() {
		global $mainframe;
		$option = JRequest::getCmd('option');
		$view = JRequest::getCmd('view');
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest($option.$view.'.limitstart', 'limitstart', 0, 'int');
		$filter_order = $mainframe->getUserStateFromRequest($option.$view.'filter_order', 'filter_order', '', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option.$view.'filter_order_Dir', 'filter_order_Dir', '', 'word');
		$filter_status = $mainframe->getUserStateFromRequest($option.$view.'filter_status', 'filter_status', -1, 'int');
		$filter_group = $mainframe->getUserStateFromRequest($option.$view.'filter_group', 'filter_group', 1, 'filter_group');
		$filter_group_pm = $mainframe->getUserStateFromRequest($option.$view.'filter_group_pm', 'filter_group_pm', '', 'filter_group_pm');
		$search = $mainframe->getUserStateFromRequest($option.$view.'search', 'search', '', 'string');
		$search = JString::strtolower($search);

		JToolBarHelper::title( JText::_( 'GALLERY USERS' ), 'user' );
		JToolBarHelper::editList();
		JToolBarHelper::deleteList(JText::_('ARE YOU SURE RESET USER'), 'remove', JText::_('RESET USER DETAILS'));
		
		$model = & $this->getModel();
	
//		$users = $model->get('Data');
		$users = & $this->get( 'Data');
	
		for ($i=0; $i<sizeof($users); $i++){
			
			$users[$i]->loggedin = $model->checkLogin($users[$i]->id);
			$users[$i]->profileID = $model->hasProfile($users[$i]->id);
		
			if ($users[$i]->lastvisitDate == "0000-00-00 00:00:00") {
				$users[$i]->lvisit = JText::_('NAVER');
			}
			else {
				$users[$i]->lvisit = JHTML::_('date', $users[$i]->lastvisitDate, '%Y-%m-%d %H:%M:%S');
			}
		
			if ($users[$i]->profileID) {
				$users[$i]->link = JRoute::_('index.php?option=com_photomapgallery&view=user&cid='.$users[$i]->profileID);
			}
			else {
				$users[$i]->link = JRoute::_('index.php?option=com_photomapgallery&view=user&userID='.$users[$i]->id);
			}
			
		}
		
		$this->assignRef('rows', $users);

		$total		= & $this->get( 'Total');
		$pageNav 	= & $this->get( 'Pagination' );

	
		$lists = array ();
		$lists['search'] = $search;
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
	
		$filter_status_options[] = JHTML::_('select.option', -1, JText::_('SELECT STATE'));
		$filter_status_options[] = JHTML::_('select.option', 0, JText::_('ENABLED'));
		$filter_status_options[] = JHTML::_('select.option', 1, JText::_('BLOCKED'));
		$lists['status'] = JHTML::_('select.genericlist', $filter_status_options, 'filter_status', 'onchange="this.form.submit();"', 'value', 'text', $filter_status);
	
		$userGroups = $model->getUserGroups();
		
		$groups[] = JHTML::_('select.option', '0', JText::_('SELECT JOOMLA GROUP'));
	
		foreach ($userGroups as $userGroup) {
			$groups[] = JHTML::_('select.option', $userGroup->value, JText::_($userGroup->text));
		}
	
		$lists['filter_group'] = JHTML::_('select.genericlist', $groups, 'filter_group', 'onchange="this.form.submit();"', 'value', 'text', $filter_group);
	
	
		$pmuserGroups = $model->getUserGroups('pm');
		$pmgroups[] = JHTML::_('select.option', '0', JText::_('SELECT PHOTOMAP GROUP'));
	
		foreach ($pmuserGroups as $pmuserGroup) {
			$pmgroups[] = JHTML::_('select.option', $pmuserGroup->id, $pmuserGroup->name);
		}
	
		$lists['filter_group_pm'] = JHTML::_('select.genericlist', $pmgroups, 'filter_group_pm', 'onchange="this.form.submit();"', 'value', 'text', $filter_group_pm);
	
		$this->assignRef('lists', $lists);
		$this->assignRef('page', $pageNav);
		
/*
echo "<pre>";
echo "view=";
print_r($users);
echo "</pre>";
*/
	}
}
?>
