<?php
/**
 * @version 1.1 beta $Id: photomapgallery.helper.php 2009-12-28 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im - www.photoindochina.com
 * @license GNU/GPL v2
 * 
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

class gallery_html
{
	function maingallery($userid, $link, $icon)
	{
		JHTML::_('behavior.tooltip');

		$image = JText::_( 'MAIN GALLERY' ) .'&nbsp;';

		$author = JFactory::getUser($userid);		
		$overlib = JText::_( 'GO TO' ) .'&nbsp;'.$author->name.JTEXT::_("'S").'&nbsp;';
	
		$overlib .= JText::_( 'MAINGALLERY TIP' );
		$text = JText::_( 'MAINGALLERY' );

		$output	= '<a href="'.JRoute::_($link).'" class="maingallerytip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

		return $output;
	}
	
	function showMenu()
	{
		$user	= & JFactory::getUser();

		if ($user->authorize('com_photomapgallery', 'edit')) {
		
			JHTML::_('behavior.tooltip');

			$image = '|&nbsp;'. JText::_( 'USER PANEL' ).'&nbsp;';

			$overlib = JText::_( 'USER PANEL TIP' );
			$text = JText::_( 'USER PANEL' );

			$link 	= JRoute::_('index.php?option=com_photomapgallery&amp;view=user');
			$output	= '<a href="'.JRoute::_($link).'" class="editlinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

			return $output;
		}
		
		return;
	}
	
	function showProfile($userid)
	{
		JHTML::_('behavior.tooltip');

		$image = '|&nbsp;'. JText::_( 'PROFILE' );

		$overlib = JText::_( 'PROFILE TIP' );
		$text = JText::_( 'PROFILE' );

		$link 	='index.php?option=com_photomapgallery&amp;view=profile&userid='.$userid;

		$output	= '<a href="'.JRoute::_($link).'" class="profilelinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

		return $output;
	}
	/**
	 * Creates the print button
	 *
	 * @param string $print_link
	 * @param array $params
	 * @since 1.0
	 */
	function printbutton( $print_link, $show, $icon )
	{
		if ($show == true) {

			JHTML::_('behavior.tooltip');

			$status = 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no';

			// checks template image directory for image, if non found default are loaded
			if ( $icon == true ) {
				$image = JHTML::_('image.site', 'printButton.png', 'images/M_images/', NULL, NULL, JText::_( 'PRINT' ));
			} else {
				$image = '|&nbsp;'. JText::_( 'PRINT' ) .'&nbsp;';
			}

			if (JRequest::getInt('pop')) {
				//button in popup
				$output = '<a href="#" onclick="window.print();return false;">'.$image.'</a>';
			} else {
				//button in view
				$overlib = JText::_( 'PRINT TIP' );
				$text = JText::_( 'PRINT' );

				$output	= '<a href="'. JRoute::_($print_link) .'" class="printlinktip hasTip" onclick="window.open(this.href,\'win2\',\''.$status.'\'); return false;" title="'.$text.'::'.$overlib.'">'.$image.'</a>';
			}

			return $output;
		}
		return;
	}

	/**
	 * Creates the email button
	 *
	 * @param string $print_link
	 * @param array $params
	 * @since 1.0
	 */
	function mailbutton($view, $slug = null, $itemslug = null, $show, $icon )
	{
		if ($show ==  true) {

			JHTML::_('behavior.tooltip');
			$uri    =& JURI::getInstance();
			$base  	= $uri->toString( array('scheme', 'host', 'port'));
			
			//TODO: clean this static stuff (Probs when determining the url directly with subdomains)
			if($view == 'category') {
				$link 	= $base.JRoute::_( 'index.php?view='.$view.'&cid='.$slug, false );
			} elseif($view == 'photogallery') {
				$link 	= $base.JRoute::_( 'index.php?view='.$view.'&cid='.$slug.'&id='.$itemslug, false );
			} elseif($view == 'tags') {
				$link 	= $base.JRoute::_( 'index.php?view='.$view.'&id='.$slug, false );
			} else {
				$link 	= $base.JRoute::_( 'index.php?view='.$view, false );
			}
			$url 	= 'index.php?option=com_mailto&tmpl=component&link='.base64_encode( $link );
			$status = 'width=400,height=300,menubar=yes,resizable=yes';

			if ($icon == true) 	{
				$image = JHTML::_('image.site', 'emailButton.png', 'images/M_images/', NULL, NULL, JText::_( 'EMAIL' ));
			} else {
				$image = '|&nbsp;'. JText::_( 'EMAIL' ) .'&nbsp;';
			}

			$overlib = JText::_( 'EMAIL TIP' );
			$text = JText::_( 'EMAIL' );

			$output	= '<a href="'. JRoute::_($url) .'" class="maillinktip hasTip" onclick="window.open(this.href,\'win2\',\''.$status.'\'); return false;" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

			return $output;
		}
		return;
	}

	
	
	/**
	 * Creates the edit button
	 *
	 * @param int $id
	 * @param array $params
	 * @since 1.0
	 */
	function editbutton( $item, $id, $icon)
	{
		$user	= & JFactory::getUser();

		if ($user->authorize('com_photomapgallery', 'edit') && $id == $user->get('id') ) {

			JHTML::_('behavior.tooltip');

			if ( $icon == true ) {
				$image = JHTML::_('image.site', 'edit.png', 'images/M_images/', NULL, NULL, JText::_( 'EDIT' ));
			} else {
				$image = '|&nbsp;'. JText::_( 'EDIT' ) .'&nbsp;';
			}
			$overlib = JText::_( 'EDIT TIP' );
			$text = JText::_( 'EDIT' );

			$link 	= 'index.php?view=photogallery&cid='.$item->categoryslug.'&id='.$item->slug.'&task=edit';
			$output	= '<a href="'.JRoute::_($link).'" class="editlinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

			return $output;
		}
		return;
	}

	/**
	 * Creates the add button
	 *
	 * @param array $params
	 * @since 1.0
	 */
	function addbutton($id, $icon)
	{
		$user	= & JFactory::getUser();

		if ($user->authorize('com_photomapgallery', 'add') && $id == $user->get('id')) {

			JHTML::_('behavior.tooltip');

			if ( $icon == true ) {
				$image = JHTML::_('image.site', 'add.png', 'components/com_photomapgallery/assets/images/', NULL, NULL, JText::_( 'ADD' ));
			} else {
				$image = '|&nbsp;'. JText::_( 'ADD' ) .'&nbsp;';
			}
			$overlib = JText::_( 'ADD TIP' );
			$text = JText::_( 'ADD' );

			$link 	= 'index.php?view=photogallery&task=add';
			$output	= '<a href="'.JRoute::_($link).'" class="editlinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

			return $output;
		}
		return;
	}

	function add_category_button(&$params)
	{
		$user	= & JFactory::getUser();
		$auth =& JFactory::getACL();
		$auth->addACL('com_photomapgallery', 'add', 'users', 'Registered');
		
		$user	= & JFactory::getUser();

//		if ($user->authorize('com_photomapgallery', 'add')) {

			JHTML::_('behavior.tooltip');

			if ( $config->show_menuicon ) {
				$image = JHTML::_('image.site', 'add.png', 'components/com_photomapgallery/assets/images/', NULL, NULL, JText::_( 'ADD CATEGORY' ));
			} else {
				$image = '|&nbsp;'. JText::_( 'ADD CATEGORY' ) .'&nbsp;';
			}
			$overlib = JText::_( 'ADD CATEGORY TIP' );
			$text = JText::_( 'ADD CATEGORY' );

			$link 	= 'index.php?view=usergallery&task=add_category';
			$output	= '<a href="'.JRoute::_($link).'" class="editlinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

			return $output;
//		}
		return;
	}
	
	function edit_category_button($item, &$params)
	{
		$config  	= & GUtil::config();
		$user	= & JFactory::getUser();

		if ($user->authorize('com_photomapgallery', 'edit') && $item->userid == $user->get('id')) {

			JHTML::_('behavior.tooltip');

			$image = '|&nbsp;'. JText::_( 'EDIT CATEGORY' ) .'&nbsp;';

			$overlib = JText::_( 'EDIT CATEGORY TIP' );
			$text = JText::_( 'EDIT CATEGORY' );

			$link 	= 'index.php?view=usergallery&cid='.$item->slug.'&task=edit_category';
			$output	= '<a href="'.JRoute::_($link).'" class="editlinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

			return $output;
		}
		return;
	}
	
	function delete_category_button($item, &$params)
	{
		$user	= & JFactory::getUser();

		if ($user->authorize('com_photomapgallery', 'delete') && $item->userid == $user->get('id')) {

			JHTML::_('behavior.tooltip');

//			if ( $params->get('show_icons') ) {
//				$image = JHTML::_('image.site', 'delete.png', 'images/M_images/', NULL, NULL, JText::_( 'DELETE CATEGORY' ));
//			} else {
				$image = '|&nbsp;'. JText::_( 'DELETE CATEGORY' ) .'&nbsp;'. JText::_( 'ICON_SEP' );
//			}
			$overlib = JText::_( 'DELETE CATEGORY TIP' );
			$text = JText::_( 'DELETE CATEGORY' );

			$link 	= 'index.php?view=photogallery&cid='.$item->slug.'&task=delete_category';
			$output	= '<a href="'.JRoute::_($link).'" class="deletelinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

			return $output;
		}
		return;
	}
	
	function vote($item)
	{
		if ($item->rate > 0) {
			$result = number_format((intval($item->rate_sum) / intval($item->rate)) * 20, 2);
		}
		else {
			$result = "0";
		}
  
		echo "
		<script type=\"text/javascript\">
		<!--
		var sfolder = '" . JURI::base(true) . "';
		var vote_msg=Array('".JTEXT::_('YOUR BROWSER NOT SUPPORT')."','" . JTEXT::_('LOADING') . "','" . JTEXT::_('THANK YOU FOR VOTING') . "','" . JTEXT::_('YOU HAVE ALREADY RATED THIS ITEM') . "','" . JTEXT::_('VOTES') . "','" . JTEXT::_('VOTES') . "');
		-->
		</script>";
		$counter = - 1;

		$html = "
		<div class=\"vote-container\">
			<ul class=\"vote-stars\">
				<li id=\"rating_" . $item->id . "\" class=\"current-rating\" style=\"width:" . (int) $result . "%;\"></li>
				<li><a href=\"javascript:void(null)\" onclick=\"javascript:vote(" . $item->id . ",1," . $item->rate_sum . "," . $item->rate . "," . $counter . ");\" title=\"" . JTEXT::_('VERY POOR') . "\" class=\"one-star\">1</a></li>
				<li><a href=\"javascript:void(null)\" onclick=\"javascript:vote(" . $item->id . ",2," . $item->rate_sum . "," . $item->rate . "," . $counter . ");\" title=\"" . JTEXT::_('POOR') . "\" class=\"two-stars\">2</a></li>
				<li><a href=\"javascript:void(null)\" onclick=\"javascript:vote(" . $item->id . ",3," . $item->rate_sum . "," . $item->rate . "," . $counter . ");\" title=\"" . JTEXT::_('REGULAR') . "\" class=\"three-stars\">3</a></li>
				<li><a href=\"javascript:void(null)\" onclick=\"javascript:vote(" . $item->id . ",4," . $item->rate_sum . "," . $item->rate . "," . $counter . ");\" title=\"" . JTEXT::_('GOOD') . "\" class=\"four-stars\">4</a></li>
				<li><a href=\"javascript:void(null)\" onclick=\"javascript:vote(" . $item->id . ",5," . $item->rate_sum . "," . $item->rate . "," . $counter . ");\" title=\"" . JTEXT::_('VERY GOOD') . "\" class=\"five-stars\">5</a></li>
			</ul>
		</div>
		<span id=\"vote_" . $item->id . "\" class=\"vote-count\">";
		if ($result != "0")
			$html .= '-&nbsp;'.$result;
		$html .= "</span>";
		echo $html;	
	}

	function showSocial($item) {
		$output	= '<div class="itemSocialBlock">';
		$output	.= '<span>'.JText::_('SOCIAL SHARING').'</span>';
		$output	.= '<ul class="itemSocial">' . "\n";
		$output	.= '<li><a class="delicious" title="'.JText::_('ADD TO DELICIOUS').'" href="http://del.icio.us/post?url='.$this->item->socialLink.'&amp;title='.urlencode($this->item->title).'" target="_blank"><span>'.JText::_('ADD TO DELICIOUS').'</span></a></li>' . "\n";
		$output	.= '<li><a class="digg" title="'.JText::_('DIGG THIS').'" href="http://digg.com/submit?url='.$this->item->socialLink.'&amp;title='.urlencode($this->item->title).'" target="_blank"><span>'.JText::_('DIGG THIS').'</span></a></li>' . "\n";
		$output	.= '<li><a class="reddit" title="'.JText::_('ADD TO REDDIT').'" href="http://reddit.com/submit?url='.$this->item->socialLink.'&amp;title='.urlencode($this->item->title).'" target="_blank"><span>'.JText::_('ADD TO REDDIT').'</span></a></li>' . "\n"; 
		$output	.= '<li><a class="stumble" title="'.JText::_('ADD TO STUMBLEUPON').'" href="http://www.stumbleupon.com/submit?url='.$this->item->socialLink.'>&amp;title='.urlencode($this->item->title).'" target="_blank"><span>'.JText::_('ADD TO STUMBLEUPON').'</span></a></li>' . "\n";
		$output	.= '<li><a class="facebook" title="'.JText::_('ADD TO FACEBOOK').'" href="http://www.facebook.com/share.php?u='.$this->item->socialLink.'&amp;t='.urlencode($this->item->title).'" target="_blank"><span>'.JText::_('ADD TO FACEBOOK').'</span></a></li>' . "\n";
		$output	.= '<li><a class="myspace" title="'.JText::_('ADD TO MYSPACE').'" href="http://www.myspace.com/Modules/PostTo/Pages/?l=3&amp;u='.$this->item->socialLink.'&amp;t='.urlencode($this->item->title).'" target="_blank"><span>'.JText::_('ADD TO MYSPACE').'</span></a></li>' . "\n";
		$output	.= '<li><a class="technorati" title="'.JText::_('ADD TO TECHNORATI').'" href="http://www.technorati.com/faves?add='.$this->item->socialLink.'" target="_blank"><span>'.JText::_('ADD TO TECHNORATI').'</span></a></li>' . "\n";
		$output	.= '<li class="clr"></li>' . "\n";
		$output	.= '</ul>' . "\n";
		$output	.= '<div class="clr"></div>' . "\n";
		$output	.= '</div>' . "\n";
		
		echo $output;	
	}
	
	function favoure($item, &$params, $favoured)
	{
		$user	= & JFactory::getUser();

		JHTML::_('behavior.tooltip');

		if ($user->id && $favoured) {
			$image = JHTML::_('image.site', 'heart_delete.png', '../components/com_photomapgallery/assets/images/', NULL, NULL, JText::_( 'REMOVE FAVOURITE' ));

			$overlib = JText::_( 'REMOVE FAVOURITE TIP' );
			$text = JText::_( 'REMOVE FAVOURITE' );

			$link 	= 'index.php?task=removefavourite&catid='.$item->categoryslug.'&itemid='.$item->slug;
			$output	= '<a href="'.JRoute::_($link).'" class="editlinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';
		} elseif($user->id) {
			if ( $params->get('show_icons') ) {
				$image = JHTML::_('image.site', 'heart_add.png', '../components/com_photomapgallery/assets/images/', NULL, NULL, JText::_( 'FAVOURE' ));
			} else {
				$image = JText::_( 'ICON_SEP' ) .'&nbsp;'. JText::_( 'FAVOURE' ) .'&nbsp;'. JText::_( 'ICON_SEP' );
			}
			$overlib = JText::_( 'FAVOURE TIP' );
			$text = JText::_( 'FAVOURE' );

			$link 	= 'index.php?task=addfavourite&catid='.$item->categoryslug.'&itemid='.$item->slug;
			$output	= '<a href="'.JRoute::_($link).'" class="editlinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';
		} else {

			$overlib = JText::_( 'FAVOURE LOGIN TIP' );
			$text = JText::_( 'FAVOURE' );

			if ( $params->get('show_icons') ) {
				$image = JHTML::_('image.site', 'heart_login.png', '../components/com_photomapgallery/assets/images/', NULL, NULL, $text, 'class="editlinktip hasTip" title="'.$text.'::'.$overlib.'"' );
			} else {
				$image = JText::_( 'ICON_SEP' ) .'&nbsp;'. '<span class="editlinktip hasTip" title="'.$text.'::'.$overlib.'">'.$text.'</span>';
			}

			$output	= $image;
		}

		return $output;
	}

	/**
	 * Creates the favourites button
	 *
	 * @param array $params
	 * @since 1.0
	 */
	function favouritesbutton($id, $show, $icon)
	{
		if ($show == true) {
			JHTML::_('behavior.tooltip');

			if ( $icon == true ) {
				$image = JHTML::_('image.site', 'heart.png', 'components/com_photomapgallery/assets/images/', NULL, NULL, JText::_( 'FAVOURITES' ));
			} else {
				$image = '|&nbsp;'. JText::_( 'FAVOURITES' ) .'&nbsp;';
			}
			$author=JFactory::getUser($id);		
			$overlib = $author->name.JTEXT::_("'s ");
		
			$overlib .= JText::_( 'FAVOURITES TIP' );
			$text = JText::_( 'FAVOURITES' );

			$link 	= 'index.php?view=favourites&userid='.$id;
			$output	= '<a href="'.JRoute::_($link).'" class="editlinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

			return $output;
		}
		return;
	}

	/**
	 * Creates the favourite remove button
	 *
	 * @param array $params
	 * @since 1.0
	 */
	function removefavbutton(&$params, $item)
	{
		$user	= & JFactory::getUser();
		JHTML::_('behavior.tooltip');

		if ($user->id) {
			if ($params->get('show_favourites')) {
				JHTML::_('behavior.tooltip');

				if ( $params->get('show_icons') ) {
					$image = JHTML::_('image.site', 'delete.png', 'components/com_photomapgallery/assets/images/', NULL, NULL, JText::_( 'REMOVE FAVOURITE' ));
				} else {
					$image = JText::_( 'ICON_SEP' ) .'&nbsp;'. JText::_( 'FAVOURITES' ) .'&nbsp;'. JText::_( 'ICON_SEP' );
				}
				$overlib = JText::_( 'REMOVE FAVOURITE TIP' );
				$text = JText::_( 'REMOVE FAVOURITE' );

		//		$link 	= 'index.php?task=removefavourite&id='.$item->id;
				$link 	= 'index.php?task=removefavourite&catid='.$item->categoryslug.'&itemid='.$item->slug;
				$output	= '<a href="'.JRoute::_($link).'" class="editlinktip hasTip" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

				return $output;
			}
		}
		return;
	}
	
	function showfullsize($link, $title)
	{
		$user	= & JFactory::getUser();
		JHTML::_('behavior.tooltip');

//		if ($params->get('show_fullsize')) {
			JHTML::_('behavior.tooltip');

			$image = JHTML::_('image.site', 'zoom.png', 'components/com_photomapgallery/assets/images/', NULL, NULL, JText::_( 'SHOW FULL SIZE' ));

			$overlib = JText::_( 'SHOW FULL SIZE TIP' );
			$text = JText::_( 'SHOW FULL SIZE' );

			$output	= '<a class="editlinktip hasTip" href="'.$link.'" rel="lightbox" title="'.$text.'::'.$overlib.'">'.$image.'</a>';

			return $output;
//		}

		return;
	}
	
	function boxtop()
	{
		$output	= '<div id="box">' . "\n";
		$output	.= '<div class="box-container-t">' . "\n";
		$output	.= '<div class="box-tl"></div>' . "\n";
		$output	.= '<div class="box-tr"></div>' . "\n";
		$output	.= '<div class="box-t"></div>' . "\n";
		$output	.= '</div>' . "\n";
		
		$output	.= '<div class="box-l">' . "\n";
		$output	.= '<div class="box-l-ie6"></div>' . "\n";
		$output	.= '<div class="box-r-ie6"></div>' . "\n";
		$output	.= '<div class="box-r">' . "\n";
		$output	.= '<div class="box-m">' . "\n";
		$output	.= '<div class="content">' . "\n";

		return $output;
	}
	
	function boxbottom()
	{
		$output	= '<div style="clear:both;"></div>' . "\n"; 
		$output	.= '</div>' . "\n"; 
		$output	.= '</div>' . "\n";
		$output	.= '</div>' . "\n";
		$output	.= '</div>' . "\n";
		$output	.= '<div class="box-container-b">' . "\n";
		$output	.= '<div class="box-bl"></div>' . "\n";
		$output	.= '<div class="box-br"></div>' . "\n";
		$output	.= '<div class="box-b"></div>' . "\n";
		$output	.= '</div>' . "\n";
		$output	.= '</div>' . "\n";
		
		$output	.= '<div style="clear:both;padding-bottom:10px;"></div>' . "\n";
		return $output;
	}
	
	function boxtop_b()
	{
		$output	= '<div id="box_b">' . "\n";
		$output	.= '<div class="box-b-container-t">' . "\n";
		$output	.= '<div class="box-b-tl"></div>' . "\n";
		$output	.= '<div class="box-b-tr"></div>' . "\n";
		$output	.= '<div class="box-b-t"></div>' . "\n";
		$output	.= '</div>' . "\n";
		
		$output	.= '<div class="box-b-l">' . "\n";
		$output	.= '<div class="box-b-l-ie6"></div>' . "\n";
		$output	.= '<div class="box-b-r-ie6"></div>' . "\n";
		$output	.= '<div class="box-b-r">' . "\n";
		$output	.= '<div class="box-b-m">' . "\n";
		$output	.= '<div class="content">' . "\n";

		return $output;
	}
	
	function boxbottom_b()
	{
		$output	= '<div style="clear:both;"></div>' . "\n"; 
		$output	= '</div>' . "\n"; 
		$output	.= '</div>' . "\n";
		$output	.= '</div>' . "\n";
		$output	.= '</div>' . "\n";
		$output	.= '<div class="box-b-container-b">' . "\n";
		$output	.= '<div class="box-b-bl"></div>' . "\n";
		$output	.= '<div class="box-b-br"></div>' . "\n";
		$output	.= '<div class="box-b-b"></div>' . "\n";
		$output	.= '</div>' . "\n";
		$output	.= '</div>' . "\n";
		
		$output	.= '<div style="clear:both;padding-bottom:10px;"></div>' . "\n";
		return $output;
	}
	
	function getmap($config, $mapdatas, $maptype, $ajaxmap, $have_cat) {
		$lat = $config->lat;
		$lon = $config->lon;
		$zoom = $config->zoom;
		$type = $maptype;
		
		switch ($type) {
			case 'Map':
				$type = G_NORMAL_MAP;
				break;
			case 'Satellite':
				$type = G_SATELLITE_MAP;
				break;
			case 'Hybrid':
				$type = G_HYBRID_MAP;
				break;
			case 'Terrain':
				$type = G_PHYSICAL_MAP;
				break;
		}
		?>

		<script language="javascript" type="text/javascript">
            var map;
            var container;
            var toggle = 0;
        
            var lat;
            var lon;
            var type;
            var title;
            var thumbLink;
            var point;

			function loadMap() {
					
				container = document.getElementById("map_canvas");
		
				var icon = new GIcon();
						   
				lat = <?php echo $lat ?>;
				lon = <?php echo $lon ?>;
				zoom = <?php echo $zoom ?>;
				type = <?php echo $type ?>;
				point = new GLatLng (lat, lon);
				map = new google.maps.Map2(container); 
				map.addControl(new GLargeMapControl3D(), new GControlPosition(G_ANCHOR_TOP_LEFT, new GSize(0,5)));
				map.addControl(new GMenuMapTypeControl(), new GControlPosition(G_ANCHOR_TOP_RIGHT, new GSize(7,7)));
				map.addMapType(G_PHYSICAL_MAP);
				map.addControl(new GScaleControl());
				map.addControl(new GOverviewMapControl());
				map.setCenter(new google.maps.LatLng(lat, lon), zoom, type);
		
				GEvent.addListener(map, "mouseover", function(){
					map.showControls();
				});
				GEvent.addListener(map, "mouseout", function(){
					map.hideControls(); 
				});
	
				// ================= infoOpened LISTENER ===========
				GEvent.addListener(map, "infowindowopen", function()  {
					infoOpened = true;	// set infoOpened to true to change the history text
					Slimbox.scanPage();
				});
		
				// ================= infoClosed LISTENER ===========
				GEvent.addListener(map, "infowindowclose", function()  {
					infoOpened = false;	// set infoOpened to false
				});

		
				var autoCenterBounds = new GLatLngBounds();
				var maxZoom = 0;	
				
				var clusterer = new Clusterer(map); 
				<?php
				if ( $config->category_cluster == 1) { ?>
					clusterer.SetMaxVisibleMarkers(<?php echo $config->cat_cluster_no; ?>);
					clusterer.SetMaxLinesPerInfoBox(<?php echo $config->max_icon_cat; ?>);
				<?php } ?>
		
				var marker; 
				var width;
				var height;
				var ratio;
				var imagelink;
				var itemlink;
				var slimboxlink;
				var logopath = "<?php echo JURI::base() ?>components/com_photomapgallery/assets/images/<?php echo $config->logoimage; ?>";
				var logowidth = <?php echo $config->logowidth; ?>;
				var logoheight = <?php echo $config->logoheight; ?>;
		
				<?php 
				if ($have_cat) {
					for ($i = 0; $i < count($mapdatas); $i++) {
						$mapdata = $mapdatas[$i];
	
						foreach ($mapdata as $data) {
							if (!$data->lat) continue; ?>
							point = new GLatLng(<?php echo $data->lat; ?>, <?php echo $data->lon; ?>);
							<?php
							if ($data->zoom) { ?>
								maxZoom = Math.max(maxZoom, <?php echo $data->zoom ?>);
							<?php } ?>
							autoCenterBounds.extend(point);
	
							<?php if ($data->user_id == 0) {
								$data->user_id = 62; } ?>
							itemlink = "<?php echo JRoute::_(photomapgalleryHelperRoute::getItemRoute($data->slug, $data->catslug)); ?>";
							thumblink = "<?php echo JURI::base() ?>images/photomap/thumb/<?php echo $data->directory; ?>/<?php echo $data->filename; ?>";
							imagelink = "<?php echo JURI::base() ?>images/photomap/resized/<?php echo $data->directory; ?>/<?php echo $data->filename; ?>";
							slimboxlink = "<?php echo JURI::base() ?>images/photomap/album/<?php echo $data->directory; ?>/<?php echo $data->filename; ?>";
					
							CreateMarker(clusterer, <?php echo $data->lat; ?>, <?php echo $data->lon; ?>, "<?php echo $data->title; ?>", thumblink, imagelink, itemlink, slimboxlink, <?php echo $data->zoom; ?>, <?php echo $data->imagewidth; ?>, <?php echo $data->imageheight; ?>, logopath, logowidth, logoheight);
							<?php
						}
					} 
				} else {
				
					foreach ($mapdatas as $item) {
	
						if (!$item->lat || $item->mapdisplay == 0) continue; ?>
						point = new GLatLng(<?php echo $item->lat; ?>, <?php echo $item->lon; ?>);
						<?php
						if ($item->zoom) : ?>
							maxZoom = Math.max(maxZoom, <?php echo $item->zoom ?>);
						<?php endif; ?>
						autoCenterBounds.extend(point);
						
						itemlink = "<?php echo JRoute::_(photomapgalleryHelperRoute::getItemRoute($item->slug, $item->catslug)); ?>";
						thumblink = "<?php echo JURI::base() ?>images/photomap/thumb/<?php echo $item->directory; ?>/<?php echo $item->filename; ?>";
						imagelink = "<?php echo JURI::base() ?>images/photomap/resized/<?php echo $item->directory; ?>/<?php echo $item->filename; ?>";
						slimboxlink = "<?php echo JURI::base() ?>images/photomap/album/<?php echo $item->directory; ?>/<?php echo $item->filename; ?>";
			
						CreateMarker(clusterer, <?php echo $item->lat; ?>, <?php echo $item->lon; ?>, "<?php echo $item->title; ?>", thumblink, imagelink, itemlink, slimboxlink, <?php echo $item->zoom; ?>, <?php echo $item->imagewidth; ?>, <?php echo $item->imageheight; ?>, logopath, logowidth, logoheight);
			<?php		
					}
				}
				?>
				map.setCenter(autoCenterBounds.getCenter(), Math.min(map.getBoundsZoomLevel(autoCenterBounds), maxZoom), type);
			}

			<?php 
			if ($ajaxmap) { ?>
				function loadScript() {
					if (toggle == 0) {
						loadMap();
						
					}
				}
			<?php } else {?>
				function addLoadEvent(func) { 
					var oldonload = window.onload; 
					if (typeof window.onload != 'function'){ 
						window.onload = func
					} else { 
						window.onload = function() {
							oldonload();
							func();
						}
					}
				}
				 
				addLoadEvent(loadMap); 
			<?php } ?>
		
		</script> 
        <?php
	}
}

?>