<?php
/**
 * @version 1.1 beta $Id: controller.php 2009-12-28 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im - www.photoindochina.com
 * @license GNU/GPL v2
 * 
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * PhotoMap Gallery Component Controller
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class photomapgalleryController extends JController
{
	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct()
	{
		parent::__construct();
		
		$this->registerTask( 'cat_orderup', 'cat_orderup' );
		$this->registerTask( 'cat_orderdown', 'cat_orderdown' );
	}

	/**
	 * Display the view
	 */
	function display()
	{
		$user = &JFactory::getUser();	

		if (JRequest::getVar('view') == 'category') {
			parent::display(false);
		} else if (JRequest::getVar('view') == 'imagehandler') {
			$view = & $this->getView('imagehandler', 'html');
			
			// Get/Create the model
			$view->setModel( $this->getModel( 'imagehandler', 'photomapgalleryModel' ), true );
			
			$view->display();
		} else if (JRequest::getVar('view') == 'gallery') {
			$view = & $this->getView('gallery', 'html');
			
			// Get/Create the model
			$view->setModel( $this->getModel( 'gallery', 'photomapgalleryModel' ), true );
			
			$view->display();
		} else if (JRequest::getVar('view') == 'photomapgallery') {
			$view = & $this->getView('photomapgallery', 'html');
			
			// Get/Create the model
			$view->setModel( $this->getModel( 'photomapgallery', 'photomapgalleryModel' ), true );
			
			$view->display();
		} else if (JRequest::getVar('view') == 'user') {
			$view = & $this->getView('user', 'html');
			
			// Get/Create the model
			$view->setModel( $this->getModel( 'user', 'photomapgalleryModel' ), true );
			
			$view->display();
		} else if (JRequest::getVar('view') == 'profile') {
			$view = & $this->getView('profile', 'html');
			
			// Get/Create the model
			$view->setModel( $this->getModel( 'user', 'photomapgalleryModel' ), true );
			
			$this->addModelPath( JPATH_BASE . DS . 'components' . DS . 'com_photomapgallery' . DS . 'models' );
			$view->setModel( $this->getModel( 'category', 'photomapgalleryModel' ));
			$view->setModel( $this->getModel( 'favourites', 'photomapgalleryModel' ));
			
			$view->display();
		} else if (JRequest::getVar('view') == 'photogallery') {
			$view = & $this->getView('photogallery', 'html');
			
			// Get/Create the model
			$view->setModel( $this->getModel( 'galleryitems', 'photomapgalleryModel' ), true );
			
			$this->addModelPath( JPATH_BASE . DS . 'components' . DS . 'com_photomapgallery' . DS . 'models' );
			$view->setModel( $this->getModel( 'comments', 'photomapgalleryModel' ));
			
			$view->setModel( $this->getModel( 'category', 'photomapgalleryModel' ));
			$view->display();
		} else if (JRequest::getVar('view') == 'specialitem') {
			$view = & $this->getView('specialitem', 'html');
			
			// Get/Create the model
			$view->setModel( $this->getModel( 'category', 'photomapgalleryModel' ), true );
			
			$view->display();
		} else if (JRequest::getVar('view') == 'usergallery') {
			$view = & $this->getView('usergallery', 'html');
			
			// Get/Create the model
			$view->setModel( $this->getModel( 'category', 'photomapgalleryModel' ), true );
			
			$view->display();
		} else if (JRequest::getVar('view') == 'favourites') {
			$view = & $this->getView('favourites', 'html');
			
			// Get/Create the model
			$view->setModel( $this->getModel( 'favourites', 'photomapgalleryModel' ), true );
			
			$this->addModelPath( JPATH_BASE . DS . 'components' . DS . 'com_photomapgallery' . DS . 'models' );
			
			$view->setModel( $this->getModel( 'category', 'photomapgalleryModel' ));
			
			$view->display();
		} else if (JRequest::getVar('view') == 'tags') {
			$view = & $this->getView('tags', 'html');
			
			// Get/Create the model
			$view->setModel( $this->getModel( 'tags', 'photomapgalleryModel' ), true );
			
			$view->display();
		} else {

			parent::display(false);
		}
	}

	/**
	* Edits an item
	*
	* @access	public
	* @since	1.0
	*/
	function edit()
	{
		$user	=& JFactory::getUser();

		// Create the view
		$view = & $this->getView('photogallery', 'html');

		//general access check
		if (!($user->authorize('com_photomapgallery', 'edit') || $user->authorize('com_content', 'edit', 'content', 'own'))) {
			JError::raiseError( 403, JText::_("ALERTNOTAUTH") );
		}

		// Get/Create the model
		$model = & $this->getModel('galleryitems');

		//check if we have an id(edit) and check if we have global edit rights or if we are allowed to edit own items.
		if( $model->get('id') > 1 && !($user->authorize('com_photomapgallery', 'edit') || ($user->authorize('com_content', 'edit', 'content', 'own') && $model->get('created_by') == $user->get('id')) ) ) {
			JError::raiseError( 403, JText::_("ALERTNOTAUTH") );
		}

		//checked out?
		if ( $model->isCheckedOut($user->get('id')))
		{
			$msg = JText::sprintf('DESCBEINGEDITTED', JText::_('The item'), $model->get('title'));
			$this->setRedirect(JRoute::_('index.php?view=galleryitems&id='.$model->get('id'), false), $msg);
			return;
		}

		//Checkout the item
		$model->checkout();

		// Push the model into the view (as default)
		$view->setModel($model, true);

		// Set the layout
		$view->setLayout('form');

		// Display the view
		$view->display();
	}
	
	function itemedit()
	{
/*		$user	=& JFactory::getUser();

		// Create the view
		$view = & $this->getView('photogallery', 'html');

		//general access check
		if (!($user->authorize('com_photomapgallery', 'edit') || $user->authorize('com_content', 'edit', 'content', 'own'))) {
			JError::raiseError( 403, JText::_("ALERTNOTAUTH") );
		}

		// Get/Create the model
		$model = & $this->getModel('galleryitems');

		//check if we have an id(edit) and check if we have global edit rights or if we are allowed to edit own items.
		if( $model->get('id') > 1 && !($user->authorize('com_photomapgallery', 'edit') || ($user->authorize('com_content', 'edit', 'content', 'own') && $model->get('created_by') == $user->get('id')) ) ) {
			JError::raiseError( 403, JText::_("ALERTNOTAUTH") );
		}

		//checked out?
		if ( $model->isCheckedOut($user->get('id')))
		{
			$msg = JText::sprintf('DESCBEINGEDITTED', JText::_('The item'), $model->get('title'));
			$this->setRedirect(JRoute::_('index.php?view=user&id='.$model->get('id'), false), $msg);
			return;
		}

		//Checkout the item
		$model->checkout();

		// Push the model into the view (as default)
		$view->setModel($model, true);

		// Set the layout
//		$view->setLayout('form');

		// Display the view
		$view->display();*/
	}
	
	/**
	* adds an item
	*
	* @access	public
	* @since	1.0
	*/
	function add()
	{
		$user	=& JFactory::getUser();

		// Create the view
		$view = & $this->getView('photogallery', 'html');

		//general access check
		if (!$user->authorize('com_photomapgallery', 'add')) {
			$msg = JText::_( 'ALERTNOTAUTH' );
			$this->setRedirect(JRoute::_('index.php?view=photogallery', false), $msg);
		}

		// Get/Create the model
		$model = & $this->getModel('galleryitems');

		// Push the model into the view (as default)
		$view->setModel($model, true);

		// Set the layout
		$view->setLayout('form');

		// Display the view
		$view->display();
	}

	function delete_item()
	{
		$itemid = (int) JRequest::getVar('gid', 0);
		
		$model = $this->getModel('galleryitems');

		if(!$model->removeitem($itemid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
			$msg = JText::_( 'Error Deleting PhotoMap gallery' );
		} else {
			$total 	= count( $itemid );
			$db 	=& JFactory::getDBO();

			$msg 	= $total.' '.JText::_($directory);

			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=user', $msg );
	}
	
	function add_category()
	{
		$user	=& JFactory::getUser();

		// Create the view
		$view = & $this->getView('usergallery', 'html');

		//general access check
		if (!$user->authorize('com_photomapgallery', 'add')) {
			$msg = JText::_( 'ALERTNOTAUTH' );
			$this->setRedirect(JRoute::_('index.php?view=usergallery', false), $msg);
		}

		// Get/Create the model
		$model = & $this->getModel('usergallery');

		// Push the model into the view (as default)
		$view->setModel($model, true);

		// Set the layout
		$view->setLayout('form');

		// Display the view
		$view->display();
	}
	
	function edit_category()
	{
		$user	=& JFactory::getUser();

		// Create the view
		$view = & $this->getView('usergallery', 'html');

		//general access check
		if (!$user->authorize('com_photomapgallery', 'edit')) {
			$msg = JText::_( 'ALERTNOTAUTH' );
			$this->setRedirect(JRoute::_('index.php?view=usergallery', false), $msg);
		}

		// Get/Create the model
		$model = & $this->getModel('usergallery');

		//check if we have an id(edit) and check if we have global edit rights or if we are allowed to edit own items.
		if( $model->get('id') > 1 && !($user->authorize('com_photomapgallery', 'edit') || $model->get('created_by') == $user->get('id') ) ) {
			JError::raiseError( 403, JText::_("ALERTNOTAUTH") );
		}

		//checked out?
		if ($model->isCheckedOut( $user->get('id') )) {
			$this->setRedirect( 'index.php?option=com_photomapgallery&view=usergallery', JText::_( 'EDITED BY ANOTHER ADMIN' ) );
		}

		//Checkout the item
		$model->checkout( $user->get('id') );

		// Push the model into the view (as default)
		$view->setModel($model, true);

		// Set the layout
		$view->setLayout('form');

		// Display the view
		$view->display();
	}
	
	/**
	* Saves the item
	*
	* @access	public
	* @since	1.0
	*/
	function save()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.archive');
		require_once (GALLERY_ADMINISTRATOR.DS.'lib'.DS.'class.upload.php');
		
		// Initialize variables
		$db			= & JFactory::getDBO();
		$user		= & JFactory::getUser();
		$config 	= & GUtil::config();

		//get model
		$model = $this->getModel('galleryitems');

		//get data from request
		$post = JRequest::get('post');

		$cid = $post['cid'];

		//perform access checks
		$isNew = ((int) $post['id'] < 1);

		// Must be logged in
		if ($user->get('id') < 1) {
			JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
			return;
		}

		//access checks
		if ( !(($user->authorize('com_photomapgallery', 'edit') || $user->authorize('com_content', 'edit', 'content', 'own')) || $user->authorize('com_photomapgallery', 'add'))) {
			JError::raiseError( 403, JText::_("ALERTNOTAUTH") );
		}
	
		if (isset($_FILES['front_upload'])){
			$handle = new Upload($_FILES['front_upload']);

			if ($handle->uploaded) {
//				$cid = JRequest::getVar('cid', 0);
		
				$db =& JFactory::getDBO();
		
				$query = 'SELECT c.directory, c.userid'
							. ' FROM #__g_categories AS c'
							. ' WHERE c.id IN ('. $cid .')';
							
				$db->setQuery($query);
				$cat = $db->loadObject();
			
				$directory = $cat->directory;

				$dir =  GALLERY_IMAGES_ORIGINAL.DS.$directory.DS;
		
				if (!file_exists($dir)) {
					mkdir($dir, 0777);
				}

				$handle->jpeg_quality = 100;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;
				$width = $handle->image_src_x;
				$height = $handle->image_src_y;
				$handle->Process($dir);

				$post['filename'] = $handle->file_dst_name;	

				// resized image
				$album_dir =  GALLERY_IMAGES_ALBUM.DS.$directory.DS;
	
				if (!file_exists($album_dir)) {
					mkdir($album_dir, 0777);
				}
		
				$handle->image_resize = true;
				if ($height < $width) {
					$handle->image_ratio_y = true;
					$handle->image_x = $config->width;
				} else {
					$handle->image_ratio_x = true;
					$handle->image_y = $config->width;
				}
				$handle->jpeg_quality = 85;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;

				$handle->Process($album_dir);

				$imagewidth = $handle->image_dst_x;
				$imageheight = $handle->image_dst_y;
				$post['imagewidth'] = $imagewidth;
				$post['imageheight'] = $imageheight;
				
				// resized image
				$resize_dir =  GALLERY_IMAGES_RESIZED.DS.$directory.DS;
	
				if (!file_exists($resize_dir)) {
					mkdir($resize_dir, 0777);
				}
		
				$handle->image_resize = true;
				if ($height < $width) {
					$handle->image_ratio_y = true;
					$handle->image_x = $config->resizewidth;
				} else {
					$handle->image_ratio_x = true;
					$handle->image_y = $config->resizewidth;
				}
				$handle->jpeg_quality = 85;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;
				
				$handle->Process($resize_dir);
				
				// thumb image
				$thumb_dir =  GALLERY_IMAGES_THUMBNAIL.DS.$directory.DS;
	
				if (!file_exists($thumb_dir)) {
					mkdir($thumb_dir, 0777);
				}
		
				$handle->image_resize = true;
				
				if ($config->uploadmethod == 1) {
					$handle->image_ratio_crop = true;
					$handle->image_y = 50;
					$handle->image_x = 50;
				} else {
					if ($height < $width) {
						$handle->image_ratio_y = true;
						$handle->image_x = $config->thumbwidth;
					} else {
						$handle->image_ratio_x = true;
						$handle->image_y = $config->thumbwidth;
					}
				}
				$handle->jpeg_quality = 85;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $file_body;
				
				$handle->Process($thumb_dir);
				
				$handle->Clean();
			/*	
				if (JFile::exists($dir.$data->filename)) {
					JFile::delete($dir.$data->filename);
				}
				
				if (JFile::exists($album_dir.$data->filename)) {
					JFile::delete($album_dir.$data->filename);
				}
				
				if (JFile::exists($resize_dir.$data->filename)) {
					JFile::delete($resize_dir.$data->filename);
				}
				
				if (JFile::exists($thumb_dir.$data->filename)) {
					JFile::delete($thumb_dir.$data->filename);
				} */
			}
		}
		
		if ($model->store($post)) {
			if($isNew) {
				$post['id'] = (int) $model->get('id');
			}
		} else {
			$msg = JText::_( 'ERROR STORING ITEM' );
			JError::raiseError( 500, $model->getError() );
		}

		$model->checkin();

		if ($isNew) {
			$exiflink = 'images/photomap/original/'.$directory.'/'.$filename;
				
			$exifdata = GUtil::showEXIF($post['id'], $exiflink);

			if (is_array($exifdata))
			{
				$txt = array ();
				foreach ($exifdata as $k => $v) {
					$txt[] = "$v";
				}
				$exiftag = implode("\n", $txt);
			}
				
			$model->updateExif($exiftag, $post['id']);
		
			//Get categories for information mail
			$query = 'SELECT DISTINCT c.id, c.title,'
					. ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as slug'
					. ' FROM #__g_categories AS c'
					. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.catid = c.id'
					. ' WHERE rel.itemid = '.(int) $model->get('id')
					;

			$db->setQuery( $query );

			$categories = $db->loadObjectList();

			//loop through the categories to create a string
			$n = count($categories);
			$i = 0;
			$catstring = '';
			foreach ($categories as $category) {
				$catstring .= $category->title;
				$i++;
				if ($i != $n) {
					$catstring .= ', ';
				}
			}

			//get list of admins who receive system mails
			$query = 'SELECT id, email, name' .
					' FROM #__users' .
					' WHERE sendEmail = 1';
			$db->setQuery($query);
			if (!$db->query()) {
				JError::raiseError( 500, $db->stderr(true));
				return;
			}
			$adminRows = $db->loadObjectList();

			require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_messages'.DS.'tables'.DS.'message.php');

			// send email notification to admins
			foreach ($adminRows as $adminRow) {

				//Not really  needed cause in com_message you can set to be notified about new messages by email
				//JUtility::sendAdminMail($adminRow->name, $adminRow->email, '', JText::_('NEW GALLERY ITEM'), $post['title'], $user->get('username'), JURI::base());

				//Send a message to the admins personal message boxes
				$message = new TableMessage($db);
				$message->send($user->get('id'), $adminRow->id, JText::_('NEW GALLERY ITEM'), JText::sprintf('ON NEW ITEM', $post['title'], $user->get('username'), $catstring));
			}

		} else {
			// If the item isn't new, then we need to clean the cache so that our changes appear realtime
			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}

		if ($user->authorize('com_photomapgallery', 'state') )
		{
			$msg = JText::_( 'ITEM SAVED' );
		}
		else
		{
			$msg = $isNew ? JText::_('THANKS SUBMISSION') : JText::_('ITEM SAVED');
		}

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=user&amp;tab=image', $msg );
	}
	
	function save_category()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$user			= & JFactory::getUser();
		$task			= JRequest::getVar('task');
		$post 			= JRequest::get('post');
		$post['userid'] = $user->id;

		$model = $this->getModel('usergallery');
		
		//perform access checks
		$isNew = ($post['id']) ? false : true;

		$cid = (int) JRequest::getVar('cid', 0);
		
		$db 	=& JFactory::getDBO();
		$query = 'SELECT c.title, c.directory'
					. ' FROM #__g_categories AS c'
					. ' WHERE c.id = '. $cid;
					
		$db->setQuery($query);
		$result = $db->loadObject();
		
		$old_dir = $result->directory;
		
		if (!$isNew) {
			$post['id'] = $cid;
		}
		else {
			$post['id'] = (int) $model->get('id');
		}
		
		if ( $model->store($post) ) {
			if($isNew) {
	//			$post['id'] = (int) $model->get('id');
			}
			else {
				if ($result->id)
					$directory = 'gallery-'.$post['userid'].'-'.$result->id;
				else
					$directory = 'gallery-'.$post['userid'].'-'.$model->get('id');
//				JError::raiseError( 500, $directory);
				if ($cid != $model->get('id')) {
					$dir = GALLERY_IMAGES_ORIGINAL.DS.$directory.DS;
		
					if (!file_exists($dir)) {
						mkdir($dir, 0777);
					}
					
					$album_dir = GALLERY_IMAGES_ALBUM.DS.$directory.DS;
				
					if (!file_exists($album_dir)) {
						mkdir($album_dir, 0777);
					}
					
					$resized_dir = GALLERY_IMAGES_RESIZED.DS.$directory.DS;
				
					if (!file_exists($resized_dir)) {
						mkdir($resized_dir, 0777);
					}
					
					$thumb_dir = GALLERY_IMAGES_THUMBNAIL.DS.$directory.DS;
				
					if (!file_exists($thumb_dir)) {
						mkdir($thumb_dir, 0777);
					}
				}
				else {
					rename(GALLERY_IMAGES_ORIGINAL.DS.$old_dir, GALLERY_IMAGES_ORIGINAL.DS.$directory);
					rename(GALLERY_IMAGES_ALBUM.DS.$old_dir, GALLERY_IMAGES_ALBUM.DS.$directory);
					rename(GALLERY_IMAGES_RESIZED.DS.$old_dir, GALLERY_IMAGES_RESIZED.DS.$directory);
					rename(GALLERY_IMAGES_THUMBNAIL.DS.$old_dir, GALLERY_IMAGES_THUMBNAIL.DS.$directory);
	//				$msg .= JText::_( 'CATEGORY NAME CHANGED' );
				}
						
				$cache = &JFactory::getCache('com_photomapgallery');
				$cache->clean();
			}
			
			$msg .= JText::_( 'CATEGORY SAVED' );
			$link 	= 'index.php?option=com_photomapgallery&view=category&cid[]='.$post['id'];
		}
		else {
			$msg 	= JText::_( 'ERROR SAVING CATEGORY' );
			$link 	= 'index.php?option=com_photomapgallery&view=category';
		}
		$model->checkin();

		$this->setRedirect($link, $msg);
	}
	
	function delete_category()
	{
		// Check for request forgeries
//		JRequest::checkToken() or jexit( 'Invalid Token' );

//		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$cid = (int) JRequest::getVar('cid', 0);
//JError::raiseWarning(500, JText::_( $cid ) );
		if ($cid < 1) {
			$msg = '';
			JError::raiseWarning(500, JText::_( 'SELECT ITEM DELETE' ) );
		} else {
			$model = $this->getModel('category');

			$msg = $model->delete($cid);

			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}
		
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=usergallery', $msg );
	}
	
	function save_Comment()
	{
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$db			= & JFactory::getDBO();
		//get model
		JModel::addIncludePath(JPATH_BASE.DS.'components'.DS.'com_photomapgallery'.DS.'models');
		$model = $this->getModel('comments');
		
		//get data from request
		$post = JRequest::get('post');

		$id = JRequest::getVar( 'id', 0, 'post', 'int' );
		$cid = JRequest::getVar( 'cid', 0, 'post', 'int' );
		$pid = JRequest::getVar( 'post_id', 0, 'post', 'int' );
		$cmtid = JRequest::getVar( 'cmtid', 0, 'post', 'int' );
		
		if ($cmtid > 0)
			$id = $cmtid;

		if ($model->store($post)) {
			if(!$id || $id <= 0){
				$id = $db->insertId();
			}
  			$msg = JText::_( 'Comment saved successfully.' );
			$link = JRoute::_('index.php?option=com_photomapgallery&view=photogallery&id='.$pid, false);
			$this->setRedirect($link, $msg);
		} else {
			$msg = JText::_( 'Error Saving comment. Please try after some time.' );
			$link = JRoute::_('index.php?option=com_photomapgallery&view=photogallery&id='.$pid, false);
			$this->setRedirect($link, $msg);
		}
	}

	function delete_comment()
	{
		$id 	= JRequest::getInt( 'id', 0 );
		$cmtid 	= JRequest::getInt( 'cmtid', 0 );

 		// Initialize variables
		$db		=& JFactory::getDBO();

		$query = 'DELETE FROM #__g_comments WHERE id = '.$cmtid;
		$db->setQuery( $query );
		if (!$db->query()) {
			JError::raiseWarning( 500, $db->getError() );
		} 

		$this->setRedirect(JRoute::_('index.php?option=com_photomapgallery&view=photogallery&id='.$id) );
		$this->setMessage( JText::sprintf( 'Comment removed successfully', $n ) );
	}
	/**
	* Cancels an edit item operation
	*
	* @access	public
	* @since	1.0
	*/
	function cancel()
	{
		// Initialize some variables
		$user	= & JFactory::getUser();

		// Get an item table object and bind post variabes to it
		$item = & JTable::getInstance('g_galleryitems', '');
		$item->bind(JRequest::get('post'));

		// todo: add task checks
		if ($user->authorize('com_photomapgallery', 'edit') || $user->authorize('com_photomapgallery', 'edit', 'own')) {
			$item->checkin();
		}

		// If the task was edit or cancel, we go back to the item
		$referer = JRequest::getString('referer', JURI::base(), 'post');
		$this->setRedirect($referer);
	}

	function sendmail()
	{
		jimport('joomla.mail.helper');
		jimport('joomla.utilities.utility');
		$config =& JFactory::getConfig();
		$db =& JFactory::getDBO();
		
		$email = JMailHelper::cleanAddress( JRequest::getVar('email', '') );
		$name = JRequest::getVar('name', '');
		$subject = JRequest::getVar('subject', '') . ' [' .$config->getValue('fromname', '') . ']';
		$message = JRequest::getVar('e_message', '');			
		
		/*verification */
		if ( empty($name) ) {
			JError::raiseWarning( 500, JText::_( 'You must to specify your name'));
			
		} elseif ( !JMailHelper::isEmailAddress($email) ) {
			JError::raiseWarning( 500, JText::sprintf( 'Invalid email', $email ));
			
		} else {
			$reciptient = $tgconf->g_default_mail;
		    
		    if($tgconf->g_send_form_to_agent == 1){
		        
		        $created_by = JRequest::getInt('created_by', 0);
		        $sql = 'SELECT `email` FROM `#__users` WHERE `id`=' . intval($created_by);
		        $db->setQuery($sql);
		        $reciptient = $db->loadResult();
		    }
		    
		    if (empty($reciptient)) {
		        // webmaster email
		        $reciptient = $config->getValue('mailfrom', '');
		    }
			
			$sendOk = JUtility::sendMail($email, $name, $reciptient ,$subject , $message, false);
		   
			if( $sendOk ) {
				
				$mainframe =& JFactory::getApplication();
				$mainframe->enqueueMessage(JText::_('Message successfully sent'));
				
				JRequest::setVar('name', '');
				JRequest::setVar('subject', '');
				JRequest::setVar('email', '');
				JRequest::setVar('e_message', '');
			} else {
				JError::raiseWarning( 500, JText::_( 'SENDMAIL_ERROR_MSG'));
				
			}
		}		
		$this->display();
	}
	
	
	/**
	 * Logic to change the state
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function unpublish_item()
	{
		$gid 	= JRequest::getInt( 'gid', 0 );

		$model = $this->getModel('galleryitems');

		if(!$model->setitemstate($gid, 0)) {
			JError::raiseError( 500, $model->getError() );
		}
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();
	}

	function publish_item()
	{
		$gid 	= JRequest::getInt( 'gid', 0 );

		$model = $this->getModel('galleryitems');

		if(!$model->setitemstate($gid, 1)) {
			JError::raiseError( 500, $model->getError() );
		}
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();
	}

	function vote() 
	{
		$db = & JFactory::getDBO();
		$rating = JRequest::getVar('rating', 'post');
		$id = JRequest::getVar('id', 0, 'get', 'int');
		if (($rating >= 1) && ($rating <= 5)) {
			$vip = $_SERVER['REMOTE_ADDR'];
			$db->setQuery("SELECT * FROM #__g_votes WHERE vpic = " . (int) $id . " AND vip LIKE '%" . $vip . "%'");
			$row = $db->loadObject();
			if (!$row) {
				$query = "INSERT INTO #__g_votes VALUES ( $id, '$vip' )";
				$db->setQuery($query);
				$db->query() or die($db->stderr());
				$query = "UPDATE #__g_galleryitems SET rate = rate + 1, rate_sum = rate_sum + " . (int) $rating . " WHERE id = " . (int) $id;
				$db->setQuery($query);
				$db->query() or die($db->stderr());
				echo 'thanks';
				exit;
			}
			else {
				echo 'voted';
				exit;
			}
		}
	}
 
 	function ajaxfav()
	{
		global $mainframe;
		$user 	=& JFactory::getUser();
		$id 	=  JRequest::getInt('id', 0);
		$db  	=& JFactory::getDBO();
		$model 	=  $this->getModel('galleryitems');

		if (!$user->get('id'))
		{
			echo 'login';
		}
		else
		{
			$isfav = $model->getFavoured();

			if ($isfav)
			{
				$model->removefav();
				$favs 	= $model->getFavourites();
				if ($favs == 0) {
					echo 'removed';
				} else {
					echo '-'.$favs;
				}
			}
			else
			{
				$model->addfav();
				$favs 	= $model->getFavourites();
				if ($favs == 0) {
					echo 'added';
				} else {
					echo '+'.$favs;
				}
			}
		}
	}

 	function addfavourite()
	{
		$catid 	= JRequest::getInt('catid', 0);
		$itemid	= JRequest::getInt('itemid', 0);
		
		$model 	= $this->getModel('galleryitems');
		if ($model->addfav($itemid)) {
			$msg = JText::_('FAVOURITE ADDED');
		} else {
			JError::raiseError( 500, $model->getError() );
			$msg = JText::_('FAVOURITE NOT ADDED');
		}
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();

		$this->setRedirect(JRoute::_('index.php?view=photogallery&cid='.$catid.'&id='. $itemid, false), $msg );

		return;
	}
	
	function removefavourite()
	{
		$catid 	= JRequest::getInt('catid', 0);
		$itemid	= JRequest::getInt('itemid', 0);

		$model 	= $this->getModel('galleryitems');
		if ($model->removefav($itemid)) {
			$msg = JText::_( 'FAVOURITE_REMOVED' );
		} else {
			JError::raiseError( 500, $model->getError() );
			$msg = JText::_( 'FAVOURITE_NOT_REMOVED' );
		}
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();
		
		if ($catid) {
			$this->setRedirect(JRoute::_('index.php?view=photogallery&cid='.$catid.'&id='. $itemid, false), $msg );
		} else {
			$this->setRedirect(JRoute::_('index.php?view=favourites', false), $msg );
		}
				
		return;
	}
	
	function save_user()
	{
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.archive');
		require_once (GALLERY_ADMINISTRATOR.DS.'lib'.DS.'class.upload.php');
		
		// Initialize variables
		$user = & JFactory::getUser();

		$catid = (int) JRequest::getVar('catid', 0);
		
		$post = JRequest::get( 'post' );
		$post['description'] = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$directory = $post['gallerytitle'].'-'.$user->id;

		$db 	=& JFactory::getDBO();
		$query = 'SELECT c.id, c.directory'
					. ' FROM #__g_categories AS c'
					. ' WHERE c.id = '. $catid;
					
		$db->setQuery($query);
		$result = $db->loadResult();
		
		$old_dir = $result->directory;
		
		$model = $this->getModel('user');
	
		if (isset($_FILES['avatar_file'])){
			$typeimg = $_FILES['avatar_file']['type'];
			if (!empty($typeimg)) {	
				if($typeimg == 'image/jpeg'){$ext='.jpg';}else{$ext= '.'.substr($typeimg, strlen($typeimg) - 3); }
				$filename = 'user_'.$post['id'].$ext;
				$post['avatar'] = $filename;	
			}
		}

		if (isset($_FILES['avatar_file'])){
			$handle = new Upload($_FILES['avatar_file']);

			if ($handle->uploaded) {


				$dir =  GALLERY_IMAGES_AVATAR.DS;
		
				if (!file_exists($dir)) {
					mkdir($dir, 0777);
				}

				$handle->jpeg_quality = 100;
				$handle->image_resize = true;
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = 'user_'.$post['id'];
				$width = $handle->image_src_x;
				$height = $handle->image_src_y;
				if ($height < $width) {
					$handle->image_ratio_y = true;
					$handle->image_x = 50;
				} else {
					$handle->image_ratio_x = true;
					$handle->image_y = 50;
				}
				$handle->Process($dir);

				$handle->Clean();

			}
		}
		
		if ( $model->store($post) ) {
			$link = 'index.php?option=com_photomapgallery&view=user';
			$msg = JText::_( 'Saved user information');

			$cat = $model->getMainCategory($user->id);

			if ($result->id)
				$directory = 'gallery-'.$user->id.'-'.$result->id;
			else
				$directory = 'gallery-'.$user->id.'-'.$cat->id;
			
			$query = 'UPDATE #__g_categories SET `directory` = ' . $db->quote($directory). ' WHERE `id` = '.$cat->id;
			$db->setQuery($query);
			if(!$db->query()) {
				JError::raiseWarning(500, JText::_( $db->getErrorMsg() ) );
				return false;
			}
			
			if ($catid == $cat->id && $old_dir != $directory) {
				rename(GALLERY_IMAGES_ORIGINAL.DS.$old_dir, GALLERY_IMAGES_ORIGINAL.DS.$directory);
				rename(GALLERY_IMAGES_ALBUM.DS.$old_dir, GALLERY_IMAGES_ALBUM.DS.$directory);
				rename(GALLERY_IMAGES_RESIZED.DS.$old_dir, GALLERY_IMAGES_RESIZED.DS.$directory);
				rename(GALLERY_IMAGES_THUMBNAIL.DS.$old_dir, GALLERY_IMAGES_THUMBNAIL.DS.$directory);
			}
			else {
				$dir = GALLERY_IMAGES_ORIGINAL.DS.$directory.DS;
	
				if (!file_exists($dir)) {
					mkdir($dir, 0777);
				}
				
				$album_dir = GALLERY_IMAGES_ALBUM.DS.$directory.DS;
			
				if (!file_exists($album_dir)) {
					mkdir($album_dir, 0777);
				}
				
				$resized_dir = GALLERY_IMAGES_RESIZED.DS.$directory.DS;
			
				if (!file_exists($resized_dir)) {
					mkdir($resized_dir, 0777);
				}
				
				$thumb_dir = GALLERY_IMAGES_THUMBNAIL.DS.$directory.DS;
			
				if (!file_exists($thumb_dir)) {
					mkdir($thumb_dir, 0777);
				}
			}
		}
		else {
			$link = 'index.php?option=com_photomapgallery&view=user';
			$msg = JText::_( 'Failed saving user information');
		}
		
		$this->setRedirect($link, $msg);
	}
	
	function save_usercategory()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$user			= & JFactory::getUser();
		$task			= JRequest::getVar('task');
		$post 			= JRequest::get('post');

		//perform access checks
		$isNew = ($post['id']) ? false : true;

//		$catid = (int) JRequest::getVar('catid', 0);
		
		$db 	=& JFactory::getDBO();
		$query = 'SELECT c.id, c.directory'
					. ' FROM #__g_categories AS c'
					. ' WHERE c.id = '.$post['id'];
					
		$db->setQuery($query);
		$result = $db->loadObject();
		
		$old_dir = $result->directory;

		$model = $this->getModel('usergallery');
		
		$catid = $model->store($post);
		if ( $catid ) {

			if ($result->id)
				$directory = 'gallery-'.$user->id.'-'.$result->id;
			else
				$directory = 'gallery-'.$user->id.'-'.$catid;
			
			$query = 'UPDATE #__g_categories SET `directory` = ' . $db->quote($directory). ' WHERE `id` = '.$catid;
			$db->setQuery($query);
			if(!$db->query()) {
				JError::raiseWarning(500, JText::_( $db->getErrorMsg() ) );
				return false;
			}
			
			if($isNew) {
				$dir = GALLERY_IMAGES_ORIGINAL.DS.$directory.DS;
		
				if (!file_exists($dir)) {
					mkdir($dir, 0777);
				}
//				JError::raiseError( 500, $dir );	
				$album_dir = GALLERY_IMAGES_ALBUM.DS.$directory.DS;
			
				if (!file_exists($album_dir)) {
					mkdir($album_dir, 0777);
				}
				
				$resized_dir = GALLERY_IMAGES_RESIZED.DS.$directory.DS;
			
				if (!file_exists($resized_dir)) {
					mkdir($resized_dir, 0777);
				}
				
				$thumb_dir = GALLERY_IMAGES_THUMBNAIL.DS.$directory.DS;
			
				if (!file_exists($thumb_dir)) {
					mkdir($thumb_dir, 0777);
				}
			}
			else {
				if ($old_dir == $post['title']) {
					rename(GALLERY_IMAGES_ORIGINAL.DS.$old_dir, GALLERY_IMAGES_ORIGINAL.DS.$directory);
					rename(GALLERY_IMAGES_ALBUM.DS.$old_dir, GALLERY_IMAGES_ALBUM.DS.$directory);
					rename(GALLERY_IMAGES_RESIZED.DS.$old_dir, GALLERY_IMAGES_RESIZED.DS.$directory);
					rename(GALLERY_IMAGES_THUMBNAIL.DS.$old_dir, GALLERY_IMAGES_THUMBNAIL.DS.$directory);
				}
				else {
					$dir = GALLERY_IMAGES_ORIGINAL.DS.$directory.DS;
		
					if (!file_exists($dir)) {
						mkdir($dir, 0777);
					}
					
					$album_dir = GALLERY_IMAGES_ALBUM.DS.$directory.DS;
				
					if (!file_exists($album_dir)) {
						mkdir($album_dir, 0777);
					}
					
					$resized_dir = GALLERY_IMAGES_RESIZED.DS.$directory.DS;
				
					if (!file_exists($resized_dir)) {
						mkdir($resized_dir, 0777);
					}
					
					$thumb_dir = GALLERY_IMAGES_THUMBNAIL.DS.$directory.DS;
				
					if (!file_exists($thumb_dir)) {
						mkdir($thumb_dir, 0777);
					}
				}
						
				$cache = &JFactory::getCache('com_photomapgallery');
				$cache->clean();
			}
			
			$msg .= JText::_( 'CATEGORY SAVED' );
			$link 	= 'index.php?option=com_photomapgallery&view=user&cid[]='.$post['id'].'&amp;tab=category';
		}
		else {
			$msg 	= JText::_( 'ERROR SAVING CATEGORY' );
			$link 	= 'index.php?option=com_photomapgallery&view=user';
		}
		$model->checkin();

		$this->setRedirect($link, $msg);
	}
	
	function delete_usercategory()
	{
		// Check for request forgeries
//		JRequest::checkToken() or jexit( 'Invalid Token' );

		$catid = (int) JRequest::getVar('catid', 0);

		if ($catid == 0) {
			$msg = 'CAN NOT DELETE SELECTED CATEGORY';

		} else {
			$model = $this->getModel('category');

			$msg = $model->delete($catid);

			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}
		
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=user&amp;tab=category', $msg );
	}
	
	function publish_usercategory()
	{
		$catid = (int) JRequest::getVar('catid', 0);
		
		if ($catid <= 0) {
			$msg = '';
			JError::raiseWarning(500, JText::_( 'SELECT ITEM PUBLISH' ) );
		} else {

			$model = $this->getModel('category');

			if(!$model->publish($catid, 1)) {
				JError::raiseError(500, $model->getError());
			}

			$msg 	= JText::_( 'CATEGORY PUBLISHED');
		
			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=user&amp;tab=category', $msg );
	}

	/**
	 * Logic to unpublish categories
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function unpublish_usercategory()
	{
		$catid = (int) JRequest::getVar('catid', 0);

		if ($catid <= 0) {
			$msg = '';
			JError::raiseWarning(500, JText::_( 'SELECT ITEM UNPUBLISH' ) );
		} else {

			$model = $this->getModel('category');

			if(!$model->publish($catid, 0)) {
				JError::raiseError(500, $model->getError());
			}

			$msg 	= JText::_( 'CATEGORY UNPUBLISHED');
		
			$cache = &JFactory::getCache('com_photomapgallery');
			$cache->clean();
		}
		
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=user&amp;tab=category', $msg );
	}

	function cat_orderup()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$model = $this->getModel('user');
		$model->move(-1);
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();
		
		$this->setRedirect( 'index.php?option=com_photomapgallery&view=user&amp;tab=category');
	}

	/**
	 * Logic to orderdown a category
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function cat_orderdown()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$model = $this->getModel('user');
		$model->move(1);
		
		$cache = &JFactory::getCache('com_photomapgallery');
		$cache->clean();

		$this->setRedirect( 'index.php?option=com_photomapgallery&view=user&amp;tab=category');
	}

	function getajaxtags()
	{
		$user = JFactory::getUser();

		if (!$user->authorize('com_photomapgallery', 'newtags')) {
			return;
		}

		$id 	= JRequest::getInt('id', 0);
		$model 	= $this->getModel('galleryitems');
		$tags 	= $model->getAlltags($user->id);

		$used = null;

		if ($id) {
			$used 	= $model->getUsedtags();
		}
		if(!is_array($used)){
			$used = array();
		}

		$rsp = '';
		$n = count($tags);
		for( $i = 0, $n; $i < $n; $i++ ){
			$tag = $tags[$i];

			if( ( $i % 5 ) == 0 ){
				if( $i != 0 ){
					$rsp .= '</div>';
				}
				$rsp .=  '<div class="tagline">';
			}
			$rsp .=  '<span class="tag"><span class="tagidbox"><input type="checkbox" name="tag[]" value="'.$tag->id.'"' . (in_array($tag->id, $used) ? 'checked="checked"' : '') . ' /></span>'.$tag->name.'</span>';
		}
		$rsp .= '</div>';
		$rsp .= '<div class="clear"></div>';
		$rsp .= '<div class="addtag">';
		$rsp .= '<label for="addtags">'.JText::_('ADD TAG').'</label>';
		$rsp .= '<input type="text" id="tagname" class="inputbox" size="30" />';
		$rsp .=	'<input type="button" class="button" value="'.JText::_('ADD TAG BUTTON').'" onclick="addtag()" />';
		$rsp .= '</div>';

		echo $rsp;
	}

	function addtag()
	{
		$user = JFactory::getUser();

		$name 	= JRequest::getString('name', '');

		if ($user->authorize('com_photomapgallery', 'newtags')) {
			$model 	= $this->getModel('galleryitems');
			$model->addtag($name);
		}
		return;
	}
	
	function categoryedit()
	{
		
	}
}
?>