<?php
/**
 * @version 1.1 beta $Id: favourites.php 2009-12-28 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im - www.photoindochina.com
 * @license GNU/GPL v2
 * 
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

// Component Helper
jimport('joomla.application.component.helper');

/**
 * PhotoMap Gallery Component Route Helper
 *
 * @static
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class photomapgalleryHelperRoute
{
	/**
	 * @param	int	The route of the photomapgallery item
	 */
	function getItemRoute($id, $catid = 0)
	{
		$needles = array(
			'item'  => (int) $id,
			'category' => (int) $catid
		);

		//Create the link
		$link = 'index.php?option=com_photomapgallery&amp;view=photogallery';

		if($catid) {
			$link .= '&amp;cid='.$catid;
		}
		
		$link .= '&amp;id='. $id;

		if($item = photomapgalleryHelperRoute::_findItem($needles)) {
			$link .= '&amp;Itemid='.$item->id;
		};

		return $link;
	}

	function getCategoryRoute($catid)
	{
		$needles = array(
			'category' => (int) $catid
		);

		//Create the link
		$link = 'index.php?option=com_photomapgallery&amp;view=category&amp;cid='.$catid;

		if($item = photomapgalleryHelperRoute::_findItem($needles)) {
			$link .= '&amp;Itemid='.$item->id;
		};

		return $link;
	}
	
	function getUserCategoryRoute($catid)
	{
		$needles = array(
			'category' => (int) $catid
		);

		//Create the link
		$link = 'index.php?option=com_photomapgallery&amp;view=usergallery&amp;cid='.$catid;

		if($item = photomapgalleryHelperRoute::_findItem($needles)) {
			$link .= '&amp;Itemid='.$item->id;
		};

		return $link;
	}
	
	function getTagRoute($id)
	{
		$needles = array(
			'tags' => (int) $id
		);

		//Create the link
		$link = 'index.php?option=com_photomapgallery&view=tags&id='.$id;

		if($item = photomapgalleryHelperRoute::_findTag($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}
	
	function getUserRoute($catid)
	{
		$needles = array(
			'user' => (int) (int) $catid
		);

		//Create the link
		$link = 'index.php?option=com_photomapgallery&view=user&cid='.$catid;

		if($item = photomapgalleryHelperRoute::_findItem($needles)) {
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}
	
	function getCommentRoute($id)
	{
		$needles = array(
			'comments' => (int) $id
		);

		//Create the link
		$link = 'index.php?option=com_photomapgallery&amp;view=comments&amp;id='.$id;

		if($item = photomapgalleryHelperRoute::_findItem($needles)) {
			$link .= '&amp;Itemid='.$item->id;
		};

		return $link;
	}
	
	function _findItem($needles)
	{
		$component = & JComponentHelper::getComponent('com_photomapgallery');
	
		$menus	= &JApplication::getMenu('site', array());
		$items	= $menus->getItems('componentid', $component->id);
		$user 	= & JFactory::getUser();
		$access = (int)$user->get('aid');

		$match = null;
		$count = 0;		
		
		foreach($needles as $needle => $id)
		{			
			$count++;
		
			foreach($items as $item)
			{
				//fetch menuitems generic of that item
				if ((@$item->query['view'] == $needle) && (@$item->query['id'] == $id)) {
					$match = $item;
					break;
				}
				
				//ensure that only the second part of the array will go through, otherwise $id will seen as $cid
				if($count == 2) {
					//fetch menuitems which might be linked to a category of that item
					if ((@$item->query['view'] == 'category') && (@$item->query['cid'] == $id)) {
						$match = $item;
						break;
					}
				}

			}
		
			if(isset($match)) {
				break;
			}
		}
		
		//no menuitem exists -> return first possible match
		if(empty($match))
		{
/*			foreach($items as $item)
			{
				if (@$item->published == 1 && @$item->access <= $access && @$item->query['layout'] != 'form') {
					$match = $item;
					break;
				}
			}*/
		}

		return $match;
	}
	
	function _findTag($needles)
	{
		$component =& JComponentHelper::getComponent('com_photomapgallery');

		$menus	= &JApplication::getMenu('site', array());
		$items	= $menus->getItems('componentid', $component->id);

		$match = null;

		foreach($needles as $needle => $id)
		{
			foreach($items as $item)
			{
				if ( (@$item->query['view'] == $needle) && (@$item->query['id'] == $id) ) {
					$match = $item;
					break;
				} else if (@$item->query['view'] == $needle) {
					$match = $item;
					break;
				}
			}

			if(isset($match)) {
				break;
			}
		}

		return $match;
	}

}
?>
