<?php
/**
 * @version		1.1.0 photomapgallery $
 * @package		photomapgallery
 * @copyright	Copyright  2009 - 2010 All rights reserved.
 * @license		GNU/GPL
 * @author		Oh-Taek Im
 * @author mail	pixeldraw@photoindochina.com
 * @website		www.photoindochina.com
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * Hello Model
 *
 * @package    Joomla
 * @subpackage Components
 */
class photomapgalleryModelComments extends JModel
{
	/**
	 * Constructor that retrieves the ID from the request
	 *
	 * @access	public
	 * @return	void
	 */
	function __construct()
	{
		parent::__construct();
		
 	}
	/**
	 * Gets the Gallery Items
	 * @return string The greeting to be displayed to the user
	 */
	function getGalleryItems(  $options=array() )
	{
		$db 		=& JFactory::getDBO();
		$id			= @$options['id'];
		
		// Where conditions
		$wheres[] = 'post.id = ' . (int) $id;
			
		$query	= 	'SELECT post.*, user.name AS postedby
					FROM #__g_galleryitems AS post LEFT JOIN #__users AS user ON post.user_id = user.id
					WHERE post.published = "1" AND '. implode( ' AND ', $wheres );
 		$bloglist = $this->_getList( $query );
		return @$bloglist[0];
	}
	
	/**
	 * Gets the Comment
	 * @return string The greeting to be displayed to the user
	 */
	function getComment()
	{
		$db 		=& JFactory::getDBO();
		$id = JRequest::getVar('id', 0, '', 'int');
		
		// Where conditions
		$wheres[] = 'c.post_id = ' . (int) $id;
				
		$query	= 	'SELECT c.*, user.name AS commentedby, u.avatar
					FROM #__g_comments AS c LEFT JOIN #__users AS user ON c.userid = user.id
					LEFT JOIN #__g_user AS u ON u.userID = c.userid
					LEFT JOIN #__g_user_groups AS g ON g.id = u.group
					WHERE c.published = "1" AND '. implode( ' AND ', $wheres ).' ORDER BY c.date ASC';
 		$commentlist = $this->_getList( $query );
		return @$commentlist;
	}
	
	function getEditComment()
	{
		$db 		=& JFactory::getDBO();
		$cmtid = JRequest::getVar('cmtid', 0, '', 'int');
		
		// Where conditions
		$wheres[] = 'c.id = ' . (int) $cmtid;
				
		$query	= 	'SELECT c.*, user.name AS commentedby
					FROM #__g_comments AS c LEFT JOIN #__users AS user ON c.userid = user.id
					WHERE c.published = "1" AND '. implode( ' AND ', $wheres ).' ORDER BY c.date ASC';
		$db->setQuery($query);
 		$editcomment = $db->loadObject();
		return @$editcomment;
	}
	/**
	 * Method to store a record
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function store($post)
	{	
//		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_photomapgallery'.DS.'tables');
//		$row =& JTable::getInstance('g_comments', 'Table');

		$userid = JRequest::getVar( 'userid', '', 'post', 'int' );
		$id = $post['id'];
		$user = JFactory::getUser();
		
		if(trim($user->id) == '' || $user->id <= 0){
			$msg = JText::_( '&nbsp; Please login to write comment' );
			$link = JRoute::_('index.php?option=com_photomapgallery&view=photogallery&id='.$id, false);
			$this->setRedirect( $link, $msg );  return;
		}
		
		$row =& $this->getTable('g_comments', '');
/*		$data = JRequest::get( 'post' );
		$data['description'] = JRequest::getVar('description', '', 'post', 'string', 2);
		$data['published'] = 1;
		$date = JFactory::getDate();
		$data['date'] = $date->toMySQL();
		$data['update'] = $date->toMySQL();
*/		
		$data = $post;
		$data['id'] = $post['cmtid'];
		$data['description'] = $post['description'];
		$data['published'] = 1;
		$date = JFactory::getDate();
		$data['date'] = $date->toMySQL();
		$data['update'] = $date->toMySQL();
		
		// Bind the form fields to the Add form
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Make sure the Add Blog record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the post details table to the database
		if (!$row->store()) {
			$this->setError( $row->getErrorMsg() );
			return false;
		}
		return true;
	}
	
	/**
	 * function for Get total Comments
	 **/
	function getTotalComments( $options=array() )
	{
		$db 		=& JFactory::getDBO();
//		$id			= @$options['id'];
		$id = JRequest::getVar('id', 0, '', 'int');
		
		// Where conditions
		$wheres[] = 'c.post_id = ' . (int) $id;
		
		$db		=& JFactory::getDBO();				
		$query	= 	'SELECT COUNT(c.id)
					FROM #__g_comments AS c LEFT JOIN #__users AS user ON c.userid = user.id
					WHERE c.published = "1" AND '. implode( ' AND ', $wheres ).' ORDER BY c.date ASC';
 		$db->setQuery( $query );
		$count = $db->loadResult();
		return $count;
	}
	
	/**
	 * function for Get total Comments
	 **/
	function getTotalHitsofPosts( $options=array() )
	{
		$db 		=& JFactory::getDBO();
		$id			= @$options['id'];
		
		// Where conditions
		$wheres[] = 'post.id = ' . (int) $id;
		
		$db		=& JFactory::getDBO();				
		$query	= 	'SELECT post.post_hits
					FROM #__g_galleryitems AS post
					WHERE post.published = "1" AND '. implode( ' AND ', $wheres );
		$blogpostHit = $this->_getList( $query );
		return @$blogpostHit[0];
	}
	
	/**
	 * function for Get total Comments
	 **/
	function updatePostHits( $options=array() )
	{
		$db 		=& JFactory::getDBO();
		$id			= @$options['id'];
		
		// Where conditions
		$wheres[] = 'id = ' . (int) $id;
		
		$db		=& JFactory::getDBO();				
		$query	= 	'UPDATE #__g_galleryitems SET post_hits = post_hits+1
					WHERE published = "1" AND '. implode( ' AND ', $wheres );
		$db->setQuery( $query );
		if (!$db->query()) {
			//JError::raiseError(500, $db->getErrorMsg() );
		}
	}
 }
?>