<?php
/**
 * @version 1.1 beta $Id: favourites.php 2009-12-28 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im - www.photoindochina.com
 * @license GNU/GPL v2
 * 
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

/**
 * QuickFAQ Component Model
 *
 * @package Joomla
 * @subpackage QuickFAQ
 * @since		1.0
 */
class photomapgalleryModelFavourites extends JModel
{
	/**
	 * Data
	 *
	 * @var mixed
	 */
	var $_data = null;
	
	/**
	 * Items total
	 *
	 * @var integer
	 */
	var $_total = null;

	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct()
	{
		parent::__construct();
		
		global $mainframe;
		$config  	= & GUtil::config();

		// Get the paramaters of the active menu item
		$params = & $mainframe->getParams('com_photomapgallery');

		//get the number of events from database
		$limit			= JRequest::getInt('limit', $config->favmaximage);
		$limitstart		= JRequest::getInt('limitstart');

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
		
		// Get the filter request variables
		$this->setState('filter_order', JRequest::getCmd('filter_order', 'i.title'));
		$this->setState('filter_order_dir', JRequest::getCmd('filter_order_Dir', 'ASC'));
	}
	
	/**
	 * Method to get Data
	 *
	 * @access public
	 * @return object
	 */
	function getData($userid)
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{		
			$query = $this->_buildQuery($userid);
			$this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit') );
		}
		
		return $this->_data;
	}
	
	/**
	 * Total nr of items
	 *
	 * @access public
	 * @return integer
	 */
	function getTotal($userid)
	{
		// Lets load the total nr if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery($userid);
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}
	
	/**
	 * Builds the query
	 *
	 * @access public
	 * @return string
	 */
	function _buildQuery($userid)
	{   	
        // Get the WHERE and ORDER BY clauses for the query
		$where		= $this->_buildItemWhere();
		$orderby	= $this->_buildItemOrderBy();

		$query = 'SELECT DISTINCT f.itemid, i.*, g.name AS groupname, c.title AS cattitle, c.directory,'
				. ' CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(\':\', i.id, i.alias) ELSE i.id END as slug,'
				. ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as categoryslug'
				. ' FROM #__g_galleryitems AS i'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__g_categories AS c ON c.id = rel.catid'
				. ' LEFT JOIN #__g_user AS u ON u.userID = c.userid'
				. ' LEFT JOIN #__g_user_groups AS g ON g.id = u.group'
				. ' LEFT JOIN #__g_favourites AS f ON f.itemid = i.id'
				. $where
				. ' AND f.userid = '.$userid
				. ' GROUP BY i.id'
				. $orderby
				;
				 
         return $query;
	}

	/**
	 * Build the order clause
	 *
	 * @access private
	 * @return string
	 */
	function _buildItemOrderBy()
	{	
		$filter_order		= $this->getState('filter_order');
		$filter_order_dir	= $this->getState('filter_order_dir');

		$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_dir.', i.title';

		return $orderby;
	}
	
	/**
	 * Method to build the WHERE clause
	 *
	 * @access private
	 * @return string
	 */
	function _buildItemWhere( )
	{
		global $mainframe;

		$user		= & JFactory::getUser();
		$gid		= (int) $user->get('aid');
		$params 	= & $mainframe->getParams('com_photomapgallery');

		// First thing we need to do is to select only the requested items
		
		$where .= ' WHERE c.access <= '.$gid;
/*		
		$states = '1, -4';
		if ($user->authorize('com_photomapgallery', 'state')) {
			$states .= ', 0 , -2, -3';
		}*/
		$where .= ' AND i.published = 1';

		/*
		 * If we have a filter, and this is enabled... lets tack the AND clause
		 * for the filter onto the WHERE clause of the item query.
		 */
		if ($params->get('filter'))
		{
			$filter 		= JRequest::getString('filter', '', 'request');

			if ($filter)
			{
				// clean filter variables
				$filter			= $this->_db->getEscaped( trim(JString::strtolower( $filter ) ) );

				$where .= ' AND LOWER( i.title ) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $filter, true ).'%', false );
			}
		}
		return $where;
	}
	
	function getAvatar($userid) {

		$query = 'SELECT avatar'
				. ' FROM #__g_user'
				. ' WHERE userID = '.$userid
				;
		$this->_db->setQuery($query);
		$avatar = $this->_db->loadObjectList();
			
		return $avatar;
	}
}
?>