<?php

/**
 * @version 1.1.0 $Id: user.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * Hello Model
 *
 * @package    Joomla
 * @subpackage Components
 */

class photomapgalleryModelUser extends JModel
{
	var $_id = null;
	
	var $_pagination_cat = null;
	var $_pagination = null;
	
	var $_imagedata = null;
	
	var $_imageitem = null;
	
	var $_imgtotal = null;
	/**
	 * Constructor that retrieves the ID from the request
	 *
	 * @access	public
	 * @return	void
	 */

	function __construct()
	{
		parent::__construct();
		
		global $mainframe, $option;

		$limit		= $mainframe->getUserStateFromRequest( $option.'.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
/*
		$limit_cat		= $mainframe->getUserStateFromRequest( $option.'.limit', 'limit_cat', $mainframe->getCfg('list_limit'), 'int');
		$limitstart_cat = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart_cat', 0, 'int' );

		$this->setState('limit', $limit_cat);
		$this->setState('limitstart', $limitstart_cat);
*/		
		$id = JRequest::getVar('id', 0, '', 'int');
		$this->setId((int)$id);
	}

	function setId($id)
	{
		// Set new tour ID
		$this->_id			= $id;
	}
	
	function getExistUser($userid)
	{
		$query = 'SELECT COUNT(u.id)'
				. ' FROM #__users AS u'
				. ' WHERE u.id = '.$userid;
				
		$this->_db->setQuery( $query );
		$count = $this->_db->loadResult();
			
		if ($count > 0) {
			return true;
		}
		
		return false;
	}
	
	function getExistUserGroup($userid)
	{
		$query = 'SELECT u.group'
				. ' FROM #__g_user AS u'
				. ' WHERE u.userID = '.$userid;
				
		$this->_db->setQuery( $query );
		$group = $this->_db->loadResult();
			
		if (empty($group)) {
			return false;
		}
		
		return true;
	}
	
	function getExistCategory($userid)
	{
		$query 	= 'SELECT COUNT( id )'
				. ' FROM #__g_categories'
				. ' WHERE userid = '.$userid
				;
		$this->_db->setQuery( $query );
		$count = $this->_db->loadResult();
			
		if ($count > 0) {
			return true;
		}
		
		return false;
	}
	
	function getExistItem($userid)
	{
		$query 	= 'SELECT COUNT( id )'
				. ' FROM #__g_galleryitems'
				. ' WHERE user_id = '.$userid
				;
		$this->_db->setQuery( $query );
		$count = $this->_db->loadResult();
			
		if ($count > 0) {
			return true;
		}
		
		return false;
	}
	
	function getUserData($userid) {

		$query = 'SELECT u.name'
				. ' FROM #__users AS u'
				. ' WHERE u.id = '.$userid
				;
		$this->_db->setQuery($query);
		$row = $this->_db->loadObject();
			
		return $row;
	}
	
	function getData($userid) {

		$query = 'SELECT u.*, g.name AS groupname'
				. ' FROM #__g_user AS u'
				. ' LEFT JOIN #__g_user_groups AS g ON g.id = u.group'
				. ' WHERE u.userID = '.$userid
				;
		$this->_db->setQuery($query);
		$row = $this->_db->loadObject();
			
		return $row;
	}
	
	function store($data) {

		jimport('joomla.filesystem.file');
		$row = & JTable::getInstance('g_user', '');
		
		// Bind the form fields to the table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// sanitise id field
		$row->id = (int) $row->id;

//		$isNew = ($row->id < 1);
		
		// Make sure the table is valid
		if (!$row->check()) {
			$this->setError($item->getError());
			return false;
		}

		// Store the table to the database
		if (!$row->store()) {
			$this->setError($item->getError());
			return false;
		}
		
		
		$category = & JTable::getInstance('g_categories', '');
		
		if ($row->catid) {
			$categorydata->id = $row->catid;
		}
		$categorydata->parent_id = 0;
		$categorydata->userid = $row->userID;
		$categorydata->title = $row->gallerytitle;
		$categorydata->published = 1;
		
		// bind it to the table
		if (!$category->bind($categorydata)) {
			$this->setError(500, $this->_db->getErrorMsg() );
			return false;
		}

		if (!$category->id) {
			$category->ordering = $category->getNextOrder();
		}
		
		// Make sure the data is valid
		if (!$category->check()) {
			$this->setError($category->getError());
			return false;
		}

		// Store it in the db
		if (!$category->store()) {
			$this->setError(500, $this->_db->getErrorMsg() );
			return false;
		}

		if ($row->catid <= 0) {
			$query = 'UPDATE #__g_user SET catid = ' . $category->id. ' WHERE id = '.$row->id;
			$this->_db->setQuery($query);
			$this->_db->query();
		}
		$cache = & JFactory::getCache('com_photomapgallery');
		$cache->clean();
		
		return $row->id;
	}
	
	function getCategories($userid)
	{
		global $mainframe, $option;
		
		$limit_cat				= $mainframe->getUserStateFromRequest( $option.'.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart_cat 		= $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		$cat_filter_order	= $mainframe->getUserStateFromRequest( $option.'.user.filter_order', 'cat_filter_order', 'c.ordering', 'cmd' );
		$cat_filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.user.filter_order_Dir', 'cat_filter_order_Dir', '', 'word' );
		$cat_filter_state 	= $mainframe->getUserStateFromRequest( $option.'.user.filter_state', 'cat_filter_state', '', 'int' );
		$catsearch 			= $mainframe->getUserStateFromRequest( $option.'.user.search', 'catsearch', '', 'string' );
		$catsearch 			= $this->_db->getEscaped( trim(JString::strtolower( $catsearch ) ) );
		
		$orderby 			= ' ORDER BY '.$cat_filter_order.' '.$cat_filter_order_Dir.', c.ordering';
		
		$where = array();
		if ( $cat_filter_state ) {
			if ( $cat_filter_state == 1 ) {
				$where[] = 'c.published = 1';
			} else if ($cat_filter_state == 0 ) {
				$where[] = 'c.published = 0';
			}
		}
	
		//select the records
		//note, since this is a tree we have to do the limits code-side
		if ($catsearch) {	
			$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
			$query = 'SELECT c.id'
					. ' FROM #__g_categories AS c'
					. ' WHERE LOWER(c.title) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $catsearch, true ).'%', false )
					. $where
					;
			$this->_db->setQuery( $query );
			$search_rows = $this->_db->loadResultArray();					
		}
		
		$where[] = ' c.userid = '.$userid;
		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
		
		$query = 'SELECT c.*, u.name AS editor, g.name AS groupname, COUNT(rel.catid) AS assigneditem'
					. ' FROM #__g_categories AS c'
					. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.catid = c.id'
					. ' LEFT JOIN #__groups AS g ON g.id = c.access'
					. ' LEFT JOIN #__users AS u ON u.id = c.checked_out'
					. $where
					. ' GROUP BY c.id'
					. $orderby
					;
					
		$this->_db->setQuery( $query );
		$rows = $this->_db->loadObjectList();
					
		//establish the hierarchy of the categories
		$children = array();
		
    	//set depth limit
   		$levellimit = 10;
		
    	foreach ($rows as $child) {
        	$parent = $child->parent_id;
       		$list 	= @$children[$parent] ? $children[$parent] : array();
        	array_push($list, $child);
        	$children[$parent] = $list;
    	}
	
    	//get list of the items
    	$list = photomapgallery_cats::treerecurse(0, '', array(), $children, false, max(0, $levellimit-1));

    	//eventually only pick out the searched items.
		if ($search) {
			$list1 = array();

			foreach ($search_rows as $sid )
			{
				foreach ($list as $item)
				{
					if ($item->id == $sid) {
						$list1[] = $item;
					}
				}
			}
			// replace full list with found items
			$list = $list1;
		}
		
    	$total = count( $list );

		jimport('joomla.html.pagination');
		$this->_pagination_cat = new JPagination( $total, $limitstart_cat, $limit_cat );

		// slice out elements based on limits
		$list = array_slice( $list, $this->_pagination_cat->limitstart, $this->_pagination_cat->limit );
		
		return $list;
	}
	
	function getCategoryPagination($userid)
	{
		if ($this->_pagination_cat == null) {
			$this->getCategories($userid);
		}
		return $this->_pagination_cat;
	}
	
	function catmove($direction)
	{
		$row =& JTable::getInstance('g_categories', '');

		if (!$row->load( $this->_id ) ) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->move( $direction, 'parent_id = '.$row->parent_id )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		return true;
	}
	
	function getCategory($id)
	{
		$query = 'SELECT c.*, g.name AS groupname'
				. ' FROM #__g_categories AS c'
				. ' LEFT JOIN #__g_user AS u ON u.userID = c.userid'
				. ' LEFT JOIN #__g_user_groups AS g ON g.id = u.group'
				. ' WHERE c.id = '.$id
				;
		$this->_db->setQuery($query);
		$row = $this->_db->loadObject();

		return $row;
	}
	
	function getMainCategory($userid)
	{
		$query = 'SELECT DISTINCT *'
				. ' FROM #__g_categories'
				. ' WHERE userid = '.$userid
				. ' AND parent_id = 0'
				;
		$this->_db->setQuery($query);
		$maincat = $this->_db->loadObject();

		return $maincat;
	}
	
	function getSubCategory($catid)
	{
		$query = 'SELECT *'
				. ' FROM #__g_categories'
				. ' WHERE parent_id = '.$catid;

		$this->_db->setQuery( $query );
		$rows = $this->_db->loadObjectList();

		return $rows;
	}
	
	function getCatsselected($cid)
	{
		$query = 'SELECT DISTINCT catid FROM #__g_cats_item_relations WHERE itemid = ' . $cid;
		$this->_db->setQuery($query);
		$used = $this->_db->loadResultArray();
		return $used;
	}
	
	function getImageItems($userid)
	{
		// Lets load the Items if it doesn't already exist
		if (empty($this->_imagedata))
		{
			$query = $this->_buildImageQuery($userid);
			$this->_imagedata = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
/*			
			$k = 0;
			$count = count($this->_imagedata);
			for($i = 0; $i < $count; $i++)
			{
				$item =& $this->_imagedata[$i];
				$item->categories = $this->getImageCategories($item->id);
				$k = 1 - $k;
			}*/
		}
		
		return $this->_imagedata;
	}
	
	function _buildImageQuery($userid)
	{
		// Get the WHERE and ORDER BY clauses for the query
		$where		= $this->_buildImageWhere($userid);
		$orderby	= $this->_buildImageOrderBy();

		$query = 'SELECT DISTINCT rel.itemid, i.*, u.name AS editor, (i.rate / (i.rate + i.rate_sum) ) * 100 AS votes, c.id AS catid, c.title AS cattitle, c.directory, g.name AS gallerygroup'
					. ' FROM #__g_galleryitems AS i'
					. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
					. ' LEFT JOIN #__g_categories AS c ON c.id = rel.catid'
					. ' LEFT JOIN #__g_user AS gu ON gu.userID = c.userid'
					. ' LEFT JOIN #__g_user_groups AS g ON g.id = gu.group'
					. ' LEFT JOIN #__users AS u ON u.id = i.checked_out'
					. $where
		//			. ' WHERE i.user_id = '.$userid
					. $orderby
					;

		return $query;
	}
	
	function _buildImageWhere($userid)
	{
		global $mainframe, $option;

		$img_filter_category 	= $mainframe->getUserStateFromRequest( $option.'.user.img_filter_category', 'img_filter_category', 0, 'int');
		$filter_state 		= $mainframe->getUserStateFromRequest( $option.'.user.filter_state', 'filter_state', 1, 'int' );
		$img_search 			= $mainframe->getUserStateFromRequest( $option.'.user.img_search', 'img_search', '', 'string' );
		$img_search 			= $this->_db->getEscaped( trim(JString::strtolower( $img_search ) ) );

		$where = array();

		if ( $filter_state ) {
			if ( $filter_state == 1 ) {
				$where[] = 'i.published = 1';
			} else if ($filter_state == 0 ) {
				$where[] = 'i.published = 0';
			} else if ($filter_state == -1 ) {
				$where[] = 'i.published != -1';
			}
		}
			
		$where[] = ' i.user_id = '.$userid;
		
		if ($img_filter_category > 0) {
			$where[] = ' c.id = '.$img_filter_category ;
		}

		if ($img_search) {
			$where[] = ' LOWER(i.title) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $img_search, true ).'%', false );
		}

		$where = ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
		
		return $where;
	}
	
	function _buildImageOrderBy()
	{
		global $mainframe, $option;

		$img_filter_order		= $mainframe->getUserStateFromRequest( $option.'.user.img_filter_order', 'img_filter_order', 'i.ordering', 'cmd' );
		$img_filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.user.img_filter_order_Dir', 'img_filter_order_Dir', '', 'word' );

		$orderby 	= ' ORDER BY '.$img_filter_order.' '.$img_filter_order_Dir.', i.ordering';

		return $orderby;
	}
	
	function getImageTotal($userid)
	{
		// Lets load the Items if it doesn't already exist
		if (empty($this->_imgtotal))
		{
			$query = $this->_buildImageQuery($userid);
			$this->_imgtotal = $this->_getListCount($query);
		}

		return $this->_imgtotal;
	}
	
	function getImagePagination($userid)
	{
		// Lets load the Items if it doesn't already exist
//		if (empty($this->_pagination))
//		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getImageTotal($userid), $this->getState('limitstart'), $this->getState('limit') );
//		}

		return $this->_pagination;
	}
	
	function countCategories($userid){

		$query = "SELECT COUNT(*) FROM #__g_categories WHERE userid = ".$userid;
		$this->_db->setQuery($query);
		$result = $this->_db->loadResult();
		return $result;
	}
	
/*	
	function getImageCategories($id)
	{
		$query = 'SELECT DISTINCT c.id, c.title'
				. ' FROM #__g_categories AS c'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.catid = c.id'
				. ' WHERE rel.itemid = '.(int)$id
				;
	
		$this->_db->setQuery( $query );

		$this->_cats = $this->_db->loadObjectList();

		return $this->_cats;
	}
*/	
	function getUsedTags($id)
	{
		$query = 'SELECT tid'
				. ' FROM #__g_tags_item_relations'
				. ' WHERE itemid = ' . $id
				;
		$this->_db->setQuery($query);
		$used = $this->_db->loadResultArray();
		return $used;
	}
/*	
	function getAlltags($userid)
	{
		$user =& JFactory::getUser();
		
		$query = 'SELECT *'
				. ' FROM #__g_tags'
				. ' WHERE userid = '.$userid
				. ' ORDER BY name'
				;
		$this->_db->setQuery($query);
		$tags = $this->_db->loadObjectlist();
		return $tags;
	}
*/	
	function getImageItem($gid)
	{		
		if ($this->_loadItem($gid))
		{		
			$query = 'SELECT name'
					. ' FROM #__users'
					. ' WHERE id = '. (int) $this->_imageitem->created_by
					;
			$this->_db->setQuery($query);
			$this->_imageitem->creator = $this->_db->loadResult();

			//reduce unneeded query
			if ($this->_imageitem->created_by == $this->_imageitem->modified_by) {
				$this->_imageitem->modifier = $this->_imageitem->creator;
			} else {
				$query = 'SELECT name'
						. ' FROM #__users'
						. ' WHERE id = '. (int) $this->_imageitem->modified_by
						;
				$this->_db->setQuery($query);
				$this->_imageitem->modifier = $this->_db->loadResult();
			}
			
		}
		else  $this->_initItem();

		return $this->_imageitem;
	}
	
	function _loadItem($gid)
	{
		// Lets load the item if it doesn't already exist
		if (empty($this->_imageitem))
		{
			$query = 'SELECT *'
					. ' FROM #__g_galleryitems'
					. ' WHERE id = '.$gid
					;
			$this->_db->setQuery($query);
			$this->_imageitem = $this->_db->loadObject();
		
			return (boolean) $this->_imageitem;
		}
		return true;
	}
	
	function _initItem()
	{
		// Lets load the item if it doesn't already exist
		if (empty($this->_imageitem))
		{
			$createdate = & JFactory::getDate();
			$nullDate	= $this->_db->getNullDate();
			
			$item = new stdClass();
			$item->id					= 0;
			$item->user_id				= 0;
			$item->cid[]				= 0;
			$item->title				= null;
			$item->alias				= null;
			$item->filename				= null;
			$item->description			= null;
			$item->imagewidth			= 0;
			$item->imageheight			= 0;
			$item->rate					= 0;
			$item->rate_sum				= 0;
			$item->hits					= 0;
			$item->post_hits			= 0;
			$item->version				= 0;
			$item->meta_description		= null;
			$item->meta_keywords		= null;
			$item->created				= $createdate->toUnix();
			$item->created_by			= null;
			$item->created_by_alias		= '';
			$item->modified				= $nullDate;
			$item->modified_by			= null;
			$item->attribs				= null;
			$item->metadata				= null;
			$item->ordering 			= null;
			$item->published			= 1;
			$item->featured				= 0;
			$item->slideshow			= 0;
			$item->mapdisplay			= 0;
			$item->lat					= null;
			$item->lon					= null;
			$item->zoom					= null;
			$item->maptype				= null;
			$item->kml					= null;
			$this->_imageitem			= $item;
			return (boolean) $this->_imageitem;
		}
		return true;
	}
	
	function getLatestItems($userid){

		$query = 'SELECT i.id, i.title, i.user_id, i.created, i.created_by, i.filename, c.title AS category, c.directory,'
				. ' CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(\':\', i.id, i.alias) ELSE i.id END as slug,'
				. ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as categoryslug'
				. ' FROM #__g_galleryitems AS i'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__g_categories AS c ON c.id = rel.catid'
				. ' WHERE user_id = '.$userid
				. ' ORDER BY created DESC'
				. ' LIMIT 18'
				;
		
		$this->_db->SetQuery($query);
  		$row = $this->_db->loadObjectList();

		return $row;
	}
	
	function getMostViewedItems($userid){

		$query = 'SELECT i.id, i.title, i.user_id, i.hits, i.created, i.created_by, i.filename, c.title AS category, c.directory,'
				. ' CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(\':\', i.id, i.alias) ELSE i.id END as slug,'
				. ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as categoryslug'
				. ' FROM #__g_galleryitems AS i'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__g_categories AS c ON c.id = rel.catid'
				. ' WHERE user_id = '.$userid
				. ' ORDER BY hits DESC'
				. ' LIMIT 18'
				;
		
		$this->_db->SetQuery($query);
  		$row = $this->_db->loadObjectList();
			
		return $row;
	}
	
	function getMostRatedItems($userid){

		$query = 'SELECT (i.rate_sum / i.rate ) * 20 AS votes, i.title, i.id, i.user_id, i.created, i.created_by, i.filename, i.rate, c.title AS category, c.directory,'
				. ' CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(\':\', i.id, i.alias) ELSE i.id END as slug,'
				. ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as categoryslug'
				. ' FROM #__g_galleryitems AS i'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__g_categories AS c ON c.id = rel.catid'
				. ' WHERE user_id = '.$userid
				. ' ORDER BY votes DESC'
				. ' LIMIT 18'
				;
		
		$this->_db->SetQuery($query);
  		$row = $this->_db->loadObjectList();

		return $row;
	}
	
	function getAllUserItem($userid)
	{
		$query = 'SELECT i.*, c.access AS cataccess, c.id AS catid, c.title AS category, c.directory, g.name AS groupname,'
				. ' CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(\':\', i.id, i.alias) ELSE i.id END as slug,'
				. ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as categoryslug'
				. ' FROM #__g_galleryitems AS i'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__g_categories AS c ON c.id = rel.catid'
				. ' LEFT JOIN #__g_user AS u ON u.userID = c.userid'
				. ' LEFT JOIN #__g_user_groups AS g ON g.id = u.group'
				. ' WHERE i.user_id = '.$userid
				. ' AND i.published = 1'
				. ' AND i.mapdisplay = 1'
				;
		$this->_db->setQuery($query);
		$alluseritem = $this->_db->loadObjectList();
		
		return $alluseritem;
	}
	
	function getLatestComments($userid, $limit) {
	
		$query = 'SELECT c.*, i.filename, i.id  AS itemid, i.title AS itemtitle, g.name AS groupname, ct.title AS category, ct.directory, u.name AS commentedby,'
				. ' CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(\':\', i.id, i.alias) ELSE i.id END as slug,'
				. ' CASE WHEN CHAR_LENGTH(ct.alias) THEN CONCAT_WS(\':\', ct.id, ct.alias) ELSE ct.id END as categoryslug'
				. ' FROM #__g_comments AS c'
				. ' LEFT JOIN #__g_galleryitems AS i ON i.id = c.post_id'
				. ' LEFT JOIN #__g_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__g_categories AS ct ON ct.id = rel.catid'
				. ' LEFT JOIN #__g_user AS u ON u.userID = ct.userid'
				. ' LEFT JOIN #__g_user_groups AS g ON g.id = u.group'
				. ' WHERE i.published = 1'
				. ' AND i.user_id = '.$userid
				. ' ORDER BY c.date DESC';
				
		$this->_db->setQuery($query, 0, $limit);
		$rows = $this->_db->loadObjectList();

		return $rows;
	}
}

?>