<?php
/**
 * @version 1.1 beta $Id: router.php 2009-12-28 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im - www.photoindochina.com
 * @license GNU/GPL v2
 * 
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

function photomapgalleryBuildRoute(&$query)
{
	$segments = array();

	if(isset($query['view']))
	{
		if(empty($query['Itemid'])) {
			$segments[] = $query['view'];
		}

		if($query['view'] == 'photogallery') {
			$segments[] = $query['view'];
		}
		
		if($query['view'] == 'tags') {
			$segments[] = 'tag';
			if(isset($query['id'])) {
				$segments[] = $query['id'];
				unset($query['id']);
			}
			unset($query['view']);
			return $segments;
		}
		
		if($query['view'] == 'favourites') {
			$segments[] = $query['view'];
		}
		
		if($query['view'] == 'user') {
			$segments[] = $query['view'];
		}
		
		if($query['view'] == 'profile') {
			$segments[] = $query['view'];
		}
		
		if($query['view'] == 'imagehandler') {
			$segments[] = $query['view'];
		}
		
		unset($query['view']);
	};

	if(isset($query['cid']))
	{
		$segments[] = $query['cid'];
		unset($query['cid']);
	};

	if(isset($query['id']))
	{
		$segments[] = $query['id'];
		unset($query['id']);
	};

	return $segments;
}

function photomapgalleryParseRoute($segments)
{
	$vars = array();

	// Count route segments
	$count = count($segments);

	if($segments[0] == 'tag') {
		$vars['view'] = 'tags';
		$vars['id'] = $segments[$count-1];
		return $vars;
	}
	
	if($segments[0] == 'favourites') {
		$vars['view'] = 'favourites';
		$vars['id'] = $segments[$count-1];
		return $vars;
	}
	
	if($segments[0] == 'user') {
		$vars['view'] = 'user';
		$vars['id'] = $segments[$count-1];
		return $vars;
	}
	
	if($segments[0] == 'profile') {
		$vars['view'] = 'profile';
		$vars['id'] = $segments[$count-1];
		return $vars;
	}
	
	if($segments[0] == 'imagehandler') {
		$vars['view'] = 'imagehandler';
		$vars['id'] = $segments[$count-1];
		return $vars;
	}
	
	if($segments[0] == 'photogallery') {
		$vars['view'] = 'photogallery';
		$vars['id'] = $segments[$count-1];
		return $vars;
	}
	
	if ($count == 1) {
		$vars['cid'] = $segments[$count-1];
		$vars['view'] = 'category';
	}
	
	return $vars;
}
?>