<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 195 2009-05-30 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 -2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the PhotoMap Gallery View
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class photomapgalleryViewCategory extends JView
{
	/**
	 * Creates the Forms for the View
	 *
	 * @since 1.0
	 */
	function display( $tpl = null )
	{
		global $mainframe, $gconf;

		//initialize variables
		$document 	= & JFactory::getDocument();
		$user		= & JFactory::getUser();
		$menus		= & JSite::getMenu();
		$menu    	= $menus->getActive();
		$params 	= & $mainframe->getParams('com_photomapgallery');
		$uri 		= & JFactory::getURI();
		$lang 		= & JFactory::getLanguage();
		$db  		= & JFactory::getDBO();

		$gconf		= GUtil::config();
		
		// Request variables
		$limitstart		= JRequest::getInt('limitstart');
		
		//add css file
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery.css');
		if ($lang->isRTL()) {
			$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery_rtl.css');
		}
	
		$document->addCustomTag('<!--[if IE]><style type="text/css">.floattext{zoom:1;}, * html #gallery dd { height: 1%; }, ul.vote-stars li.current-rating{top:-1.5pt;}</style><![endif]-->');

		$document->addCustomTag('<!--[if lte IE 6]>
<script language="javascript" type="text/javascript" src="/components/com_photomapgallery/assets/js/DD_belatedPNG.js"></script>
<link rel="stylesheet" href="/components/com_photomapgallery/assets/css/template_ie6.css" type="text/css" />
<script type="text/javascript">
DD_belatedPNG.fix("div#box div.box-t, div#box div.box-tl, div#box div.box-tr, div#box div.box-l, div#box div.box-r, div#box div.box-m, div#box div.box-b, div#box div.box-bl, div#box div.box-br, div#box h3.title, div#box_b div.box-b-t, div#box_b div.box-b-tl, div#box_b div.box-b-tr, div#box_b div.box-b-l, div#box_b div.box-b-r, div#box_b div.box-b-m, div#box_b div.box-b-b, div#box_b div.box-b-bl, div#box_b div.box-b-br, div#box_b h3.title, a.readon, a.readmore, .toggler, ul.vote-stars, ul.vote-stars li a:hover, ul.vote-stars li.current-rating, div#ThumbMatrix .shadow, div#ThumbMatrix .shadow span, div#ThumbMatrix .shadow div.left");
</script>
<![endif]-->');
		if ($gconf->showrating) {
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/vote.js');
		}

		if ($gconf->mootools == 1) {
			JHTML::_('behavior.mootools'); 
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/mootools-release-1.11.js');
		}
		
		$mapkey = $gconf->api_key;
		$a_lang = explode('-', $document->getLanguage());
		if ($mapkey) {
			$document->addScript( 'http://maps.google.com/maps?file=api&amp;v=2.x&amp;key=' . $mapkey . '&amp;hl=' . $a_lang[0] );
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/photomap_packed.js');
		}
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/qtabs.js');	
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/slimbox.js');
		
		//pathway
		$pathway 	= & $mainframe->getPathWay();

		// Get data from the model	
		$model	= &$this->getModel();
		
		$category 	= & $this->get('Category');
		$items 		= & $this->get('Data');
		$limit		= $mainframe->getUserStateFromRequest('com_photomapgallery.'.$this->getLayout().'.limit', 'limit', $gconf->imagelimit, 'int');
		$total 		= & $this->get('Total');
		$maincat 	= $model->getMainCategory((int)$category->userid);
		$categories	= & $this->get('Childs');
		
		if (is_object( $menu )) {
			$menu_params = new JParameter( $menu->params );		
			
			if ($menu_params->get( 'page_title')) {
				$params->set('page_title',	$menu_params->get( 'page_title'));
			} else {
				$params->set('page_title',	$category->title);
			}	
		} else {
			$params->set('page_title',	$category->title);
		}

		/*
		* Handle the metadata for a categoy
		*/
		$document->setTitle( $params->get( 'page_title' ) );
		
		if ($category->meta_description) {
			$document->setDescription( $category->meta_description );
		}
		if ($category->meta_keywords) {
			$document->setMetadata('keywords', $category->meta_keywords);
		}
		if ($mainframe->getCfg('MetaTitle') == '1') {
			$mainframe->addMetaTag('title', $category->title);
		}
		
//		foreach($parents as $parent) {
//			$pathway->addItem( $this->escape($category->title), JRoute::_('index.php?view=category&cid='.$category->slug));
//		}
//		$count = count ($parents);
//		$pathway->addItem( $this->escape($parents[$count-1]->title), JRoute::_('index.php?view=category&cid='.$parents[$count-1]->slug));
		
		if ($params->get('show_feed_link', 1) == 1) {
			//add alternate feed link
			$link	= '&format=feed';
			$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
			$document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
			$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
			$document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
		}

		//ordering
		$filter_order		= JRequest::getCmd('filter_order', 'i.title');
		$filter_order_Dir	= JRequest::getCmd('filter_order_Dir', 'ASC');
		$filter				= JRequest::getString('filter');
		
		$lists						= array();
		$lists['filter_order']		= $filter_order;
		$lists['filter_order_Dir'] 	= $filter_order_Dir;
		$lists['filter']			= $filter;

		// Create the pagination object
		jimport('joomla.html.pagination');

		$pageNav 	= new JPagination($total, $limitstart, $limit);

		$number = count($categories);
		$display = 0;
		if ($number > 0) {
			$n = 0;
			for ($i = 0; $i < $number; $i++) {
				$sub = count($categories[$i]->subcats);
				if ($sub > 0) {
					for ($j = 0; $j < $sub; $j++) {
						$mapdatas[$n] = $model->getMapData((int)$categories[$i]->subcats[$j]->id);
						if ($mapdatas[$n]->mapdisplay == 1)
							$display = 1;
						$n++;
					}
				} else {
					$mapdatas[$n] = $model->getMapData((int)$categories[$i]->id);
					if ($mapdatas[$n]->mapdisplay == 1)
						$display = 1;
					$n++;
				}
			}
		}
		else {
			for ($i = 0; $i < count($items); $i++) {
				if ($items[$i]->mapdisplay == 1)
					$display = 1;
			}
		}
//		$diaplay = 1;
		
		$this->assignRef('gconf', 					$gconf);
		$this->assignRef('user', 					$user);
		$this->assignRef('params', 					$params);
		$this->assignRef('categories', 				$categories);
		$this->assignRef('category', 				$category);
		$this->assignRef('items', 					$items);
		$this->assignRef('maincat', 				$maincat);
		$this->assignRef('pageNav', 				$pageNav);
		$this->assignRef('lists',	 				$lists);
		$this->assignRef('mapdatas',				$mapdatas);
		$this->assignRef('diaplay',					$display);
/*
		echo "<PRE>"; 
		print_r($gconf); 
		echo "</PRE>";	
*/	
		parent::display($tpl);
	}
}
?>