<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 195 2009-05-30 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the PhotoMap Gallery View
 *
 * @package Joomla
 * @subpackage HotelGuide
 * @since 1.0
 */
class photomapgalleryViewGallery extends JView
{
	/**
	 * Creates the Forms for the View
	 *
	 * @since 1.0
	 */
	function display( $tpl = null )
	{
		global $mainframe, $tgconf;

		//initialize variables
		$db    		= JFactory::getDBO();
		$document 	= & JFactory::getDocument();
		$menus		= & JSite::getMenu();
		$lang 		= & JFactory::getLanguage();
		$menu		= $menus->getActive();
		$params 	= $mainframe->getParams('com_photomapgallery');
		
		$config = & GUtil::config();
		
		$limitstart		= JRequest::getInt('limitstart');
		
		//add css file
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery.css');
		if ($lang->isRTL()) {
			$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery_rtl.css');
		}
		
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/jd.gallery.js');
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/jd.gallery.transitions.js');
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/slimbox.js');
		
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/jd.gallery.css');
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/slimbox.css');
		
		$document->addCustomTag('<!--[if IE]><style type="text/css">.floattext{zoom:1;}, * html #hotelguide dd { height: 1%; }, .main {
	display: block; }, .col1, .col2, .col3 { display: inline; zoom: 1; }, .col2 { margin-left: -1px; } </style><![endif]-->');

		$document->addCustomTag('<!--[if lte IE 6]>
<script language="javascript" type="text/javascript" src="/components/com_photomapgallery/assets/js/DD_belatedPNG.js"></script>
<link rel="stylesheet" href="/components/com_photomapgallery/assets/css/template_ie6.css" type="text/css" />
<script type="text/javascript">
DD_belatedPNG.fix("div#box div.box-t, div#box div.box-tl, div#box div.box-tr, div#box div.box-l, div#box div.box-r, div#box div.box-m, div#box div.box-b, div#box div.box-bl, div#box div.box-br, div#box h3.title, .col3, a.readon, a.readmore");
</script>
<![endif]-->');

		$categories = & $this->get('Data');
		$limit		= $mainframe->getUserStateFromRequest('com_photomapgallery.'.$this->getLayout().'.limit', 'limit', $params->def('limit', 0), 'int');
		$total 		= & $this->get('Total');
		
		// because the application sets a default page title, we need to get it
		// right from the menu item itself
		if (is_object( $menu )) {
			$menu_params = new JParameter( $menu->params );		
			
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title',	$menu->name);
			}
			
		} else {
			$params->set('page_title',	JText::_('HOTEL'));
		}

		/*
		* Handle the metadata for the hotel guide list
		*/
		$document->setTitle($params->get('page_title'));
		$document->setMetadata( 'keywords' , $params->get('page_title') );

		if ($mainframe->getCfg('MetaTitle') == '1') {
			$mainframe->addMetaTag('title', $params->get('page_title'));
		}
				
		if ($params->get('show_feed_link', 1) == 1) {
			//add alternate feed link
			$link	= '&format=feed';
			$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
			$document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
			$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
			$document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
		}

		//ordering
		$filter_order		= JRequest::getCmd('filter_order', 'i.title');
		$filter_order_Dir	= JRequest::getCmd('filter_order_Dir', 'ASC');
		$filter				= JRequest::getString('filter');
		
		$lists						= array();
		$lists['filter_order']		= $filter_order;
		$lists['filter_order_Dir'] 	= $filter_order_Dir;
		$lists['filter']			= $filter;
		
		// Create the pagination object
		jimport('joomla.html.pagination');

		$pageNav 	= new JPagination($total, $limitstart, $limit);

		$pathway =& $mainframe->getPathway();

		$query = 'SELECT *' .
			' FROM #__g_galleryitems' .
			' WHERE featured = 1';

		$db->setQuery($query);
		$featured = $db->loadObjectList();
	
		$slideshow = & $this->get('SlideshowItems');
		
		
		$this->assignRef('tgconf', 			$tgconf);
		$this->assignRef('params', 			$params);
		$this->assignRef('categories', 		$categories);
		$this->assignRef('featured', 		$featured);
		$this->assignRef('pageNav', 		$pageNav);
		$this->assignRef('lists' ,	 		$lists);
		$this->assignRef('slideshow',			$slideshow);
		$this->assignRef('config',			$config);
/*
		echo "<pre>";
		echo "view=";
		print_r($slideshow);
		echo "</pre>";
*/		
		parent::display($tpl);
	}
}
?>