<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

if ($this->item->lat) {
	if (!$this->item->lat)
		$lat = $this->config->lat;
	else
		$lat = $this->item->lat;
	if (!$this->item->lon)
		$lon = $this->config->lon;
	else
		$lon = $this->item->lon;
	if (!$this->item->zoom)
		$zoom = $this->config->zoom;
	else
		$zoom = $this->item->zoom;
	if (!$this->item->maptype)
		$type = $this->config->maptype;
	else
		$type = $this->item->maptype;
		
	switch ($type) {
		case 'map':
		case 'roadmap':
			$map_type='google.maps.MapTypeId.ROADMAP';
			break;
		case 'satellite':
			$map_type='google.maps.MapTypeId.SATELLITE';
			break;
		case 'hybrid':
			$map_type='google.maps.MapTypeId.HYBRID';
			break;
		case 'terrain':
			$map_type='google.maps.MapTypeId.TERRAIN';
			break;
		default :
			$map_type='google.maps.MapTypeId.ROADMAP';
	}
?>

<script language="javascript" type="text/javascript">
    var map;

    function handleApiReady() {
		var latlng = new google.maps.LatLng(<?php echo $lat ?>, <?php echo $lon ?>);

		var myOptions = {
			zoom: <?php echo $zoom ?>,
			center: latlng,
			mapTypeControl: true,
			mapTypeControlOptions: {style: google.maps.MapTypeControlStyle.DROPDOWN_MENU},
			navigationControl: true,
			navigationControlOptions: {style: google.maps.NavigationControlStyle.SMALL},
			mapTypeId: <?php echo $map_type ?>
		};
		
		map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
	
		var marker = new google.maps.Marker({
			position: latlng, 
			map: map,
			title:"Hello World!"
		}); 

	}
	
	function centerChanged() {
		document.adminForm.lat.value=map.getCenter().lat();
		document.adminForm.lon.value=map.getCenter().lng();
	}
	
	function appendBootstrap() {
		var script = document.createElement("script");
		script.type = "text/javascript";
		script.src = "http://maps.google.com/maps/api/js?sensor=false&callback=handleApiReady";
		document.body.appendChild(script);
	}

</script>
<?php
}

echo '<div id="sideBar" style="position:absolute; width: auto; height: auto; top: 5px; right:0; float:right; background-color: transparent; z-index: 9999;">';
	echo '<a id="sideBarTab" style="float:left; height:67px; width:17px; padding:0; margin:0;" href="#" onclick="appendBootstrap();"><img src="'.$this->baseurl.'/components/com_photomapgallery/assets/images/slide-button.png" alt="Sidebar" title="SideBar"/></a>';
	echo '<div id="sideBarContents" style="width:0px; float:left; padding:0; margin: 0; vertical-align: top; overflow:hidden !important; display:none;">' . "\n"; 
		echo '<div id="sideBarContentsInner" style="width:200px; padding:5px; background-color: #2B2B2B; border: 1px solid #666666;">' . "\n"; 
			echo '<h2 style="font-size: 1.0em; line-height:1.4em; text-align: center; font-weight: bold; color: #888; background-color: #1B1B1B;"><span>'.JText::_('RANDOM IMAGE').'</span></h2>' . "\n"; 
			echo '<div class="sideblock" style="padding-top:5px; width: 100%; text-align: center;">' . "\n";
				$link = photomapgalleryHelperRoute::getItemRoute($this->random[0]->slug, $this->random[0]->catslug);

				echo "<a href='".JRoute::_( $link )."'>";
				if ($this->random[0]->filename) {
					echo '<img src="'.JURI::base().'images/photomap/resized/'.$this->random[0]->directory.'/'.$this->random[0]->filename.'" title="'.$this->random[0]->title.'" alt="'.$this->random[0]->title.'" /></a>';
				}
			echo '</div>' . "\n";
/*			echo '<h2 style="font-size: 1.0em; line-height:1.4em; text-align: center; font-weight: bold; color: #888; background-color: #1B1B1B;"><span>'.JText::_('GALLERY').'</span></h2>' . "\n"; 
			echo $this->lists['parent_id'];
			echo '<div style="clear:both;padding-bottom:10px;"></div>' . "\n";  
	*/		
			echo '<h2 style="font-size: 1.0em; line-height:1.4em; text-align: center; font-weight: bold; color: #888; background-color: #1B1B1B;"><span>'.JText::_('TAG CLOUD').'</span></h2>' . "\n"; 

			echo '<ul id="cloud" class="tagcloud">' . "\n"; 
			foreach ($this->taglists as $tag) : 
				echo '<li><span>'.$tag->screenreader.'</span><a href="'.$tag->link.'" class="tag'.$tag->size.'">'.$tag->name.'</a></li>' . "\n"; 
			endforeach;
			echo '</ul>' . "\n"; 
			
			echo '<div style="clear:both;padding-bottom:10px;"></div>' . "\n";  
			echo '<h2 style="font-size: 1.0em; line-height:1.4em; text-align: center; font-weight: bold; color: #888; background-color: #1B1B1B;"><span>'.JText::_('EXIF INFORMATION').'</span></h2>' . "\n"; 
			
		?>
			<table class="adminlist" border="0">
            <?php if ($this->item->exif) { ?>
                <tr>
                    <td><span class="label"><?php echo JText::_('CAMERA'); ?></span></td>
                    <td><?php echo $this->item->exif[1];?></td>
                </tr>
                <tr>
                    <td><span class="label"><?php echo JText::_('EXPOSURE'); ?></span></td>
                    <td>1<?php echo $this->item->exif[3];?></td>
                </tr>
                <tr>
                    <td><span class="label"><?php echo JText::_('APERTURE'); ?></span></td>
                    <td><?php echo $this->item->exif[4];?></td>
                </tr>
                <tr>
                    <td><span class="label"><?php echo JText::_('FOCAL LENGTH'); ?></span></td>
                    <td><?php echo $this->item->exif[12];?></td>
                </tr>
                <tr>
                    <td><span class="label"><?php echo JText::_('ISO SPEED'); ?></span></td>
                    <td><?php echo $this->item->exif[5];?></td>
                </tr>
                <tr>
                    <td><span class="label"><?php echo JText::_('EXPOSURE BIAS'); ?></span></td>
                    <td><?php echo $this->item->exif[6];?></td>
                </tr>
                <tr>
                    <td><span class="label"><?php echo JText::_('FLASH'); ?></span></td>
                    <td><?php echo $this->item->exif[7];?></td>
                </tr>
                <tr>
                    <td><span class="label"><?php echo JText::_('WHITE BALANCE'); ?></span></td>
                    <td><?php echo $this->item->exif[11];?></td>
                </tr>
                <tr>
                    <td><span class="label"><?php echo JText::_('DATE AND TIME'); ?></span></td>
                    <td><?php echo $this->item->exif[2];?></td>
                </tr>
			<?php } else { ?>
            	<tr>
					<td>** No information available **</td>
				</tr>
			<?php } ?>
		</table> <?php 

			if ($this->item->lat) {
				echo '<div style="clear:both;padding-bottom:10px;"></div>' . "\n"; 
				echo '<h2 style="font-size: 1.0em; line-height:1.4em; text-align: center; font-weight: bold; color: #888; background-color: #1B1B1B;"><span>'.JText::_('PHOTO MAP').'</span></h2>' . "\n"; 
				echo '<div id="map"><div id="map_canvas" style="width: 200px; height: 200px"></div></div>' . "\n";
			}
		echo '</div>' . "\n"; 
	echo '</div>' . "\n"; 
	
echo '</div>';

?>