<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 195 2009-05-30 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Items View
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class photomapgalleryViewPhotoGallery extends JView
{

	/**
	 * Creates the item page
	 *
	 * @since 1.0
	 */
	function display( $tpl = null )
	{
		global $mainframe, $option;

		//initialize variables
		$document 	= & JFactory::getDocument();
		$user		= & JFactory::getUser();
		$menus		= & JSite::getMenu();
		$lang 		= & JFactory::getLanguage();
		$menu    	= $menus->getActive();
		$component 	= JComponentHelper::getComponent( 'com_photomapgallery' );
  		$params 	= new JParameter( $component->params );
		$db  		= & JFactory::getDBO();
		$config  	= & GUtil::config();

		$cid		= JRequest::getInt('cid', 0);
		$id			= JRequest::getInt('id', 0);
		$cmtid		= JRequest::getInt('cmtid', 0);
		$task		= JRequest::getVar('task');
		$dynamic	= JRequest::getVar('dynamic');

		if($this->getLayout() == 'form') {
			$this->_displayForm($tpl);
			return;
		}

		//add css file
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery.css');
		if ($lang->isRTL()) {
			$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery_rtl.css');
		}
		
		$document->addCustomTag('<!--[if IE]><style type="text/css">.floattext{zoom:1;}, * html #photomapgallery dd { height: 1%; }, ul.vote-stars li.current-rating{top:-1.5pt;}</style><![endif]-->');
		
		$document->addCustomTag('<!--[if lte IE 6]>
		<script language="javascript" type="text/javascript" src="/components/com_photomapgallery/assets/js/DD_belatedPNG.js"></script>
		<link rel="stylesheet" href="/components/com_photomapgallery/assets/css/template_ie6.css" type="text/css" />
		<script type="text/javascript">
		DD_belatedPNG.fix("div#box div.box-t, div#box div.box-tl, div#box div.box-tr, div#box div.box-l, div#box div.box-r, div#box div.box-m, div#box div.box-b, div#box div.box-bl, div#box div.box-br, div#box h3.title, ul.vote-stars, ul.vote-stars li a:hover, ul.vote-stars li.current-rating");
		</script>
		<![endif]-->');

		if ($config->mootools == 1) {
			JHTML::_('behavior.mootools'); 
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/mootools-release-1.11.js');
		}
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/slimbox.js');
//		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/iCarousel.js');
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/favourite.js');
		if ($config->show_sidebar == 1) { 
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/side-bar.js');
		}
		
		if ($config->showrating) {
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/vote.js');
		}
		
		//get tour item data
		$model	= &$this->getModel();

		if ($id > 0) {
			$item 	= &$this->get('Item');
			$navItem = $model->getMicroNavItem($item->id, $item->catid, $item->ordering, $item->hits, (int)$dynamic, $config->navicolumm * $config->navirow);
			$nextItem = $model->getNextItem($item->id, $item->catid, $item->ordering, $item->hits, (int)$dynamic);
			$nextItem->nextLink = urldecode(JRoute::_(photomapgalleryHelperRoute::getItemRoute(urlencode($nextItem->slug))));
			$prevItem = $model->getPreviousItem($item->id, $item->catid, $item->ordering, $item->hits, (int)$dynamic);
			$prevItem->prevLink = urldecode(JRoute::_(photomapgalleryHelperRoute::getItemRoute(urlencode($prevItem->slug))));
			$firstItem = $model->getFirstItem($item->catid, (int)$dynamic);
			$firstItem->firstLink = urldecode(JRoute::_(photomapgalleryHelperRoute::getItemRoute(urlencode($firstItem->slug))));
			$lastItem = $model->getLastItem($item->catid, (int)$dynamic);
			$lastItem->lastLink = urldecode(JRoute::_(photomapgalleryHelperRoute::getItemRoute(urlencode($lastItem->slug))));
			// Absolute URL
			$uri = &JURI::getInstance();
			$item->absoluteURL = $uri->_uri;
			//Email link
        	$item->emailLink = JRoute::_('index.php?option=com_mailto&tmpl=component&link='.base64_encode($item->absoluteURL));
			//Social link
			$item->socialLink = urlencode($item->absoluteURL);
		}
		
		if (($item->id == 0))
		{	
//			return JError::raiseError( 404, JText::sprintf( 'ITEM #%d NOT FOUND', $id ) );
		}
		
		//get favourites if enabled
		if ($config->show_favourite_icon) {
			$favourites	= & $this->get('Favourites');
			$favoured	= & $this->get('Favoured');
		}
		
		$random 		= $model->getRandom(1);
		$counttags 		= $model->getLimitTags($item->user_id, 30);
		
		$max = count($counttags);
		$min = (int)$counttags[sizeof($counttags)-1];
		
		$iparams	=& $item->attribs;
		$params->merge($iparams);
		
		$modelcomment	= &$this->getModel( 'Comments' );
	
		//pathway
		$cats		= new photomapgallery_cats($item->catid);
        $parents	= $cats->getParentlist();
		$pathway 	= & $mainframe->getPathWay();
		
		$pathway->addItem( $this->escape($item->title), JRoute::_('index.php?view=photogallery&id='.$item->slug));
/*		
		$author=JFactory::getUser($item->user_id);		
		$username = JTEXT::_(' - ').$author->name;

//		$params->set('page_title',	$item->title);
		$params->set('page_title',	$item->title.$username);
		$doc_title = $params->get( 'page_title' );
		$document->setTitle($doc_title);
*/		
		$params->set('page_title',	$item->title);
		/*
		 * Create the document title
		 */
		if($item->catid) {
			$parentcat = array_pop($parents);
			$doc_title = $parentcat->title.' - '.$params->get( 'page_title' );
		} else {
			$doc_title = $params->get( 'page_title' );
		}
		
		$document->setTitle($doc_title);
		
		if ($item->meta_description) {
			$document->setDescription( $item->meta_description );
		}
		
		if ($item->meta_keywords) {
			$document->setMetadata('keywords', $item->meta_keywords);
		}
		
		if ($mainframe->getCfg('MetaTitle') == '1') {
			$mainframe->addMetaTag('title', $item->title);
		}
		
		if ($mainframe->getCfg('MetaAuthor') == '1') {
			$mainframe->addMetaTag('author', $item->author);
		}

		$mdata = new JParameter($item->metadata);
		$mdata = $mdata->toArray();
		foreach ($mdata as $k => $v)
		{
			if ($v) {
				$document->setMetadata($k, $v);
			}
		}

        $print_link = JRoute::_('index.php?view=photogallery&cid='.$item->categoryslug.'&id='.$item->slug.'&pop=1&tmpl=component');

		
		// Get commets lsit againt the post ID
		$comments	= $modelcomment->getComment();
		$totalcomments	= $modelcomment->getTotalComments( $options );
		$editcomments	= $modelcomment->getEditComment();
	
		$modelCategory	= &$this->getModel( 'category' );
//		$modelCategory->setId($item->catid);
//		$mapdatas = $modelCategory->getMapData($item->catid);

		$minsize 	= 1;
		$maxsize 	= 10;
		
		$i		= 0;
		$taglists	= array();
		foreach ( $counttags as $tag )
		{	
			$taglists[$i]->size 			= $this->sizer($min, $max, $tag->no, $minsize, $maxsize);
			$taglists[$i]->name 			= $tag->name;
			$taglists[$i]->screenreader		= JText::sprintf('NR_ITEMS_TAGGED', $tag->no);
			$taglists[$i]->link 			= JRoute::_(photomapgalleryHelperRoute::getTagRoute($tag->slug));
			$i++;
		}

		$selectedcats = & $this->get( 'Catsselected' );
		$categories = photomapgallery_cats::getCategoriesTree(1, $item->user_id);
	
		$maincat 	= $model->getMainCategory((int)$item->user_id);
		
		//build selectlist
//		$lists = array();
//		$lists['parent_id'] = photomapgallery_cats::buildcatselect($categories, 'parent_id', $selectedcats, false);
		
		if (!$item->exif) {
			$exiflink = 'images/photomap/original/'.$item->directory.'/'.$item->filename;
				
			$data = GUtil::showEXIF($item->id, $exiflink);

			if (is_array($data))
			{
				$txt = array ();
				foreach ($data as $k => $v) {
					$txt[] = "$v";
				}
				$exiftag = implode("\n", $txt);
			}
				
			$model->updateExif($exiftag, $item->id);
	
			$item->exif =  explode ("\n", $exiftag);
		}
		else {
			$item->exif = explode ("\n", $item->exif);
		}
		
		$this->assignRef('config', 				$config);
		$this->assignRef('item', 				$item);
		$this->assignRef('nextItem', 			$nextItem);
		$this->assignRef('prevItem', 			$prevItem);
		$this->assignRef('firstItem', 			$firstItem);
		$this->assignRef('lastItem', 			$lastItem);
		$this->assignRef('navItem',				$navItem);
		$this->assignRef('user', 				$user);
		$this->assignRef('params', 				$params);
		$this->assignRef('print_link', 			$print_link);
		$this->assignRef('parentcat',			$parentcat);
		$this->assignRef('tags',				$tags);
		$this->assignRef('taglists',			$taglists);
//		$this->assignRef('lists',				$lists);
		$this->assignRef('random',				$random);
		$this->assignRef('favourites',			$favourites);
		$this->assignRef('favoured',			$favoured);
		$this->assignRef('dynamic',				$dynamic);
		$this->assignRef('maincat',				$maincat);

		$this->assignRef('totalcomments', 		$totalcomments);
		$this->assignRef('comments', 			$comments);
		$this->assignRef('task', 				$task);
		$this->assignRef('editcomments', 		$editcomments);
/*
		echo "<PRE>"; 
		print_r($item); 
		echo "</PRE>";
*/
		parent::display($tpl);
	}
	
	/**
	 * Creates the item submit form
	 *
	 * @since 1.0
	 */
	function _displayForm($tpl)
	{
		global $mainframe;

		//Initialize variables
		$document	=& JFactory::getDocument();
		$user		=& JFactory::getUser();
		$uri     	=& JFactory::getURI();
		$params		=& $mainframe->getParams('com_photomapgallery');
		$config  	= & GUtil::config();
		$db  		= & JFactory::getDBO();

		$model	= &$this->getModel();
		$item		=& $this->get('Item');
		$used 		=& $this->get('Usedtags');
//		$tags 		= $model->getAlltags($item->user_id);
		
		//Add the js includes to the document <head> section
		JHTML::_('behavior.formvalidation');
		JHTML::_('behavior.tooltip');

		//ensure $used is an array
		if(!is_array($used)){
			$used = array();
		}
		
		//add css file
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery.css');
		$document->addCustomTag('<!--[if IE]><style type="text/css">.floattext{zoom:1;}, * html #photomapgallery dd { height: 1%; }</style><![endif]-->');
		
		//check if we have an id(edit) and check if we have global edit rights or if we are allowed to edit own items.
		if( $item->id > 1 && !($user->authorize('com_photomapgallery', 'edit') || ($user->authorize('com_content', 'edit', 'content', 'own') && $item->created_by == $user->get('id')) ) ) {
			JError::raiseError( 403, JText::_("ALERTNOTAUTH") );
		}
	
		if ($user->authorize('com_photomapgallery', 'newtags')) {
			$document->addScript( 'components/com_photomapgallery/assets/js/tags.js' );
		}
/*		
		$selectedcats = & $this->get( 'Catsselected' );
		
		$query = 'SELECT c.title'
					. ' FROM #__g_categories AS c'
					. ' WHERE c.id IN ('. $selectedcats[0] .')';
					
		$db->setQuery($query);
		$directory = $db->loadResult();
*/		
		$query = 'SELECT c.directory'
					. ' FROM #__g_cats_item_relations AS rel'
					. ' LEFT JOIN #__g_categories AS c ON c.id = rel.catid'
					. ' WHERE rel.itemid = '.$item->id;

		$db->setQuery($query);
		$directory = $db->loadResult();
		
		//Get the lists
		$lists = $this->_buildEditLists($user->id);

		//Load the JEditor object
		$editor =& JFactory::getEditor();

		//Build the page title string
		$title = $item->id ? JText::_('Edit') : JText::_('New');

		//Set page title
		$document->setTitle($title);

		//get pathway
		$pathway =& $mainframe->getPathWay();
		$pathway->addItem($title, '');

		//Ensure the row data is safe html
		JFilterOutput::objectHTMLSafe( $item, ENT_QUOTES );

		$this->assign('action', 	$uri->toString());
		$this->assign('config', 	$config);
		$this->assignRef('item',	$item);
		$this->assignRef('params',	$params);
		$this->assignRef('lists',	$lists);
		$this->assignRef('editor',	$editor);
		$this->assignRef('user',	$user);
		$this->assignRef('tags',	$tags);
		$this->assignRef('used',	$used);
		$this->assignRef('directory',	$directory);

		parent::display($tpl);
	}
	
	function getViewUrl ( $id=0, $params='' )
	{
		if ( $id ) {
			$params .= '&id=' . intval( $id ) ;
		}
	  
		return JRoute::_( $params );
	}
	
	/**
	 * Creates the item submit form
	 *
	 * @since 1.0
	 */
	function _buildEditLists($userid)
	{
		//Get the item from the model
		$item 		= & $this->get('Item');
		//get the categories tree
		$categories = photomapgallery_cats::getCategoriesTree(1, $userid);
		//get ids of selected categories (edit action)
		$selectedcats = & $this->get( 'Catsselected' );
		
		//build selectlist
		$lists = array();
		$lists['cid'] = photomapgallery_cats::buildcatselect($categories, 'cid', $selectedcats, false, 'class="inputbox required validate-cid" size="8"');
		
		$published = array();
		$published[] = JHTML::_('select.option',  0, JText::_( 'UNPUBLISHED' ) );
		$published[] = JHTML::_('select.option',  1, JText::_( 'PUBLISHED' ) );

		$lists['published'] = JHTML::_('select.genericlist', $published, 'published', '', 'value', 'text', $item->published );
		
		$mapdisplay = array();
		$mapdisplay[] = JHTML::_('select.option',  1, JText::_( 'SHOW' ) );
		$mapdisplay[] = JHTML::_('select.option',  0, JText::_( 'HIDE' ) );

		$lists['mapdisplay'] = JHTML::_('select.genericlist', $mapdisplay, 'mapdisplay', '', 'value', 'text', $item->mapdisplay );
		
		$ajaxmap[] = JHTML::_('select.option',  '1', JText::_( 'YES' ) );
		$ajaxmap[] = JHTML::_('select.option',  '0', JText::_( 'NO' ) );
		$lists['ajaxmap'] = JHTML::_('select.genericlist', $ajaxmap, 'ajaxmap', '', 'value', 'text', $item->ajaxmap );
/*
echo "<pre>";
echo "view=";
print_r($item);
echo "</pre>";
*/
		return $lists;
	}

	function sizer($min, $max, $no, $minsize, $maxsize)
	{		
		$spread = $max - $min;
		if (0 == $spread) {
	   		$spread = 1;
		}

		$step = ($maxsize - $minsize) / $spread;

    	$size = $minsize + (($no - $min) * $step);
		$size = ceil($size);
		
		if ($size > $maxsize)
			$size = $maxsize;
		
		return $size;
	}
	
	
	function getOption($key) {
		$_options = array();
		if (isset($_options[$key])) return $_options[$key];
		return NULL;
	}

	function setexifvars() {

		foreach ($zp_exifvars as $key=>$item) {
			$exifvars[$key][3] = getOption($key);
		}
	}
	
	function getMetaData() {
		require_once(dirname(__FILE__).'/exif/exif.php');
		global $_zp_exifvars;
		$exif = array();
		// Put together an array of EXIF data to return
		foreach($_zp_exifvars as $field => $exifvar) {
			$exif[$field] = $this->get($field);
		}
		return $exif;
	}
/*	
	function set($var, $value) {
		if (empty($var)) return false;
		if ($this->loaded && !array_key_exists($var, $this->data)) {
			$this->tempdata[$var] = $value;
		} else {
			$this->updates[$var] = $value;
		}
		return true;
	}
*/	
	
}

?>