<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the PhotoMap Gallery View
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class photomapgalleryViewProfile extends JView
{
	/**
	 * Creates the Forms for the View
	 *
	 * @since 1.0
	 */
	function display( $tpl = null )
	{
		global $mainframe, $gconf;

		//initialize variables
		$db    		= JFactory::getDBO();
		$document 	= & JFactory::getDocument();
		$menus		= & JSite::getMenu();
		$lang 		= & JFactory::getLanguage();
		$menu		= $menus->getActive();
		$params 	= $mainframe->getParams('com_photomapgallery');
		$juser		= JFactory::getUser();
		
		$userid		= JRequest::getInt('userid', 0);

		$limit_comment = 5;
		
		$model	= &$this->getModel();
		$user 	= $model->getData($userid);
		
		$latestitems = $model->getLatestItems($userid);
		$mostvieweditems = $model->getMostViewedItems($userid);
		$mostrateditems = $model->getMostRatedItems($userid);
		$totalimage = $model->getImageTotal($userid);
		$totalcategory = $model->countCategories($userid);
		$alluseritems = $model->getAllUserItem($userid);
		$latestcommnets = $model->getLatestComments($userid, $limit_comment);
		
		$cat_model	= &$this->getModel( 'Category' );
		$maincat = $cat_model->getMainCategory($userid);

		$fav_model	= &$this->getModel( 'Favourites' );
		$fav_model->setState('limit', 27);
		$favs = $fav_model->getData($userid);
		$totalfavs = $fav_model->getTotal($userid);
		
		//add css file
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery.css');
		if ($lang->isRTL()) {
			$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery_rtl.css');
		}

		if ($gconf->api_key) {
			$document->addScript( 'http://maps.google.com/maps?file=api&amp;v=2.x&amp;key=' . $gconf->api_key . '&amp;hl=' . $a_lang[0] );
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/photomap_packed.js');
		}
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/qtabs.js');	
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/slimbox.js');
		
		$title = $user->name."'s Profile";
		$params->set('page_title', $title);

		/*
		* Handle the metadata for the hotel guide list
		*/
		$document->setTitle($params->get('page_title'));
		$document->setMetadata( 'keywords' , $params->get('page_title') );

		if ($mainframe->getCfg('MetaTitle') == '1') {
			$mainframe->addMetaTag('title', $params->get('page_title'));
		}
				
		if ($params->get('show_feed_link', 1) == 1) {
			//add alternate feed link
			$link	= '&format=feed';
			$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
			$document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
			$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
			$document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
		}

		$pathway =& $mainframe->getPathway();
//		$pathway->addItem( $params->get('page_title') );

		

		$this->assignRef('params', 			$params);
		$this->assignRef('user',	 		$user);
		$this->assignRef('juser',	 		$juser);
		$this->assignRef('maincat',	 		$maincat);
		$this->assignRef('favs',	 		$favs);
		$this->assignRef('totalfavs',	 	$totalfavs);
		$this->assignRef('latestitems',	 	$latestitems);
		$this->assignRef('mostvieweditems',	$mostvieweditems);
		$this->assignRef('mostrateditems',	$mostrateditems);
		$this->assignRef('totalimage',	 	$totalimage);
		$this->assignRef('totalcategory',	$totalcategory);
		$this->assignRef('alluseritems',	$alluseritems);
		$this->assignRef('latestcommnets',	$latestcommnets);
		$this->assignRef('gconf',	 		$gconf);
/*
		echo "<pre>";
		echo "view=";
		print_r($user);
		echo "</pre>";
*/
		parent::display($tpl);
	}
}
?>