<?php

/**
 * @version 1.1.0 $Id: specialitem_view.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.application.component.view');

/**
 * HTML View class for the HelloWorld Component
 *
 * @package    HelloWorld
 */

class photomapgalleryViewSpecialItem extends JView
{
	function display( $tpl = null )
	{
		global $mainframe;

		//initialize variables
		$document 	= & JFactory::getDocument();
		$menus		= & JSite::getMenu();
		$menu    	= $menus->getActive();
		$params 	= & $mainframe->getParams('com_photomapgallery');
		$lang 		= & JFactory::getLanguage();
		$config  	= & GUtil::config();

		// Request variables
		$limitstart		= JRequest::getInt('limitstart');
		
		//add css file
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery.css');
		if ($lang->isRTL()) {
			$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery_rtl.css');
		}
	
		$document->addCustomTag('<!--[if IE]><style type="text/css">.floattext{zoom:1;}, * html #photomapgallery dd { height: 1%; }, ul.vote-stars li.current-rating{top:-1.5pt;}</style><![endif]-->');

		$document->addCustomTag('<!--[if lte IE 6]>
<script language="javascript" type="text/javascript" src="/components/com_photomapgallery/assets/js/DD_belatedPNG.js"></script>
<link rel="stylesheet" href="/components/com_photomapgallery/assets/css/template_ie6.css" type="text/css" />
<script type="text/javascript">
DD_belatedPNG.fix("ul.vote-stars, ul.vote-stars li a:hover, ul.vote-stars li.current-rating, div#ThumbMatrix .shadow, div#ThumbMatrix .shadow div, div#ThumbMatrix .shadow span");
</script>
<![endif]-->');
		
		if ($config->mootools == 1) {
			JHTML::_('behavior.mootools'); 
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/mootools-release-1.11.js');
		}
		
		$mapkey = $config->api_key;
		
		if ($mapkey) {
			$a_lang = explode('-', $document->getLanguage());
			$document->addScript( 'http://maps.google.com/maps?file=api&amp;v=2.x&amp;key=' . $mapkey . '&amp;hl=' . $a_lang[0] );
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/photomap_packed.js');
		}
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/qtabs.js');	
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/slimbox.js');
		if ($config->showrating) {
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/vote.js');
		}
		
		//pathway
		$pathway 	= & $mainframe->getPathWay();

		$dynamic = $params->get('dynamic');
		// Get data from the model	
		$model	= &$this->getModel();

		if ($dynamic == 1) {
			$items 		= & $this->get('ViewedData');
			$maptype = $config->mostviewmaptype;
			$total 		= $config->mostviewed;
			$title = JText::_('MOST VIEWED PHOTOS');
		}
		else if ($dynamic == 2) {
			$items 		= & $this->get('NewData');
			$maptype = $config->newviewmaptype;
			$total 		= $config->newphotos;
			$title = JText::_('NEW PHOTOS');
		}
		else if ($dynamic == 3) {
			$items 		= & $this->get('RandomData');
			$maptype = $config->randomviewmaptype;
			$total 		= & $this->get('ViewedTotal');
			$title = JText::_('RANDOM PHOTOS');
		}
		
		$limit		= $mainframe->getUserStateFromRequest('com_photomapgallery.'.$this->getLayout().'.limit', 'limit', $config->imagelimit, 'int');
		
		// because the application sets a default page title, we need to get it
		// right from the menu item itself
		if (is_object( $menu )) {
			$menu_params = new JParameter( $menu->params );		
			
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title',	$title);
			}
			
		} else {
			$params->set('page_title',	$title);
		}

		/*
		* Handle the metadata for a categoy
		*/
		$document->setTitle( $params->get( 'page_title' ) );
/*		
		if ($category->meta_description) {
			$document->setDescription( $category->meta_description );
		}
		if ($category->meta_keywords) {
			$document->setMetadata('keywords', $category->meta_keywords);
		}
*/		if ($mainframe->getCfg('MetaTitle') == '1') {
			$mainframe->addMetaTag('title', $title);
		}
		
		if ($params->get('show_feed_link', 1) == 1) {
			//add alternate feed link
			$link	= '&format=feed';
			$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
			$document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
			$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
			$document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
		}

		// Create the pagination object
		jimport('joomla.html.pagination');

		$pageNav 	= new JPagination($total, $limitstart, $limit);

		$mapdisplay = 0;
		for ($i = 0; $i < count($items); $i++) {
			if ($items[$i]->lat && $items[$i]->mapdisplay == 1)
				$mapdisplay = 1;						
		}

		$this->assignRef('config', 					$config);
		$this->assignRef('params' , 				$params);
		$this->assignRef('categories', 				$categories);
		$this->assignRef('items', 					$items);
		$this->assignRef('category', 				$category);
		$this->assignRef('pageNav', 				$pageNav);
		$this->assignRef('maptype',					$maptype);
		$this->assignRef('mapdisplay',				$mapdisplay);
		$this->assignRef('dynamic',					$dynamic);
/*
		echo "<pre>";
		echo "view=";
		print_r($items[0]);
		echo "</pre>";
*/
		parent::display($tpl);
	}
}
?>