<?php

/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * PhotoMap Gallery is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Items View
 *
 * @package Joomla
 * @subpackage FLEXIcontent
 * @since 1.0
 */
class photomapgalleryViewTags extends JView
{
	/**
	 * Creates the item page
	 *
	 * @since 1.0
	 */
	function display( $tpl = null )
	{
		global $mainframe;

		//initialize variables
		$document 	= & JFactory::getDocument();
		$menu		= & JSite::getMenu();
		$uri 		= & JFactory::getURI();
//		$item    	= $menu->getActive();
		$params 	= & $mainframe->getParams('com_photomapgallery');
		$config  	= & GUtil::config();
		
		$tid 			= JRequest::getInt('id', 0);
		$limitstart		= JRequest::getInt('limitstart');
		$filter			= JRequest::getString('filter');
//		$limit			= $mainframe->getUserStateFromRequest('com_photomapgallery.tags.limit', 'limit', $params->def('limit', 0), 'int');
		$limit			= $config->tagmaximage;

		//add css file
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery.css');
		$document->addCustomTag('<!--[if IE]><style type="text/css">.floattext {zoom:1;}</style><![endif]-->');

		$model	= &$this->getModel();
		$items 	= & $this->get('Data');
		$tag	= & $this->get('Tag');
		$total 	= & $this->get('Total');
		$alltags		= $model->getAlltags($items[0]->user_id);
		$counttags 		= $model->getLimitTags($items[0]->user_id, 150);
		$user		= $model->getAvatar($items[0]->user_id);
        
		$maincat 	= $model->getMainCategory((int)$items[0]->user_id);
		
        //set 404 if category doesn't exist or access isn't permitted
		if ( empty($tag) ) {
			return JError::raiseError( 404, JText::sprintf( 'Tag #%d not found', $tid ) );
		}
		
		$author=JFactory::getUser($items[0]->user_id);		
		$title = $author->name.JTEXT::_("'s Tags").JTEXT::_(" - ").$tag->name;

		$params->set('page_title',	$title);
		
		//params
//		@$params->def( 'page_title', $tag->name);

		//pathway
		$pathway 	= & $mainframe->getPathWay();
		$pathway->setItemName( 1, $title );

		//Set Page title
//		if (!@$item->name) {
			$document->setTitle($params->get('page_title'));
			$document->setMetadata( 'keywords' , $params->get('page_title') );
//		}
		
		
        
		$max = count($alltags);
		$min = (int)$alltags[sizeof($alltags)-1];
		
		$minsize 	= 1;
		$maxsize 	= 10;
		
		$i		= 0;
		$taglists	= array();
		foreach ( $counttags as $subtag )
		{	
			$taglists[$i]->size 			= $this->sizer($min, $max, $subtag->no, $minsize, $maxsize);
			$taglists[$i]->name 			= $subtag->name.'&nbsp;&nbsp;';
			$taglists[$i]->screenreader		= JText::sprintf('NR_ITEMS_TAGGED', $subtag->no);
			$taglists[$i]->link 			= JRoute::_(photomapgalleryHelperRoute::getTagRoute($subtag->slug));
			$i++;
		}
		
        //ordering
		$filter_order		= JRequest::getCmd('filter_order', 'i.title');
		$filter_order_Dir	= JRequest::getCmd('filter_order_Dir', 'ASC');
		
		$lists						= array();
		$lists['filter_order']		= $filter_order;
		$lists['filter_order_Dir'] 	= $filter_order_Dir;
		$lists['filter']			= $filter;
		
				
		// Create the pagination object
		jimport('joomla.html.pagination');
		
		$pageNav 	= new JPagination($total, $limitstart, $limit);
		
		$this->assign('action', 					$uri->toString());

		$this->assignRef('items' , 					$items);
		$this->assignRef('tag' , 					$tag);
		$this->assignRef('alltags' , 				$alltags);
		$this->assignRef('taglists',				$taglists);
		$this->assignRef('user',					$user);
		$this->assignRef('params' , 				$params);
		$this->assignRef('pageNav' , 				$pageNav);
		$this->assignRef('lists' ,	 				$lists);
		$this->assignRef('config' ,	 				$config);
		$this->assignRef('maincat',					$maincat);

		parent::display($tpl);

	}
	
	function sizer($min, $max, $no, $minsize, $maxsize)
	{		
		$spread = $max - $min;
		if (0 == $spread) {
	   		$spread = 1;
		}

		$step = ($maxsize - $minsize) / $spread;

    	$size = $minsize + (($no - $min) * $step);
		$size = ceil($size);
		
		if ($size > $maxsize)
			$size = $maxsize;
			
		return $size;
	}
}
?>