<?php
/**
 * @version 1.1.0 $Id: photomapgallery_files.php 2009-03-25 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 - 2010 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */



// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.client.helper' );
jimport( 'joomla.application.component.view');


/**
 * HTML View class for the HelloWorld Component
 *
 * @package    HelloWorld
 */

require_once (JPATH_COMPONENT_SITE.DS.'classes'.DS.'photomapgallery.categories.php');

class photomapgalleryViewUser extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;

		$document 	= & JFactory::getDocument();
		$db			= & JFactory::getDBO();
		$user		= JFactory::getUser();
		$params 	= & $mainframe->getParams('com_photomapgallery');
		$lang 		= & JFactory::getLanguage();
		$editor 	= & JFactory::getEditor();
		$uri 		= &JFactory::getURI();
		$action		= $uri->toString();
		$task		= JRequest::getVar('type');
		$tab		= JRequest::getVar('tab');
		$config  	= & GUtil::config();
		
		$catid		= JRequest::getInt('catid', 0);

		JHTML::_('behavior.formvalidation');
		
		// Only registered users
		if ($user->aid == 0) {
			$mainframe->redirect(JRoute::_('index.php?option=com_user&view=login', false), JText::_("ALERTNOTAUTH"));
			exit;
		}
		
		//add css file
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery.css');
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/qtabs.css');
		if ($lang->isRTL()) {
			$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery_rtl.css');
		}
	
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/qtabs.js');	
		
		$pathway 	= & $mainframe->getPathWay();
		
		if (is_object( $menu )) {
			$menu_params = new JParameter( $menu->params );		
			
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title', JText::_('USER PANEL'));
			}
			
		} else {
			$params->set('page_title', JText::_('USER PANEL'));
		}

		$document->setTitle( $params->get( 'page_title' ) );
		
		
		$modelUser	= &$this->getModel( 'User' );

		$existuser 	= $modelUser->getExistUser($user->id);
		$existcat 	= $modelUser->getExistCategory($user->id);
		$existitem 	= $modelUser->getExistItem($user->id);
		
		if ($existuser) {
			$usergroup		= $modelUser->getExistUserGroup( $user->id );
			
			if ($usergroup == true) {
				$galleryuser	= $modelUser->getData( $user->id );
				$maincat		= $modelUser->getMainCategory( $user->id );
	
				$query = "SELECT name FROM #__g_user_groups WHERE id = ".$galleryuser->group;
				$db->setQuery($query);
				$group = $db->loadObject();
			}
			else {
				$galleryuser	= $modelUser->getUserData( $user->id );
			}
		}
		else {
			$query = "SELECT name FROM #__g_user_groups";
			$db->setQuery($query);
			$group = $db->loadObject();
		}
		
		$lists = array ();
		
		if ($existcat && ($task != 'categoryedit' || $task != 'newcategory')) {
			$cat_filter_order	= $mainframe->getUserStateFromRequest( $option.'.user.filter_order', 'cat_filter_order', 'c.ordering', 'cmd' );
			$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.user.filter_order_Dir', 'cat_filter_order_Dir', '', 'word' );
			$cat_filter_state 	= $mainframe->getUserStateFromRequest( $option.'.user.filter_state', 'cat_filter_state', '', 'int' );
			$catsearch 			= $mainframe->getUserStateFromRequest( $option.'.user.search', 'catsearch', '', 'string' );
			$catsearch 			= $db->getEscaped( trim(JString::strtolower( $catsearch ) ) );
			
			$categories 	= $modelUser->getCategories($galleryuser->userID);
			$cat_pageNav 	= $modelUser->getCategoryPagination($galleryuser->userID);
			
			//publish unpublished filter
			$cat_lists['state']	= JHTML::_('grid.state', $cat_filter_state );
			
			// search filter
			$cat_lists['catsearch'] = $catsearch;
	
			// table ordering
			$cat_lists['order_Dir'] = $filter_order_Dir;
			$cat_lists['order'] = $cat_filter_order;
	
			$cat_ordering = ($cat_lists['order'] == 'c.ordering');
		}
	
		if (!$group->name)
			$group->name = $config->group;
			
		if (!$group->id)
			$group->id = 2;

		if ($task == 'categoryedit') {
			$row = $modelUser->getCategory($catid);
			$sub = $modelUser->getSubCategory($catid);
			
	//		$folder = $row->title.'-'.$row->userid;
			if (count($sub)) {
				$folder = $sub[0]->id;
				$directory = $sub[0]->directory;
			} else {
				$folder = $row->id;
				$directory = $row->directory;
			}

			$thumb_link = '../images/photomap/thumb/';
				
			//build image select js and load the view
			$js = "
			function gSelectImage(image, folder) {
				document.getElementById('a_image').value = image;
				document.getElementById('a_folder').value = folder;
				document.getElementById('imagelib').src = '$thumb_link' + image;
				document.getElementById('sbox-window').close();
			}";
	
			$link = 'index.php?option=com_photomapgallery&view=imagehandler&amp;task=selectimage&amp;tmpl=component&amp;folder='.$folder;
			$document->addScriptDeclaration($js);
			
			JHTML::_('behavior.modal', 'a.modal');
			
			$imageselect = "\n<input style=\"background: #ffffff;\" size=\"65\" type=\"text\" id=\"a_folder\" value=\"$row->image\" disabled=\"disabled\" onchange=\"javascript:if (document.forms[0].a_image.value!='') {document.imagelib.src='$thumb_link'+$directory/' + document.forms[0].a_folder.value + '/' + document.forms[0].a_image.value} else {document.imagelib.src='../media/com_photomapgallery/gallery/no_thumb.gif'}\"; /><br />";
	
			$imageselect .= "<div class=\"button\"><div class=\"blank\"><a class=\"modal\" title=\"".JText::_('SELECTIMAGE')."\" href=\"$link\" rel=\"{handler: 'iframe', size: {x: 650, y: 425}}\">".JText::_('SELECTIMAGE')."</a></div></div>\n";
	
			$imageselect .= "\n<input type=\"hidden\" class=\"button\" id=\"a_image\" name=\"image\" value=\"$row->image\" />";
		}
		else if ($task == 'newcategory') {
			
			$row->userid = $user->id;
		}
		
		if ($task == 'categoryedit' || $task == 'newcategory') {
			
			$maptype[] = JHTML::_('select.option',  'Map', JText::_( 'MAP' ) );
			$maptype[] = JHTML::_('select.option',  'Satellite', JText::_( 'SATELLITE' ) );
			$maptype[] = JHTML::_('select.option',  'Hybrid', JText::_( 'HYBRID' ) );
			$maptype[] = JHTML::_('select.option',  'Terrain', JText::_( 'TERRAIN' ) );
	
			$lists['maptype'] = JHTML::_('select.genericlist',   $maptype, 'maptype', '', 'value', 'text', $row->maptype );
			
			$categorytree = photomapgallery_cats::getCategoriesTree(1, $galleryuser->userID);
			$lists['parent_id'] = photomapgallery_cats::buildcatselect($categorytree, 'parent_id', $row->parent_id, false);
			
			$lists['access'] 	= JHTML::_('list.accesslevel', $row );
			
			$published[] = JHTML::_('select.option',  '1', JText::_( 'PUBLISHED' ) );
			$published[] = JHTML::_('select.option',  '0', JText::_( 'UNPUBLISHED' ) );
			$lists['published'] = JHTML::_('select.genericlist', $published, 'published', '', 'value', 'text', $row->published );
			
			$ajaxmap[] = JHTML::_('select.option',  '1', JText::_( 'YES' ) );
			$ajaxmap[] = JHTML::_('select.option',  '0', JText::_( 'NO' ) );
			$lists['ajaxmap'] = JHTML::_('select.genericlist', $ajaxmap, 'ajaxmap', '', 'value', 'text', $row->ajaxmap );
		}
		else if ($task == 'itemedit' || $task == 'newimage') {
			$document->addScript( JURI::base().'administrator/components/com_photomapgallery/assets/js/itemscreen.js' );
			
			if ($user->authorize('com_photomapgallery', 'newtags')) {
				$document->addScript( 'components/com_photomapgallery/assets/js/tags.js' );
			}
			
			$gid		= JRequest::getInt('gid', 0);
			$itemcategories = photomapgallery_cats::getCategoriesTree(1, $user->id);
			$selectedcats = $modelUser->getCatsselected( $gid );
			
			$item 		= $modelUser->getImageItem($gid);
			$used 		= $modelUser->getUsedTags($gid);
			
			//ensure $used is an array
			if(!is_array($used)){
				$used = array();
			}
			
			//build selectlists
			$itemedit_lists = array();
			$itemedit_lists['cid'] = photomapgallery_cats::buildcatselect($itemcategories, 'cid', $selectedcats, false, 'size="10"');
			$published[] = JHTML::_('select.option',  '1', JText::_( 'PUBLISHED' ) );
			$published[] = JHTML::_('select.option',  '0', JText::_( 'UNPUBLISHED' ) );
			$itemedit_lists['published'] = JHTML::_('select.genericlist', $published, 'published', '', 'value', 'text', $item->published );
			
			$mapdisplay[] = JHTML::_('select.option',  '1', JText::_( 'YES' ) );
			$mapdisplay[] = JHTML::_('select.option',  '0', JText::_( 'NO' ) );
			$itemedit_lists['mapdisplay'] = JHTML::_('select.genericlist', $mapdisplay, 'mapdisplay', '', 'value', 'text', $item->mapdisplay );
	
			if ($task == 'itemedit') {
				$query = 'SELECT *'
						. ' FROM #__g_categories'
						. ' WHERE id = '.$selectedcats[0];
							
				$db->setQuery($query);
				$parent_cat = $db->loadObject();
			}
		}

		$genderOptions[] = JHTML::_('select.option', 'm', JText::_('MALE'));
		$genderOptions[] = JHTML::_('select.option', 'f', JText::_('FEMALE'));
		$lists['gender'] = JHTML::_('select.genericlist', $genderOptions, 'gender','','value','text', $galleryuser->gender);

		if ($existcat) {
			$img_filter_order		= $mainframe->getUserStateFromRequest( $option.'.user.img_filter_order', 'img_filter_order', 'i.ordering', 'cmd' );
			$img_filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.user.img_filter_order_Dir', 'img_filter_order_Dir', '', 'word' );
			$filter_state 		= $mainframe->getUserStateFromRequest( $option.'.user.filter_state', 'filter_state', '*', 'word' );
			$img_filter_category 	= $mainframe->getUserStateFromRequest( $option.'.user.img_filter_category', 'img_filter_category',0, 'int');
			$img_search 		= $mainframe->getUserStateFromRequest( $option.'.user.img_search', 'img_search', '', 'string' );
			$img_search 		= $db->getEscaped( trim(JString::strtolower( $img_search ) ) );
		
			$items      = $modelUser->getImageItems($user->id);
			$pageNav 	= $modelUser->getImagePagination($user->id);
			
			//publish unpublished filter
			$filter_state_options[] = JHTML::_('select.option', -1, JText::_('- SELECT STATE -'));
			$filter_state_options[] = JHTML::_('select.option', 1, JText::_('PUBLISHED'));
			$filter_state_options[] = JHTML::_('select.option', 0, JText::_('UNPUBLISHED'));
			$itemlists['state'] = JHTML::_('select.genericlist', $filter_state_options, 'filter_state', 'onchange="this.form.submit();"', 'value', 'text', $filter_state);
		
			// search filter
			$itemlists['img_search']= $img_search;
	
			// table ordering
			$itemlists['order_Dir'] = $img_filter_order_Dir;
			$itemlists['order'] = $img_filter_order;
	
			$itemordering = ($itemlists['order'] == 'i.ordering');
			
			$categories_option[]=JHTML::_('select.option', 0, JText::_('- SELECT CATEGORY -'));
			$itemcategories = photomapgallery_cats::getCategoriesTree(1, $user->id);
			$categories_options=@array_merge($categories_option, $itemcategories);
			$itemlists['itemcategories'] = JHTML::_('select.genericlist', $categories_options, 'filter_category', 'onchange="this.form.submit();"', 'value', 'text', $filter_category); 
		}

		if ($tab == "category") 
			$cur_tab = 1;
		else if ($tab == "image") 
			$cur_tab = 2;
		else
			$cur_tab = 0;
		
		$this->assignRef('params', 			$params);
		$this->assignRef('action', 			$action);
		$this->assignRef('user', 			$user);
		$this->assignRef('galleryuser', 	$galleryuser);
		$this->assignRef('lists', 			$lists);
		$this->assignRef('cat_lists', 		$cat_lists);
		$this->assignRef('cat_ordering', 	$cat_ordering);
		$this->assignRef('group', 			$group);
		$this->assignRef('editor', 			$editor);
		$this->assignRef('maincat', 		$maincat);
		$this->assignRef('catid', 			$catid);
		$this->assignRef('categories', 		$categories);
		$this->assignRef('cat_pageNav', 	$cat_pageNav);
		$this->assignRef('pageNav', 		$pageNav);
		$this->assignRef('task',			$task);
		$this->assignRef('existcat',		$existcat);
		$this->assignRef('existitem',		$existitem);
		$this->assignRef('row',				$row);
		$this->assignRef('imageselect',		$imageselect);
		
		$this->assignRef('items',			$items);
		$this->assignRef('item',			$item);
		$this->assignRef('itemordering',	$itemordering);
		$this->assignRef('itemlists',		$itemlists);
		$this->assignRef('parent_cat',		$parent_cat);
		$this->assignRef('used',			$used);
		$this->assignRef('config',			$config);
		$this->assignRef('itemedit_lists',	$itemedit_lists);
		$this->assignRef('cur_tab',			$cur_tab);
/*	
		echo "<pre>";
		echo "view=";
		print_r($parent_cat);
		echo "</pre>";
*/	
		parent::display($tpl);
	}
 }

?>