<?php
/**
 * @version 1.0 $Id: photomapgallery_files.php 195 2009-05-30 $
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @copyright (C) 2009 Oh-Taek Im
 * @license GNU/GPL, see LICENCE.php
 * PhotoMap Gallery is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * PhotoMap Gallery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with PHOTOMAP GALLERY; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

if ($this->gconf->api_key && $this->mapdisplay == 1) {
	echo gallery_html::getmap($this->gconf, $this->mapdatas, $this->category->maptype, $this->category->ajaxmap, true);
}

 
echo '<h1 class="componentheading">';
	if ($this->category) {
		$link = photomapgalleryHelperRoute::getUserCategoryRoute($this->category->parent_id);
		echo "<a href='".JRoute::_( $link )."'>";
		echo $this->params->get('page_title').'</a>';
	} else {
		echo $this->params->get('page_title');
	}
echo '</h1>' . "\n";

echo '<div style="clear:both;padding-bottom:10px;"></div>' . "\n";

echo '<p class="buttons">' . "\n";
	if ($this->category && $this->user->id == $this->category->userid) {
		echo gallery_html::add_category_button( $this->params );
		echo gallery_html::edit_category_button( $this->category, $this->params );
	}
echo '</p>' . "\n";


if ($this->gconf->api_key && $this->mapdisplay == 1) {	
	echo gallery_html::boxtop();
		echo '<div id="map_canvas" style="width:100%; height:400px"></div>';
	echo gallery_html::boxbottom();
}

echo '<div style="clear:both;padding-bottom:10px;"></div>' . "\n"; 


$cellwidth = (100 / $this->gconf->collimit) - 0.2;

echo '<div id="ThumbMatrix">' . "\n"; 
	foreach($this->categories as $item) {
		if ($item->groupname == "Site Owner") continue;
		echo '<div class="AlbumCell" style="width: '.$cellwidth.'%; height: '.$this->gconf->cellheight.'px;">' . "\n"; 
		if ($item->title) {
			$shadow = 8;

			if (!$item->width)
				$item->width = 150;
			if (!$item->height)
				$item->height = 100;
			if ($this->gconf->frame == 'Shadow') {
				$frame_width = $item->width + $shadow;
				$frame_height = $item->height + $shadow;
			} else if ($this->gconf->frame == 'Polaroid Shadow' || $this->gconf->frame == 'Polaroid') {
				$back_width = $item->width  + $this->gconf->sidemargin * 2;
				$back_height = $item->height + $this->gconf->topmargin + $this->gconf->bottommargin;
				$frame_width = $back_width + $shadow;
				$frame_height = $back_height + $shadow;
			}
			
			if ($this->gconf->frame == 'Shadow') {
				echo '<div class="shadow" style="width:'.$frame_width.'px; height:'.$frame_height.'px;"><div class="left"><span><b>' . "\n"; 
			} else if ($this->gconf->frame == 'Polaroid Shadow') {
				echo '<div class="shadow" style="width:'.$frame_width.'px; height:'.$frame_height.'px;"><div class="left"><span style="width:'.$back_width.'px; height:'.$back_height.'px;"><b>' . "\n";
				echo '<div class="inner" style="background-color:'.$this->gconf->framecolor.'; left:0px; top:0px; width:'.$back_width.'px; height:'.$back_height.'px;">' . "\n";
			} else if ($this->gconf->frame == 'Polaroid') {
				echo '<div class="inner" style="margin: 0 auto; background-color:'.$this->gconf->framecolor.'; width:'.$back_width.'px; height:'.$back_height.'px;">' . "\n";
			}
				
			$link = JRoute::_( photomapgalleryHelperRoute::getUserCategoryRoute($item->slug, $item->catslug));

			echo '<a href="'.$link.'">';
			if ($item->image) 
				$imagelink = JURI::base().'images/photomap/user/resized/'.$item->image;
			else
				$imagelink = JURI::base().'administrator/components/com_photomapgallery/assets/images/no_listthumb.gif';
				
			if ($this->gconf->frame == 'Solid') {
				echo '<img src="'.$imagelink.'" title="'.$item->title.'" alt="'.$item->title.'" style="border: 1px solid '.$this->gconf->framecolor.';"/></a>';
			} else if ($this->gconf->frame == 'Polaroid Shadow') {
				echo '<img src="'.$imagelink.'" title="'.$item->title.'" alt="'.$item->title.'" style="left:0px; top:'.$this->gconf->topmargin.'px;"/></a>';
			} else if ($this->gconf->frame == 'Polaroid') {
				echo '<img src="'.$imagelink.'" title="'.$item->title.'" alt="'.$item->title.'" style="position: relative; top:'.$this->gconf->topmargin.'px;"/></a>';
			} else if ($this->gconf->frame == 'Shadow') {
				echo '<img src="'.$imagelink.'" title="'.$item->title.'" alt="'.$item->title.'" style="left:0;"/></a>';
			} else {
				echo '<img src="'.$imagelink.'" title="'.$item->title.'" alt="'.$item->title.'"/></a>';
			}


			if ($this->gconf->frame == 'Shadow') {
				echo '</b></span></div></div>' . "\n"; 
			} else if ($this->gconf->frame == 'Polaroid Shadow') {
				echo '</div>' . "\n";
				echo '</b></span></div></div>' . "\n"; 
			} else if ($this->gconf->frame == 'Polaroid') {
				echo '</div>' . "\n";
			}
				
			echo '<p class="albumTitle">' . "\n"; 
			echo '&#9642; &nbsp;'.$item->title.'&nbsp; &#9642'; 
			echo '</p>' . "\n"; 

			if ($item->groupname != "Site Owner") {
				$author=JFactory::getUser($item->userid);
				echo '<p class="imageInfo" style="margin:0;">' . "\n"; 
				echo JText::_('OWNER').':&nbsp;'.$author->name;
				echo '</p>' . "\n"; 
			}
			if (count($item->subcats) > 0) {
				echo '<p class="imageInfo" style="margin:5px 0 0 0;">' . "\n"; 
				echo JText::_('GALLERIES').':&nbsp;'.count($item->subcats);
				echo '</p>' . "\n"; 
			}
			
			if ($item->assignedgalleryitems > 0) {
				echo '<p class="imageInfo" style="margin:5px 0 0 0;">' . "\n"; 
				echo JText::_('IMAGES').':&nbsp;'.$item->assignedgalleryitems;
				echo '</p>' . "\n"; 
			} else if ($item->assignedgalleryitems < 1 && count($item->subcats) < 0) {
				echo '<p class="imageInfo" style="margin:0;">' . "\n"; 
				echo JText::_('NO IMAGE');
				echo '</p>' . "\n"; 
			}
		} else {
			echo '<img src= "'.JURI::base().'administrator/components/com_photomapgallery/assets/images/no_listthumb.gif" title="'.JText::_('SELECT A CATEGORY IMAGE').'" />';
		}	
		echo '</div>' . "\n"; 
	}

echo '</div>' . "\n"; 
echo '<div style="clear:both;padding-bottom:10px;"></div>' . "\n";

						
?>
