<?php
/**
 * @version		1.0.0 photomapgallery $
 * @package		photomapgallery
 * @copyright	Copyright  2009 - All rights reserved.
 * @license		GNU/GPL
 * @author		Oh-Taek Im
 * @author mail	pixeldraw@photoindochina.com
 * @website		www.photoindochina.com
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the PhotoMap Gallery View
 *
 * @package Joomla
 * @subpackage PhotoMap Gallery
 * @since 1.0
 */
class photomapgalleryViewUserGallery extends JView
{
	/**
	 * Creates the Forms for the View
	 *
	 * @since 1.0
	 */
	function display( $tpl = null )
	{
		global $mainframe, $gconf;

		//initialize variables
		$document 	= & JFactory::getDocument();
		$user		= & JFactory::getUser();
		$menus		= & JSite::getMenu();
		$menu    	= $menus->getActive();
		$params 	= & $mainframe->getParams('com_photomapgallery');
		$uri 		= & JFactory::getURI();
		$lang 		= & JFactory::getLanguage();

		// Request variables
		$limitstart	= JRequest::getInt('limitstart');
		$cid		= JRequest::getInt('cid', 0);
		
		if($this->getLayout() == 'form') {
			$this->_displayForm($tpl);
			return;
		}
		
		//add css file
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery.css');
		if ($lang->isRTL()) {
			$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery_rtl.css');
		}
	
		$document->addCustomTag('<!--[if IE]><style type="text/css">.col1 {float:left;}, .col3 {width: 24.99%;top:5px;float:left;}, .col3 a img {top: -12px;}, .col3 .trans{top: 8px; }, .floattext{zoom:1;}, * html #tourguide dd { height: 1%; }</style><![endif]-->');

		$document->addCustomTag('<!--[if lte IE 6]>
<script language="javascript" type="text/javascript" src="/components/com_photomapgallery/assets/js/DD_belatedPNG.js"></script>
<link rel="stylesheet" href="/components/com_photomapgallery/assets/css/template_ie6.css" type="text/css" />
<script type="text/javascript">
DD_belatedPNG.fix("div#box div.box-t, div#box div.box-tl, div#box div.box-tr, div#box div.box-l, div#box div.box-r, div#box div.box-m, div#box div.box-b, div#box div.box-bl, div#box div.box-br, div#box h3.title, .col3, .col3 .trans, a.readon, a.readmore, .toggler");
</script>
<![endif]-->');
		if ($gconf->showrating) {
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/vote.js');
		}

		if ($gconf->mootools == 1) {
			JHTML::_('behavior.mootools'); 
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/mootools-release-1.11.js');
		}
		
		$mapkey = $gconf->api_key;
		$a_lang = explode('-', $document->getLanguage());
		if ($mapkey) {
			$document->addScript( 'http://maps.google.com/maps?file=api&amp;v=2.x&amp;key=' . $mapkey . '&amp;hl=' . $a_lang[0] );
			$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/photomap_packed.js');
		}
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/qtabs.js');	
		$document->addScript( $this->baseurl.'/components/com_photomapgallery/assets/js/slimbox.js');
		
		//pathway
		$pathway 	= & $mainframe->getPathWay();

		// Get data from the model	
		$model	= &$this->getModel();
		
		$category 	= & $this->get('Category');
		$items 		= & $this->get('Data');
		$limit		= $mainframe->getUserStateFromRequest('com_photomapgallery.'.$this->getLayout().'.limit', 'limit', $gconf->imagelimit, 'int');
		$total 		= & $this->get('Total');
		
		$cats		= new photomapgallery_cats((int)$category->id);
		$parents	= $cats->getParentlist();
		$categories	= & $this->get('UserChilds');
		
//		$usercategory 	= & $this->get('UserCategory');
		
//		$params->set('page_title',	$category->title);

		$author=JFactory::getUser($category->userid);
		
		$username = JTEXT::_(' - ').$author->name;
/*		if (is_object( $menu )) {
			$menu_params = new JParameter( $menu->params );		
			
			if ($category->title)
				$params->set('page_title',	$category->title.$username);
			else 
				$menu_params->get( 'page_title');
		} else {
	//		$params->set('page_title',	$category->title.$username);
			$params->set('page_title',	'User Gallery');
		}
*/		
		if (is_object( $menu )) {
			$menu_params = new JParameter( $menu->params );		
			
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title',	$category->title.$username);
			}
		} else {
			$params->set('page_title',	$category->title);
		}
		
		foreach($parents as $parent) {
			$pathway->addItem( $this->escape($parent->title), JRoute::_('index.php?view=category&cid='.$parent->slug));
		}

		/*
		* Handle the metadata for a categoy
		*/
		$document->setTitle( $params->get( 'page_title' ) );
		
		if ($category->meta_description) {
			$document->setDescription( $category->meta_description );
		}
		if ($category->meta_keywords) {
			$document->setMetadata('keywords', $category->meta_keywords);
		}
		if ($mainframe->getCfg('MetaTitle') == '1') {
			$mainframe->addMetaTag('title', $category->title);
		}
		
		if ($params->get('show_feed_link', 1) == 1) {
			//add alternate feed link
			$link	= '&format=feed';
			$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
			$document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
			$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
			$document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
		}

		//ordering
		$filter_order		= JRequest::getCmd('filter_order', 'i.title');
		$filter_order_Dir	= JRequest::getCmd('filter_order_Dir', 'ASC');
		$filter				= JRequest::getString('filter');
		
		$lists						= array();
		$lists['filter_order']		= $filter_order;
		$lists['filter_order_Dir'] 	= $filter_order_Dir;
		$lists['filter']			= $filter;

		// Create the pagination object
		jimport('joomla.html.pagination');

		$pageNav 	= new JPagination($total, $limitstart, $limit);
		
		$number = count($categories);
		$n = 0;
		for ($i = 0; $i < $number; $i++) {
			$sub = count($categories[$i]->subcats);
			if ($sub > 0) {
				for ($j = 0; $j < $sub; $j++) {
					$mapdatas[$n] = $model->getMapData((int)$categories[$i]->subcats[$j]->id);
					$n++;
				}
			} else {
				$mapdatas[$n] = $model->getMapData((int)$categories[$i]->id);
				$n++;
			}
		}
		
		for ($i = 0; $i < count($mapdatas); $i++) {
			if (empty($mapdatas[$i]))
				$mapdisplay = 0;
			else
				$mapdisplay = 1;						
		}

		$this->assignRef('gconf', 					$gconf);
		$this->assign('action', 					$uri->toString());	
		$this->assignRef('params', 					$params);
		$this->assignRef('categories', 				$categories);
		$this->assignRef('items', 					$items);
		$this->assignRef('category', 				$category);
		$this->assignRef('user', 					$user);
		$this->assignRef('pageNav', 				$pageNav);
		$this->assignRef('lists',	 				$lists);
		$this->assignRef('mapdatas',				$mapdatas);
		$this->assignRef('mapdisplay', 				$mapdisplay);
/*
		echo "<pre>";
		echo "view=";
		print_r($categories);
		echo "</pre>";
*/
		parent::display($tpl);
	}
	
	/**
	 * Creates the category submit form
	 *
	 * @since 1.0
	 */
	function _displayForm($tpl)
	{
		global $mainframe, $gconf;

		//Initialize variables
		$document	=& JFactory::getDocument();
		$user		=& JFactory::getUser();
		$uri     	=& JFactory::getURI();
		
		$params		=& $mainframe->getParams('com_photomapgallery');
		$db  		= & JFactory::getDBO();
		$task		= JRequest::getVar('task');

		$cid 		= JRequest::getVar( 'cid' );
		
		//Add the js includes to the document <head> section
		JHTML::_('behavior.formvalidation');
		JHTML::_('behavior.tooltip');
		
		//add css file
		$document->addStyleSheet($this->baseurl.'/components/com_photomapgallery/assets/css/photomapgallery.css');
		$document->addCustomTag('<!--[if IE]><style type="text/css">.floattext{zoom:1;}, * html #photomapgallery dd { height: 1%; }</style><![endif]-->');
		
		$model	= &$this->getModel();
		
		$category 	= & $this->get('Category');
		$sub     	= & $this->get('SubCategory');
		$item		=& $this->get('Data');
		$maincat = $model->getMainCategory($user->id);

		//check if we have an id(edit) and check if we have global edit rights or if we are allowed to edit own items.
		if( $item->id > 1 && !($user->authorize('com_photomapgallery', 'edit') || ($user->authorize('com_content', 'edit', 'content', 'own') && $item->created_by == $user->get('id')) ) ) {
			JError::raiseError( 403, JText::_("ALERTNOTAUTH") );
		}

		if ( $category->title ) {
//			$folder = $category->title.'-'.$category->userid;
			$folder = $category->id;
			$directory = $category->directory;

			$thumb_link = '../images/photomap/thumb/';

			//build image select js and load the view
			$js = "
				function gSelectImage(image, folder) {
					document.getElementById('a_image').value = image;
					document.getElementById('a_folder').value = folder;
					document.getElementById('imagelib').src = '$thumb_link' + folder;
					document.getElementById('sbox-window').close();
				}";

			$link = 'index.php?option=com_photomapgallery&amp;view=imagehandler&amp;task=selectimage&amp;tmpl=component&amp;folder='.$folder;
			$document->addScriptDeclaration($js);
			
			JHTML::_('behavior.modal', 'a.modal');
			
			$imageselect = "\n<input style=\"background: #ffffff;\" size=\"65\" type=\"text\" id=\"a_folder\" value=\"$category->image\" disabled=\"disabled\" onchange=\"javascript:if (document.forms[0].a_image.value!='') {document.imagelib.src='$thumb_link' + $folder/' + document.forms[0].a_folder.value + '/' + document.forms[0].a_image.value} else {document.imagelib.src='../media/com_photomapgallery/gallery/no_thumb.gif'}\"; /><br />";
	
			$imageselect .= "<div class=\"button\"><div class=\"blank\"><a class=\"modal\" title=\"".JText::_('SELECTIMAGE')."\" href=\"$link\" rel=\"{handler: 'iframe', size: {x: 650, y: 425}}\">".JText::_('SELECTIMAGE')."</a></div></div>\n";
	
			$imageselect .= "\n<input type=\"hidden\" id=\"a_image\" name=\"image\" value=\"$category->image\" />";
		}
		//Get the lists
		$lists = $this->_buildEditLists($user->id);

		//Load the JEditor object
		$editor =& JFactory::getEditor();

		//Build the page title string
		$title = $item->id ? JText::_('Edit Category') : JText::_('New Category');

		//Set page title
		$document->setTitle($title);

		//get pathway
		$pathway =& $mainframe->getPathWay();
		$pathway->addItem($title, '');

		//Ensure the row data is safe html
		JFilterOutput::objectHTMLSafe( $item, ENT_QUOTES );

		$this->assign('action', 	$uri->toString());
		$this->assign('gconf', 	$gconf);
		$this->assignRef('item',	$item);
		$this->assignRef('params',	$params);
		$this->assignRef('lists',	$lists);
		$this->assignRef('editor',	$editor);
		$this->assignRef('user',	$user);
		$this->assignRef('category',	$category);
		$this->assignRef('directory',	$directory);
		$this->assignRef('imageselect',	$imageselect);
		$this->assignRef('maincat',	$maincat);
		$this->assignRef('task',	$task);
/*
		echo "<pre>";
		echo "view=";
		print_r($category);
		echo "</pre>";
*/	
		parent::display($tpl);
	}
	
	function _buildEditLists($userid)
	{
		//Get the category from the model
		$row     	= & $this->get( 'Category' );
		
		//get the categories tree
		$categories = photomapgallery_cats::getCategoriesTree(1, $userid);
	
		//build selectlist
		$lists = array();
		$lists['parent_id'] = photomapgallery_cats::buildcatselect($categories, 'parent_id', $row->parent_id, false);
	
		$published = array();
		$published[] = JHTML::_('select.option',  1, JText::_( 'PUBLISHED' ) );
		$published[] = JHTML::_('select.option',  0, JText::_( 'UNPUBLISHED' ) );

		$lists['published'] = JHTML::_('select.genericlist', $published, 'published', '', 'value', 'text', $item->published );
		
		$lists['access'] 	= JHTML::_('list.accesslevel', $row );
		
		$maptype[] = JHTML::_('select.option',  'Map', JText::_( 'Map' ) );
		$maptype[] = JHTML::_('select.option',  'Satellite', JText::_( 'Satellite' ) );
		$maptype[] = JHTML::_('select.option',  'Hybrid', JText::_( 'Hybrid' ) );
		$maptype[] = JHTML::_('select.option',  'Terrain', JText::_( 'Terrain' ) );

		$lists['maptype'] = JHTML::_('select.genericlist',   $maptype, 'maptype', '', 'value', 'text', $row->maptype );
		
		$ajaxmap[] = JHTML::_('select.option',  '1', JText::_( 'YES' ) );
		$ajaxmap[] = JHTML::_('select.option',  '0', JText::_( 'NO' ) );
		$lists['ajaxmap'] = JHTML::_('select.genericlist', $ajaxmap, 'ajaxmap', '', 'value', 'text', $row->ajaxmap );
			
		return $lists;
	}
}
?>